/* PreviewColors.c generated by valac 0.56.18, the Vala compiler
 * generated from PreviewColors.vala, do not modify */

/* PreviewColors.vala
 *
 * Copyright (C) 2022-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include "vala-common.h"
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FONT_MANAGER_PREVIEW_COLORS_0_PROPERTY,
	FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY,
	FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY,
	FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY,
	FONT_MANAGER_PREVIEW_COLORS_NUM_PROPERTIES
};
static GParamSpec* font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	FONT_MANAGER_PREVIEW_COLORS_STYLE_UPDATED_SIGNAL,
	FONT_MANAGER_PREVIEW_COLORS_NUM_SIGNALS
};
static guint font_manager_preview_colors_signals[FONT_MANAGER_PREVIEW_COLORS_NUM_SIGNALS] = {0};

struct _FontManagerPreviewColorsPrivate {
	GdkRGBA _foreground_color;
	GdkRGBA _background_color;
	GSettings* _settings;
	GtkColorDialogButton* bg_color_button;
	GtkColorDialogButton* fg_color_button;
	GtkCssProvider* css_provider;
};

static gint FontManagerPreviewColors_private_offset;
static gpointer font_manager_preview_colors_parent_class = NULL;

static void font_manager_preview_colors_flatten_color_button (FontManagerPreviewColors* self,
                                                       GtkColorDialogButton* button);
static void font_manager_preview_colors_update_default_colors_if_needed (FontManagerPreviewColors* self);
static void __lambda4_ (FontManagerPreviewColors* self,
                 const gchar* key);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void font_manager_preview_colors_real_constructed (GObject* base);
static void __lambda5_ (FontManagerPreviewColors* self);
static void ___lambda5__gtk_widget_map (GtkWidget* _sender,
                                 gpointer self);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void font_manager_preview_colors_finalize (GObject * obj);
static GType font_manager_preview_colors_get_type_once (void);
static void _vala_font_manager_preview_colors_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_font_manager_preview_colors_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
font_manager_preview_colors_get_instance_private (FontManagerPreviewColors* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerPreviewColors_private_offset);
}

void
font_manager_preview_colors_update_style (FontManagerPreviewColors* self)
{
	GtkCssProvider* _tmp0_;
	GdkRGBA _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GdkRGBA _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GdkRGBA _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GdkRGBA _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
#line 37 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->css_provider;
#line 38 "../src/common/PreviewColors.vala"
	_tmp1_ = self->priv->_foreground_color;
#line 38 "../src/common/PreviewColors.vala"
	_tmp2_ = gdk_rgba_to_string (&_tmp1_);
#line 38 "../src/common/PreviewColors.vala"
	_tmp3_ = _tmp2_;
#line 38 "../src/common/PreviewColors.vala"
	_tmp4_ = self->priv->_background_color;
#line 38 "../src/common/PreviewColors.vala"
	_tmp5_ = gdk_rgba_to_string (&_tmp4_);
#line 38 "../src/common/PreviewColors.vala"
	_tmp6_ = _tmp5_;
#line 38 "../src/common/PreviewColors.vala"
	_tmp7_ = self->priv->_background_color;
#line 38 "../src/common/PreviewColors.vala"
	_tmp8_ = gdk_rgba_to_string (&_tmp7_);
#line 38 "../src/common/PreviewColors.vala"
	_tmp9_ = _tmp8_;
#line 38 "../src/common/PreviewColors.vala"
	_tmp10_ = self->priv->_foreground_color;
#line 38 "../src/common/PreviewColors.vala"
	_tmp11_ = gdk_rgba_to_string (&_tmp10_);
#line 38 "../src/common/PreviewColors.vala"
	_tmp12_ = _tmp11_;
#line 38 "../src/common/PreviewColors.vala"
	_tmp13_ = g_strconcat (".FontManagerFontPreviewArea {color: ", _tmp3_, ";background-color: ", _tmp6_, ";} .FontManagerFontPreviewArea text selection {color: ", _tmp9_, ";background-color: ", _tmp12_, ";}", NULL);
#line 38 "../src/common/PreviewColors.vala"
	_tmp14_ = _tmp13_;
#line 38 "../src/common/PreviewColors.vala"
	gtk_css_provider_load_from_string (_tmp0_, _tmp14_);
#line 38 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp14_);
#line 38 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp12_);
#line 38 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp9_);
#line 38 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp6_);
#line 38 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp3_);
#line 39 "../src/common/PreviewColors.vala"
	g_signal_emit (self, font_manager_preview_colors_signals[FONT_MANAGER_PREVIEW_COLORS_STYLE_UPDATED_SIGNAL], 0);
#line 40 "../src/common/PreviewColors.vala"
	return;
#line 168 "PreviewColors.c"
}

static void
font_manager_preview_colors_flatten_color_button (FontManagerPreviewColors* self,
                                                  GtkColorDialogButton* button)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 43 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/common/PreviewColors.vala"
	g_return_if_fail (button != NULL);
#line 44 "../src/common/PreviewColors.vala"
	_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) button);
#line 44 "../src/common/PreviewColors.vala"
	gtk_widget_remove_css_class (_tmp0_, "color");
#line 45 "../src/common/PreviewColors.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) button);
#line 45 "../src/common/PreviewColors.vala"
	gtk_widget_add_css_class (_tmp1_, "flat");
#line 46 "../src/common/PreviewColors.vala"
	return;
#line 191 "PreviewColors.c"
}

static void
font_manager_preview_colors_update_default_colors_if_needed (FontManagerPreviewColors* self)
{
	GSettings* _tmp0_;
	gboolean prefer_dark = FALSE;
	GSettings* _tmp1_;
	GdkRGBA default_light_bg = {0};
	GdkRGBA default_light_fg = {0};
	GdkRGBA default_dark_bg = {0};
	GdkRGBA default_dark_fg = {0};
#line 49 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->_settings;
#line 50 "../src/common/PreviewColors.vala"
	if (_tmp0_ == NULL) {
#line 51 "../src/common/PreviewColors.vala"
		return;
#line 212 "PreviewColors.c"
	}
#line 52 "../src/common/PreviewColors.vala"
	_tmp1_ = self->priv->_settings;
#line 52 "../src/common/PreviewColors.vala"
	prefer_dark = g_settings_get_boolean (_tmp1_, "prefer-dark-theme");
#line 53 "../src/common/PreviewColors.vala"
	memset (&default_light_bg, 0, sizeof (GdkRGBA));
#line 54 "../src/common/PreviewColors.vala"
	memset (&default_light_fg, 0, sizeof (GdkRGBA));
#line 55 "../src/common/PreviewColors.vala"
	memset (&default_dark_bg, 0, sizeof (GdkRGBA));
#line 56 "../src/common/PreviewColors.vala"
	memset (&default_dark_fg, 0, sizeof (GdkRGBA));
#line 57 "../src/common/PreviewColors.vala"
	gdk_rgba_parse (&default_light_bg, "white");
#line 58 "../src/common/PreviewColors.vala"
	gdk_rgba_parse (&default_light_fg, "black");
#line 59 "../src/common/PreviewColors.vala"
	gdk_rgba_parse (&default_dark_bg, "black");
#line 60 "../src/common/PreviewColors.vala"
	gdk_rgba_parse (&default_dark_fg, "white");
#line 61 "../src/common/PreviewColors.vala"
	if (prefer_dark) {
#line 236 "PreviewColors.c"
		gboolean _tmp2_ = FALSE;
		GdkRGBA _tmp3_;
		GdkRGBA _tmp4_;
#line 62 "../src/common/PreviewColors.vala"
		_tmp3_ = self->priv->_foreground_color;
#line 62 "../src/common/PreviewColors.vala"
		_tmp4_ = default_light_fg;
#line 62 "../src/common/PreviewColors.vala"
		if (gdk_rgba_equal (&_tmp3_, &_tmp4_)) {
#line 246 "PreviewColors.c"
			GdkRGBA _tmp5_;
			GdkRGBA _tmp6_;
#line 62 "../src/common/PreviewColors.vala"
			_tmp5_ = self->priv->_background_color;
#line 62 "../src/common/PreviewColors.vala"
			_tmp6_ = default_light_bg;
#line 62 "../src/common/PreviewColors.vala"
			_tmp2_ = gdk_rgba_equal (&_tmp5_, &_tmp6_);
#line 255 "PreviewColors.c"
		} else {
#line 62 "../src/common/PreviewColors.vala"
			_tmp2_ = FALSE;
#line 259 "PreviewColors.c"
		}
#line 62 "../src/common/PreviewColors.vala"
		if (_tmp2_) {
#line 263 "PreviewColors.c"
			GdkRGBA _tmp7_;
			GdkRGBA _tmp8_;
#line 63 "../src/common/PreviewColors.vala"
			_tmp7_ = default_dark_fg;
#line 63 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_set_foreground_color (self, &_tmp7_);
#line 64 "../src/common/PreviewColors.vala"
			_tmp8_ = default_dark_bg;
#line 64 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_set_background_color (self, &_tmp8_);
#line 274 "PreviewColors.c"
		}
	} else {
		gboolean _tmp9_ = FALSE;
		GdkRGBA _tmp10_;
		GdkRGBA _tmp11_;
#line 67 "../src/common/PreviewColors.vala"
		_tmp10_ = self->priv->_foreground_color;
#line 67 "../src/common/PreviewColors.vala"
		_tmp11_ = default_dark_fg;
#line 67 "../src/common/PreviewColors.vala"
		if (gdk_rgba_equal (&_tmp10_, &_tmp11_)) {
#line 286 "PreviewColors.c"
			GdkRGBA _tmp12_;
			GdkRGBA _tmp13_;
#line 67 "../src/common/PreviewColors.vala"
			_tmp12_ = self->priv->_background_color;
#line 67 "../src/common/PreviewColors.vala"
			_tmp13_ = default_dark_bg;
#line 67 "../src/common/PreviewColors.vala"
			_tmp9_ = gdk_rgba_equal (&_tmp12_, &_tmp13_);
#line 295 "PreviewColors.c"
		} else {
#line 67 "../src/common/PreviewColors.vala"
			_tmp9_ = FALSE;
#line 299 "PreviewColors.c"
		}
#line 67 "../src/common/PreviewColors.vala"
		if (_tmp9_) {
#line 303 "PreviewColors.c"
			GdkRGBA _tmp14_;
			GdkRGBA _tmp15_;
#line 68 "../src/common/PreviewColors.vala"
			_tmp14_ = default_light_fg;
#line 68 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_set_foreground_color (self, &_tmp14_);
#line 69 "../src/common/PreviewColors.vala"
			_tmp15_ = default_light_bg;
#line 69 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_set_background_color (self, &_tmp15_);
#line 314 "PreviewColors.c"
		}
	}
#line 72 "../src/common/PreviewColors.vala"
	return;
#line 319 "PreviewColors.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 338 "PreviewColors.c"
}

static void
__lambda4_ (FontManagerPreviewColors* self,
            const gchar* key)
{
#line 94 "../src/common/PreviewColors.vala"
	g_return_if_fail (key != NULL);
#line 95 "../src/common/PreviewColors.vala"
	if (string_contains (key, "color")) {
#line 96 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_update_style (self);
#line 351 "PreviewColors.c"
	}
#line 97 "../src/common/PreviewColors.vala"
	if (string_contains (key, "dark")) {
#line 98 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_update_default_colors_if_needed (self);
#line 99 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_update_style (self);
#line 359 "PreviewColors.c"
	}
}

static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 94 "../src/common/PreviewColors.vala"
	__lambda4_ ((FontManagerPreviewColors*) self, key);
#line 370 "PreviewColors.c"
}

void
font_manager_preview_colors_restore_state (FontManagerPreviewColors* self,
                                           GSettings* settings)
{
	GSettingsBindFlags flags = 0U;
	GtkColorDialogButton* _tmp0_;
	GtkColorDialogButton* _tmp1_;
#line 75 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/common/PreviewColors.vala"
	g_return_if_fail (settings != NULL);
#line 76 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_set_settings (self, settings);
#line 77 "../src/common/PreviewColors.vala"
	if (settings == NULL) {
#line 78 "../src/common/PreviewColors.vala"
		return;
#line 390 "PreviewColors.c"
	}
#line 79 "../src/common/PreviewColors.vala"
	flags = G_SETTINGS_BIND_DEFAULT;
#line 80 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->fg_color_button;
#line 80 "../src/common/PreviewColors.vala"
	g_settings_bind_with_mapping (settings, "preview-foreground-color", (GObject*) _tmp0_, "rgba", flags, (GSettingsBindGetMapping) font_manager_preview_colors_from_setting, (GSettingsBindSetMapping) font_manager_preview_colors_to_setting, NULL, NULL);
#line 87 "../src/common/PreviewColors.vala"
	_tmp1_ = self->priv->bg_color_button;
#line 87 "../src/common/PreviewColors.vala"
	g_settings_bind_with_mapping (settings, "preview-background-color", (GObject*) _tmp1_, "rgba", flags, (GSettingsBindGetMapping) font_manager_preview_colors_from_setting, (GSettingsBindSetMapping) font_manager_preview_colors_to_setting, NULL, NULL);
#line 94 "../src/common/PreviewColors.vala"
	g_signal_connect_object (settings, "changed", (GCallback) ___lambda4__g_settings_changed, self, 0);
#line 102 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_update_default_colors_if_needed (self);
#line 103 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_update_style (self);
#line 104 "../src/common/PreviewColors.vala"
	return;
#line 410 "PreviewColors.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../src/common/PreviewColors.vala"
	return self ? g_object_ref (self) : NULL;
#line 418 "PreviewColors.c"
}

static void
__lambda5_ (FontManagerPreviewColors* self)
{
#line 117 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_update_default_colors_if_needed (self);
#line 118 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_update_style (self);
#line 428 "PreviewColors.c"
}

static void
___lambda5__gtk_widget_map (GtkWidget* _sender,
                            gpointer self)
{
#line 116 "../src/common/PreviewColors.vala"
	__lambda5_ ((FontManagerPreviewColors*) self);
#line 437 "PreviewColors.c"
}

static void
font_manager_preview_colors_real_constructed (GObject* base)
{
	FontManagerPreviewColors * self;
	GtkColorDialogButton* _tmp0_;
	GtkColorDialogButton* _tmp1_;
	GtkCssProvider* _tmp2_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GtkCssProvider* _tmp5_;
	GBindingFlags flags = 0U;
	GtkColorDialogButton* _tmp6_;
	GtkColorDialogButton* _tmp7_;
#line 107 "../src/common/PreviewColors.vala"
	self = (FontManagerPreviewColors*) base;
#line 108 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->bg_color_button;
#line 108 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_flatten_color_button (self, _tmp0_);
#line 109 "../src/common/PreviewColors.vala"
	_tmp1_ = self->priv->fg_color_button;
#line 109 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_flatten_color_button (self, _tmp1_);
#line 110 "../src/common/PreviewColors.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 110 "../src/common/PreviewColors.vala"
	_g_object_unref0 (self->priv->css_provider);
#line 110 "../src/common/PreviewColors.vala"
	self->priv->css_provider = _tmp2_;
#line 111 "../src/common/PreviewColors.vala"
	_tmp3_ = gdk_display_get_default ();
#line 111 "../src/common/PreviewColors.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 111 "../src/common/PreviewColors.vala"
	display = _tmp4_;
#line 112 "../src/common/PreviewColors.vala"
	_tmp5_ = self->priv->css_provider;
#line 112 "../src/common/PreviewColors.vala"
	gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) _tmp5_, (guint) GTK_STYLE_PROVIDER_PRIORITY_USER);
#line 113 "../src/common/PreviewColors.vala"
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 114 "../src/common/PreviewColors.vala"
	_tmp6_ = self->priv->bg_color_button;
#line 114 "../src/common/PreviewColors.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp6_, "rgba", (GObject*) self, "background-color", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 115 "../src/common/PreviewColors.vala"
	_tmp7_ = self->priv->fg_color_button;
#line 115 "../src/common/PreviewColors.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp7_, "rgba", (GObject*) self, "foreground-color", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 116 "../src/common/PreviewColors.vala"
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) ___lambda5__gtk_widget_map, self, 0);
#line 120 "../src/common/PreviewColors.vala"
	G_OBJECT_CLASS (font_manager_preview_colors_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox));
#line 121 "../src/common/PreviewColors.vala"
	_g_object_unref0 (display);
#line 121 "../src/common/PreviewColors.vala"
	return;
#line 498 "PreviewColors.c"
}

GVariant*
font_manager_preview_colors_to_setting (GValue* val,
                                        const GVariantType* type)
{
	GValue _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA _tmp2_ = {0};
	GdkRGBA _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* result;
#line 126 "../src/common/PreviewColors.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 126 "../src/common/PreviewColors.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 127 "../src/common/PreviewColors.vala"
	_tmp0_ = *val;
#line 127 "../src/common/PreviewColors.vala"
	_tmp1_ = g_value_get_boxed (&_tmp0_);
#line 127 "../src/common/PreviewColors.vala"
	_tmp3_ = (G_VALUE_HOLDS (&_tmp0_, gdk_rgba_get_type ()) && _tmp1_) ? (*_tmp1_) : (g_warning ("Invalid GValue unboxing (wrong type or NULL)"), _tmp2_);
#line 127 "../src/common/PreviewColors.vala"
	_tmp4_ = gdk_rgba_to_string (&_tmp3_);
#line 127 "../src/common/PreviewColors.vala"
	_tmp5_ = _tmp4_;
#line 127 "../src/common/PreviewColors.vala"
	_tmp6_ = g_variant_new_string (_tmp5_);
#line 127 "../src/common/PreviewColors.vala"
	g_variant_ref_sink (_tmp6_);
#line 127 "../src/common/PreviewColors.vala"
	_tmp7_ = _tmp6_;
#line 127 "../src/common/PreviewColors.vala"
	_g_free0 (_tmp5_);
#line 127 "../src/common/PreviewColors.vala"
	result = _tmp7_;
#line 127 "../src/common/PreviewColors.vala"
	return result;
#line 540 "PreviewColors.c"
}

gboolean
font_manager_preview_colors_from_setting (GValue* val,
                                          GVariant* variant)
{
	GdkRGBA rgba = {0};
	gchar* rgba_string = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _result_ = FALSE;
	gboolean result;
#line 130 "../src/common/PreviewColors.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 130 "../src/common/PreviewColors.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 131 "../src/common/PreviewColors.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 132 "../src/common/PreviewColors.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 132 "../src/common/PreviewColors.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 132 "../src/common/PreviewColors.vala"
	rgba_string = _tmp1_;
#line 133 "../src/common/PreviewColors.vala"
	_result_ = gdk_rgba_parse (&rgba, rgba_string);
#line 134 "../src/common/PreviewColors.vala"
	g_value_set_boxed (val, &rgba);
#line 135 "../src/common/PreviewColors.vala"
	result = _result_;
#line 135 "../src/common/PreviewColors.vala"
	_g_free0 (rgba_string);
#line 135 "../src/common/PreviewColors.vala"
	return result;
#line 575 "PreviewColors.c"
}

FontManagerPreviewColors*
font_manager_preview_colors_construct (GType object_type)
{
	FontManagerPreviewColors * self = NULL;
#line 24 "../src/common/PreviewColors.vala"
	self = (FontManagerPreviewColors*) g_object_new (object_type, NULL);
#line 24 "../src/common/PreviewColors.vala"
	return self;
#line 586 "PreviewColors.c"
}

FontManagerPreviewColors*
font_manager_preview_colors_new (void)
{
#line 24 "../src/common/PreviewColors.vala"
	return font_manager_preview_colors_construct (FONT_MANAGER_TYPE_PREVIEW_COLORS);
#line 594 "PreviewColors.c"
}

void
font_manager_preview_colors_get_foreground_color (FontManagerPreviewColors* self,
                                                  GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 28 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->_foreground_color;
#line 28 "../src/common/PreviewColors.vala"
	*result = _tmp0_;
#line 28 "../src/common/PreviewColors.vala"
	return;
#line 610 "PreviewColors.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 28 "../src/common/PreviewColors.vala"
	if (s1 == s2) {
#line 28 "../src/common/PreviewColors.vala"
		return TRUE;
#line 621 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s1 == NULL) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 627 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s2 == NULL) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 633 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s1->red != s2->red) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 639 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s1->green != s2->green) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 645 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s1->blue != s2->blue) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 651 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	if (s1->alpha != s2->alpha) {
#line 28 "../src/common/PreviewColors.vala"
		return FALSE;
#line 657 "PreviewColors.c"
	}
#line 28 "../src/common/PreviewColors.vala"
	return TRUE;
#line 661 "PreviewColors.c"
}

void
font_manager_preview_colors_set_foreground_color (FontManagerPreviewColors* self,
                                                  GdkRGBA * value)
{
	GdkRGBA old_value;
#line 28 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_get_foreground_color (self, &old_value);
#line 28 "../src/common/PreviewColors.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 675 "PreviewColors.c"
		GdkRGBA _tmp0_;
#line 28 "../src/common/PreviewColors.vala"
		_tmp0_ = *value;
#line 28 "../src/common/PreviewColors.vala"
		self->priv->_foreground_color = _tmp0_;
#line 28 "../src/common/PreviewColors.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY]);
#line 683 "PreviewColors.c"
	}
}

void
font_manager_preview_colors_get_background_color (FontManagerPreviewColors* self,
                                                  GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 29 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->_background_color;
#line 29 "../src/common/PreviewColors.vala"
	*result = _tmp0_;
#line 29 "../src/common/PreviewColors.vala"
	return;
#line 700 "PreviewColors.c"
}

void
font_manager_preview_colors_set_background_color (FontManagerPreviewColors* self,
                                                  GdkRGBA * value)
{
	GdkRGBA old_value;
#line 29 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_get_background_color (self, &old_value);
#line 29 "../src/common/PreviewColors.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 714 "PreviewColors.c"
		GdkRGBA _tmp0_;
#line 29 "../src/common/PreviewColors.vala"
		_tmp0_ = *value;
#line 29 "../src/common/PreviewColors.vala"
		self->priv->_background_color = _tmp0_;
#line 29 "../src/common/PreviewColors.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY]);
#line 722 "PreviewColors.c"
	}
}

GSettings*
font_manager_preview_colors_get_settings (FontManagerPreviewColors* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 30 "../src/common/PreviewColors.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/common/PreviewColors.vala"
	_tmp0_ = self->priv->_settings;
#line 30 "../src/common/PreviewColors.vala"
	result = _tmp0_;
#line 30 "../src/common/PreviewColors.vala"
	return result;
#line 739 "PreviewColors.c"
}

void
font_manager_preview_colors_set_settings (FontManagerPreviewColors* self,
                                          GSettings* value)
{
	GSettings* old_value;
#line 30 "../src/common/PreviewColors.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/common/PreviewColors.vala"
	old_value = font_manager_preview_colors_get_settings (self);
#line 30 "../src/common/PreviewColors.vala"
	if (old_value != value) {
#line 753 "PreviewColors.c"
		GSettings* _tmp0_;
#line 30 "../src/common/PreviewColors.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/common/PreviewColors.vala"
		_g_object_unref0 (self->priv->_settings);
#line 30 "../src/common/PreviewColors.vala"
		self->priv->_settings = _tmp0_;
#line 30 "../src/common/PreviewColors.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY]);
#line 763 "PreviewColors.c"
	}
}

static void
font_manager_preview_colors_class_init (FontManagerPreviewColorsClass * klass,
                                        gpointer klass_data)
{
#line 24 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/common/PreviewColors.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerPreviewColors_private_offset);
#line 24 "../src/common/PreviewColors.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) font_manager_preview_colors_real_constructed;
#line 24 "../src/common/PreviewColors.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_preview_colors_get_property;
#line 24 "../src/common/PreviewColors.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_preview_colors_set_property;
#line 24 "../src/common/PreviewColors.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_preview_colors_finalize;
#line 24 "../src/common/PreviewColors.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY] = g_param_spec_boxed ("foreground-color", "foreground-color", "foreground-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/common/PreviewColors.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY] = g_param_spec_boxed ("background-color", "background-color", "background-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/common/PreviewColors.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY, font_manager_preview_colors_properties[FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/common/PreviewColors.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/FontManager/FontManager/ui/font-manager-preview-colors.ui");
#line 24 "../src/common/PreviewColors.vala"
	font_manager_preview_colors_signals[FONT_MANAGER_PREVIEW_COLORS_STYLE_UPDATED_SIGNAL] = g_signal_new ("style-updated", FONT_MANAGER_TYPE_PREVIEW_COLORS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../src/common/PreviewColors.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bg_color_button", FALSE, FontManagerPreviewColors_private_offset + G_STRUCT_OFFSET (FontManagerPreviewColorsPrivate, bg_color_button));
#line 24 "../src/common/PreviewColors.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fg_color_button", FALSE, FontManagerPreviewColors_private_offset + G_STRUCT_OFFSET (FontManagerPreviewColorsPrivate, fg_color_button));
#line 797 "PreviewColors.c"
}

static void
font_manager_preview_colors_instance_init (FontManagerPreviewColors * self,
                                           gpointer klass)
{
#line 24 "../src/common/PreviewColors.vala"
	self->priv = font_manager_preview_colors_get_instance_private (self);
#line 24 "../src/common/PreviewColors.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 808 "PreviewColors.c"
}

static void
font_manager_preview_colors_finalize (GObject * obj)
{
	FontManagerPreviewColors * self;
#line 24 "../src/common/PreviewColors.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColors);
#line 30 "../src/common/PreviewColors.vala"
	_g_object_unref0 (self->priv->_settings);
#line 35 "../src/common/PreviewColors.vala"
	_g_object_unref0 (self->priv->css_provider);
#line 24 "../src/common/PreviewColors.vala"
	G_OBJECT_CLASS (font_manager_preview_colors_parent_class)->finalize (obj);
#line 823 "PreviewColors.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_preview_colors_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerPreviewColorsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_preview_colors_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerPreviewColors), 0, (GInstanceInitFunc) font_manager_preview_colors_instance_init, NULL };
	GType font_manager_preview_colors_type_id;
	font_manager_preview_colors_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerPreviewColors", &g_define_type_info, 0);
	FontManagerPreviewColors_private_offset = g_type_add_instance_private (font_manager_preview_colors_type_id, sizeof (FontManagerPreviewColorsPrivate));
	return font_manager_preview_colors_type_id;
}

GType
font_manager_preview_colors_get_type (void)
{
	static volatile gsize font_manager_preview_colors_type_id__once = 0;
	if (g_once_init_enter (&font_manager_preview_colors_type_id__once)) {
		GType font_manager_preview_colors_type_id;
		font_manager_preview_colors_type_id = font_manager_preview_colors_get_type_once ();
		g_once_init_leave (&font_manager_preview_colors_type_id__once, font_manager_preview_colors_type_id);
	}
	return font_manager_preview_colors_type_id__once;
}

static void
_vala_font_manager_preview_colors_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerPreviewColors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColors);
#line 24 "../src/common/PreviewColors.vala"
	switch (property_id) {
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY:
#line 860 "PreviewColors.c"
		{
			GdkRGBA boxed;
#line 24 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_get_foreground_color (self, &boxed);
#line 24 "../src/common/PreviewColors.vala"
			g_value_set_boxed (value, &boxed);
#line 867 "PreviewColors.c"
		}
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY:
#line 873 "PreviewColors.c"
		{
			GdkRGBA boxed;
#line 24 "../src/common/PreviewColors.vala"
			font_manager_preview_colors_get_background_color (self, &boxed);
#line 24 "../src/common/PreviewColors.vala"
			g_value_set_boxed (value, &boxed);
#line 880 "PreviewColors.c"
		}
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY:
#line 24 "../src/common/PreviewColors.vala"
		g_value_set_object (value, font_manager_preview_colors_get_settings (self));
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 890 "PreviewColors.c"
		default:
#line 24 "../src/common/PreviewColors.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 896 "PreviewColors.c"
	}
}

static void
_vala_font_manager_preview_colors_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerPreviewColors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColors);
#line 24 "../src/common/PreviewColors.vala"
	switch (property_id) {
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_FOREGROUND_COLOR_PROPERTY:
#line 24 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_set_foreground_color (self, g_value_get_boxed (value));
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_BACKGROUND_COLOR_PROPERTY:
#line 24 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_set_background_color (self, g_value_get_boxed (value));
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 24 "../src/common/PreviewColors.vala"
		case FONT_MANAGER_PREVIEW_COLORS_SETTINGS_PROPERTY:
#line 24 "../src/common/PreviewColors.vala"
		font_manager_preview_colors_set_settings (self, g_value_get_object (value));
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 928 "PreviewColors.c"
		default:
#line 24 "../src/common/PreviewColors.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/common/PreviewColors.vala"
		break;
#line 934 "PreviewColors.c"
	}
}

