/* WaterfallSettings.c generated by valac 0.56.18, the Vala compiler
 * generated from WaterfallSettings.vala, do not modify */

/* WaterfallSettings.vala
 *
 * Copyright (C) 2022-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include "vala-common.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include "font-manager.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FONT_MANAGER_WATERFALL_SETTINGS_0_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_CONTEXT_MENU_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_PREFERENCE_ROW_PROPERTY,
	FONT_MANAGER_WATERFALL_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _FontManagerWaterfallSettingsPrivate {
	GSettings* _settings;
	gint _predefined_size;
	gdouble _minimum;
	gdouble _maximum;
	gdouble _ratio;
	gboolean _show_line_size;
	gint _line_spacing;
	GtkSpinButton* min;
	GtkSpinButton* max;
	GtkSpinButton* rat;
	GtkDropDown* selection;
	GtkPopoverMenu* menu;
	FontManagerPreferenceRow* row;
};

static gint FontManagerWaterfallSettings_private_offset;
static gpointer font_manager_waterfall_settings_parent_class = NULL;

static void font_manager_waterfall_settings_bind_settings (FontManagerWaterfallSettings* self);
static void font_manager_waterfall_settings_create_preference_row (FontManagerWaterfallSettings* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
static void __lambda6_ (FontManagerWaterfallSettings* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (FontManagerWaterfallSettings* self);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GMenuModel* font_manager_waterfall_settings_get_context_menu_model (FontManagerWaterfallSettings* self);
static void font_manager_waterfall_settings_finalize (GObject * obj);
static GType font_manager_waterfall_settings_get_type_once (void);
static void _vala_font_manager_waterfall_settings_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_font_manager_waterfall_settings_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

gchar*
font_manager_predefined_waterfall_size_to_string (FontManagerPredefinedWaterfallSize self)
{
	gchar* result;
#line 35 "../src/common/WaterfallSettings.vala"
	switch (self) {
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_48:
#line 115 "WaterfallSettings.c"
		{
			gchar* _tmp0_;
#line 37 "../src/common/WaterfallSettings.vala"
			_tmp0_ = g_strdup (_ ("Up to 48 points (Linear Scaling)"));
#line 37 "../src/common/WaterfallSettings.vala"
			result = _tmp0_;
#line 37 "../src/common/WaterfallSettings.vala"
			return result;
#line 124 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_72_11:
#line 128 "WaterfallSettings.c"
		{
			gchar* _tmp1_;
#line 39 "../src/common/WaterfallSettings.vala"
			_tmp1_ = g_strdup (_ ("Up to 72 points (1.1 Common Ratio)"));
#line 39 "../src/common/WaterfallSettings.vala"
			result = _tmp1_;
#line 39 "../src/common/WaterfallSettings.vala"
			return result;
#line 137 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_96:
#line 141 "WaterfallSettings.c"
		{
			gchar* _tmp2_;
#line 41 "../src/common/WaterfallSettings.vala"
			_tmp2_ = g_strdup (_ ("Up to 96 points (Linear Scaling)"));
#line 41 "../src/common/WaterfallSettings.vala"
			result = _tmp2_;
#line 41 "../src/common/WaterfallSettings.vala"
			return result;
#line 150 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_96_11:
#line 154 "WaterfallSettings.c"
		{
			gchar* _tmp3_;
#line 43 "../src/common/WaterfallSettings.vala"
			_tmp3_ = g_strdup (_ ("Up to 96 points (1.1 Common Ratio)"));
#line 43 "../src/common/WaterfallSettings.vala"
			result = _tmp3_;
#line 43 "../src/common/WaterfallSettings.vala"
			return result;
#line 163 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_120_12:
#line 167 "WaterfallSettings.c"
		{
			gchar* _tmp4_;
#line 45 "../src/common/WaterfallSettings.vala"
			_tmp4_ = g_strdup (_ ("Up to 120 points (1.2 Common Ratio)"));
#line 45 "../src/common/WaterfallSettings.vala"
			result = _tmp4_;
#line 45 "../src/common/WaterfallSettings.vala"
			return result;
#line 176 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_144_13:
#line 180 "WaterfallSettings.c"
		{
			gchar* _tmp5_;
#line 47 "../src/common/WaterfallSettings.vala"
			_tmp5_ = g_strdup (_ ("Up to 144 points (1.3 Common Ratio)"));
#line 47 "../src/common/WaterfallSettings.vala"
			result = _tmp5_;
#line 47 "../src/common/WaterfallSettings.vala"
			return result;
#line 189 "WaterfallSettings.c"
		}
#line 35 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_192_14:
#line 193 "WaterfallSettings.c"
		{
			gchar* _tmp6_;
#line 49 "../src/common/WaterfallSettings.vala"
			_tmp6_ = g_strdup (_ ("Up to 192 points (1.4 Common Ratio)"));
#line 49 "../src/common/WaterfallSettings.vala"
			result = _tmp6_;
#line 49 "../src/common/WaterfallSettings.vala"
			return result;
#line 202 "WaterfallSettings.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 51 "../src/common/WaterfallSettings.vala"
			_tmp7_ = g_strdup (_ ("Custom Size Settings"));
#line 51 "../src/common/WaterfallSettings.vala"
			result = _tmp7_;
#line 51 "../src/common/WaterfallSettings.vala"
			return result;
#line 213 "WaterfallSettings.c"
		}
	}
}

gdouble*
font_manager_predefined_waterfall_size_to_size_array (FontManagerPredefinedWaterfallSize self,
                                                      gint* result_length1)
{
	gdouble* result;
#line 56 "../src/common/WaterfallSettings.vala"
	switch (self) {
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_48:
#line 227 "WaterfallSettings.c"
		{
			gdouble* _tmp0_;
			gdouble* _tmp1_;
			gint _tmp1__length1;
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp0_ = g_new0 (gdouble, 3);
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp0_[0] = 8.0;
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp0_[1] = 48.0;
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp0_[2] = 1.0;
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp1_ = _tmp0_;
#line 58 "../src/common/WaterfallSettings.vala"
			_tmp1__length1 = 3;
#line 58 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 58 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp1__length1;
#line 248 "WaterfallSettings.c"
			}
#line 58 "../src/common/WaterfallSettings.vala"
			result = _tmp1_;
#line 58 "../src/common/WaterfallSettings.vala"
			return result;
#line 254 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_72_11:
#line 258 "WaterfallSettings.c"
		{
			gdouble* _tmp2_;
			gdouble* _tmp3_;
			gint _tmp3__length1;
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp2_ = g_new0 (gdouble, 3);
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp2_[0] = 8.0;
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp2_[1] = 72.0;
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp2_[2] = 1.1;
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp3_ = _tmp2_;
#line 60 "../src/common/WaterfallSettings.vala"
			_tmp3__length1 = 3;
#line 60 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 60 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp3__length1;
#line 279 "WaterfallSettings.c"
			}
#line 60 "../src/common/WaterfallSettings.vala"
			result = _tmp3_;
#line 60 "../src/common/WaterfallSettings.vala"
			return result;
#line 285 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_96:
#line 289 "WaterfallSettings.c"
		{
			gdouble* _tmp4_;
			gdouble* _tmp5_;
			gint _tmp5__length1;
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp4_ = g_new0 (gdouble, 3);
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp4_[0] = 8.0;
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp4_[1] = 96.0;
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp4_[2] = 1.0;
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp5_ = _tmp4_;
#line 62 "../src/common/WaterfallSettings.vala"
			_tmp5__length1 = 3;
#line 62 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 62 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp5__length1;
#line 310 "WaterfallSettings.c"
			}
#line 62 "../src/common/WaterfallSettings.vala"
			result = _tmp5_;
#line 62 "../src/common/WaterfallSettings.vala"
			return result;
#line 316 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_96_11:
#line 320 "WaterfallSettings.c"
		{
			gdouble* _tmp6_;
			gdouble* _tmp7_;
			gint _tmp7__length1;
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp6_ = g_new0 (gdouble, 3);
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp6_[0] = 8.0;
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp6_[1] = 96.0;
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp6_[2] = 1.1;
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp7_ = _tmp6_;
#line 64 "../src/common/WaterfallSettings.vala"
			_tmp7__length1 = 3;
#line 64 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 64 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp7__length1;
#line 341 "WaterfallSettings.c"
			}
#line 64 "../src/common/WaterfallSettings.vala"
			result = _tmp7_;
#line 64 "../src/common/WaterfallSettings.vala"
			return result;
#line 347 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_120_12:
#line 351 "WaterfallSettings.c"
		{
			gdouble* _tmp8_;
			gdouble* _tmp9_;
			gint _tmp9__length1;
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp8_ = g_new0 (gdouble, 3);
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp8_[0] = 8.0;
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp8_[1] = 120.0;
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp8_[2] = 1.2;
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp9_ = _tmp8_;
#line 66 "../src/common/WaterfallSettings.vala"
			_tmp9__length1 = 3;
#line 66 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 66 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp9__length1;
#line 372 "WaterfallSettings.c"
			}
#line 66 "../src/common/WaterfallSettings.vala"
			result = _tmp9_;
#line 66 "../src/common/WaterfallSettings.vala"
			return result;
#line 378 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_144_13:
#line 382 "WaterfallSettings.c"
		{
			gdouble* _tmp10_;
			gdouble* _tmp11_;
			gint _tmp11__length1;
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp10_ = g_new0 (gdouble, 3);
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp10_[0] = 8.0;
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp10_[1] = 144.0;
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp10_[2] = 1.3;
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp11_ = _tmp10_;
#line 68 "../src/common/WaterfallSettings.vala"
			_tmp11__length1 = 3;
#line 68 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 68 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp11__length1;
#line 403 "WaterfallSettings.c"
			}
#line 68 "../src/common/WaterfallSettings.vala"
			result = _tmp11_;
#line 68 "../src/common/WaterfallSettings.vala"
			return result;
#line 409 "WaterfallSettings.c"
		}
#line 56 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_192_14:
#line 413 "WaterfallSettings.c"
		{
			gdouble* _tmp12_;
			gdouble* _tmp13_;
			gint _tmp13__length1;
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp12_ = g_new0 (gdouble, 3);
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp12_[0] = 8.0;
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp12_[1] = 192.0;
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp12_[2] = 1.4;
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp13_ = _tmp12_;
#line 70 "../src/common/WaterfallSettings.vala"
			_tmp13__length1 = 3;
#line 70 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 70 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp13__length1;
#line 434 "WaterfallSettings.c"
			}
#line 70 "../src/common/WaterfallSettings.vala"
			result = _tmp13_;
#line 70 "../src/common/WaterfallSettings.vala"
			return result;
#line 440 "WaterfallSettings.c"
		}
		default:
		{
			gdouble* _tmp14_;
			gdouble* _tmp15_;
			gint _tmp15__length1;
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp14_ = g_new0 (gdouble, 3);
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp14_[0] = 0.0;
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp14_[1] = 0.0;
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp14_[2] = 0.0;
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp15_ = _tmp14_;
#line 72 "../src/common/WaterfallSettings.vala"
			_tmp15__length1 = 3;
#line 72 "../src/common/WaterfallSettings.vala"
			if (result_length1) {
#line 72 "../src/common/WaterfallSettings.vala"
				*result_length1 = _tmp15__length1;
#line 463 "WaterfallSettings.c"
			}
#line 72 "../src/common/WaterfallSettings.vala"
			result = _tmp15_;
#line 72 "../src/common/WaterfallSettings.vala"
			return result;
#line 469 "WaterfallSettings.c"
		}
	}
}

GVariant*
font_manager_predefined_waterfall_size_to_setting (GValue* val,
                                                   const GVariantType* type)
{
	GVariant* result;
#line 78 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 78 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 79 "../src/common/WaterfallSettings.vala"
	switch (g_value_get_int (val)) {
#line 79 "../src/common/WaterfallSettings.vala"
		case 0:
#line 487 "WaterfallSettings.c"
		{
			GVariant* _tmp0_;
#line 81 "../src/common/WaterfallSettings.vala"
			_tmp0_ = g_variant_new_string ("48 Points Linear");
#line 81 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp0_);
#line 81 "../src/common/WaterfallSettings.vala"
			result = _tmp0_;
#line 81 "../src/common/WaterfallSettings.vala"
			return result;
#line 498 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 1:
#line 502 "WaterfallSettings.c"
		{
			GVariant* _tmp1_;
#line 83 "../src/common/WaterfallSettings.vala"
			_tmp1_ = g_variant_new_string ("72 Points 1.1 Ratio");
#line 83 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp1_);
#line 83 "../src/common/WaterfallSettings.vala"
			result = _tmp1_;
#line 83 "../src/common/WaterfallSettings.vala"
			return result;
#line 513 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 2:
#line 517 "WaterfallSettings.c"
		{
			GVariant* _tmp2_;
#line 85 "../src/common/WaterfallSettings.vala"
			_tmp2_ = g_variant_new_string ("96 Points Linear");
#line 85 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp2_);
#line 85 "../src/common/WaterfallSettings.vala"
			result = _tmp2_;
#line 85 "../src/common/WaterfallSettings.vala"
			return result;
#line 528 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 3:
#line 532 "WaterfallSettings.c"
		{
			GVariant* _tmp3_;
#line 87 "../src/common/WaterfallSettings.vala"
			_tmp3_ = g_variant_new_string ("96 Points 1.1 Ratio");
#line 87 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp3_);
#line 87 "../src/common/WaterfallSettings.vala"
			result = _tmp3_;
#line 87 "../src/common/WaterfallSettings.vala"
			return result;
#line 543 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 4:
#line 547 "WaterfallSettings.c"
		{
			GVariant* _tmp4_;
#line 89 "../src/common/WaterfallSettings.vala"
			_tmp4_ = g_variant_new_string ("120 Points 1.2 Ratio");
#line 89 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp4_);
#line 89 "../src/common/WaterfallSettings.vala"
			result = _tmp4_;
#line 89 "../src/common/WaterfallSettings.vala"
			return result;
#line 558 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 5:
#line 562 "WaterfallSettings.c"
		{
			GVariant* _tmp5_;
#line 91 "../src/common/WaterfallSettings.vala"
			_tmp5_ = g_variant_new_string ("144 Points 1.3 Ratio");
#line 91 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp5_);
#line 91 "../src/common/WaterfallSettings.vala"
			result = _tmp5_;
#line 91 "../src/common/WaterfallSettings.vala"
			return result;
#line 573 "WaterfallSettings.c"
		}
#line 79 "../src/common/WaterfallSettings.vala"
		case 6:
#line 577 "WaterfallSettings.c"
		{
			GVariant* _tmp6_;
#line 93 "../src/common/WaterfallSettings.vala"
			_tmp6_ = g_variant_new_string ("192 Points 1.4 Ratio");
#line 93 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp6_);
#line 93 "../src/common/WaterfallSettings.vala"
			result = _tmp6_;
#line 93 "../src/common/WaterfallSettings.vala"
			return result;
#line 588 "WaterfallSettings.c"
		}
		default:
		{
			GVariant* _tmp7_;
#line 95 "../src/common/WaterfallSettings.vala"
			_tmp7_ = g_variant_new_string ("Custom");
#line 95 "../src/common/WaterfallSettings.vala"
			g_variant_ref_sink (_tmp7_);
#line 95 "../src/common/WaterfallSettings.vala"
			result = _tmp7_;
#line 95 "../src/common/WaterfallSettings.vala"
			return result;
#line 601 "WaterfallSettings.c"
		}
	}
}

gboolean
font_manager_predefined_waterfall_size_from_setting (GValue* val,
                                                     GVariant* variant)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label0 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label1 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label2 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label3 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label4 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label5 = 0;
#line 100 "../src/common/WaterfallSettings.vala"
	static GQuark _tmp2_label6 = 0;
#line 627 "WaterfallSettings.c"
	gboolean result;
#line 99 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 99 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 100 "../src/common/WaterfallSettings.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 100 "../src/common/WaterfallSettings.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/common/WaterfallSettings.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 100 "../src/common/WaterfallSettings.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("48 Points Linear")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 643 "WaterfallSettings.c"
			default:
			{
#line 102 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 0);
#line 103 "../src/common/WaterfallSettings.vala"
				break;
#line 650 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("72 Points 1.1 Ratio")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 656 "WaterfallSettings.c"
			default:
			{
#line 105 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 1);
#line 106 "../src/common/WaterfallSettings.vala"
				break;
#line 663 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("96 Points Linear")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 669 "WaterfallSettings.c"
			default:
			{
#line 108 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 2);
#line 109 "../src/common/WaterfallSettings.vala"
				break;
#line 676 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("96 Points 1.1 Ratio")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 682 "WaterfallSettings.c"
			default:
			{
#line 111 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 3);
#line 112 "../src/common/WaterfallSettings.vala"
				break;
#line 689 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("120 Points 1.2 Ratio")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 695 "WaterfallSettings.c"
			default:
			{
#line 114 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 4);
#line 115 "../src/common/WaterfallSettings.vala"
				break;
#line 702 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("144 Points 1.3 Ratio")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 708 "WaterfallSettings.c"
			default:
			{
#line 117 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 5);
#line 118 "../src/common/WaterfallSettings.vala"
				break;
#line 715 "WaterfallSettings.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("192 Points 1.4 Ratio")))) {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 721 "WaterfallSettings.c"
			default:
			{
#line 120 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 6);
#line 121 "../src/common/WaterfallSettings.vala"
				break;
#line 728 "WaterfallSettings.c"
			}
		}
	} else {
#line 100 "../src/common/WaterfallSettings.vala"
		switch (0) {
#line 734 "WaterfallSettings.c"
			default:
			{
#line 123 "../src/common/WaterfallSettings.vala"
				g_value_set_int (val, 7);
#line 124 "../src/common/WaterfallSettings.vala"
				break;
#line 741 "WaterfallSettings.c"
			}
		}
	}
#line 126 "../src/common/WaterfallSettings.vala"
	result = TRUE;
#line 126 "../src/common/WaterfallSettings.vala"
	return result;
#line 749 "WaterfallSettings.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_predefined_waterfall_size_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_48, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_48", "linear-48"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_72_11, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_72_11", "72-11"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_96, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_LINEAR_96", "linear-96"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_96_11, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_96_11", "96-11"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_120_12, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_120_12", "120-12"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_144_13, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_144_13", "144-13"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_192_14, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_192_14", "192-14"}, {FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM, "FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType font_manager_predefined_waterfall_size_type_id;
	font_manager_predefined_waterfall_size_type_id = g_enum_register_static ("FontManagerPredefinedWaterfallSize", values);
	return font_manager_predefined_waterfall_size_type_id;
}

GType
font_manager_predefined_waterfall_size_get_type (void)
{
	static volatile gsize font_manager_predefined_waterfall_size_type_id__once = 0;
	if (g_once_init_enter (&font_manager_predefined_waterfall_size_type_id__once)) {
		GType font_manager_predefined_waterfall_size_type_id;
		font_manager_predefined_waterfall_size_type_id = font_manager_predefined_waterfall_size_get_type_once ();
		g_once_init_leave (&font_manager_predefined_waterfall_size_type_id__once, font_manager_predefined_waterfall_size_type_id);
	}
	return font_manager_predefined_waterfall_size_type_id__once;
}

static inline gpointer
font_manager_waterfall_settings_get_instance_private (FontManagerWaterfallSettings* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerWaterfallSettings_private_offset);
}

FontManagerWaterfallSettings*
font_manager_waterfall_settings_construct (GType object_type,
                                           GSettings* settings)
{
	FontManagerWaterfallSettings * self = NULL;
#line 166 "../src/common/WaterfallSettings.vala"
	self = (FontManagerWaterfallSettings*) g_object_new (object_type, NULL);
#line 167 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_set_settings (self, settings);
#line 168 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_bind_settings (self);
#line 166 "../src/common/WaterfallSettings.vala"
	return self;
#line 792 "WaterfallSettings.c"
}

FontManagerWaterfallSettings*
font_manager_waterfall_settings_new (GSettings* settings)
{
#line 166 "../src/common/WaterfallSettings.vala"
	return font_manager_waterfall_settings_construct (FONT_MANAGER_TYPE_WATERFALL_SETTINGS, settings);
#line 800 "WaterfallSettings.c"
}

static void
font_manager_waterfall_settings_bind_settings (FontManagerWaterfallSettings* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp3_;
	GSettingsBindFlags flags = 0U;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
#line 171 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->_settings;
#line 172 "../src/common/WaterfallSettings.vala"
	if (_tmp0_ == NULL) {
#line 821 "WaterfallSettings.c"
		GSettings* _tmp1_;
		GSettings* _tmp2_;
#line 173 "../src/common/WaterfallSettings.vala"
		_tmp1_ = font_manager_get_gsettings (FONT_MANAGER_BUS_ID);
#line 173 "../src/common/WaterfallSettings.vala"
		_tmp2_ = _tmp1_;
#line 173 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_settings (self, _tmp2_);
#line 173 "../src/common/WaterfallSettings.vala"
		_g_object_unref0 (_tmp2_);
#line 832 "WaterfallSettings.c"
	}
#line 174 "../src/common/WaterfallSettings.vala"
	_tmp3_ = self->priv->_settings;
#line 174 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (_tmp3_ != NULL);
#line 175 "../src/common/WaterfallSettings.vala"
	flags = G_SETTINGS_BIND_DEFAULT;
#line 176 "../src/common/WaterfallSettings.vala"
	_tmp4_ = self->priv->_settings;
#line 176 "../src/common/WaterfallSettings.vala"
	g_settings_bind (_tmp4_, "waterfall-show-line-size", (GObject*) self, "show-line-size", flags);
#line 177 "../src/common/WaterfallSettings.vala"
	_tmp5_ = self->priv->_settings;
#line 177 "../src/common/WaterfallSettings.vala"
	g_settings_bind (_tmp5_, "min-waterfall-size", (GObject*) self, "minimum", flags);
#line 178 "../src/common/WaterfallSettings.vala"
	_tmp6_ = self->priv->_settings;
#line 178 "../src/common/WaterfallSettings.vala"
	g_settings_bind (_tmp6_, "max-waterfall-size", (GObject*) self, "maximum", flags);
#line 179 "../src/common/WaterfallSettings.vala"
	_tmp7_ = self->priv->_settings;
#line 179 "../src/common/WaterfallSettings.vala"
	g_settings_bind (_tmp7_, "waterfall-size-ratio", (GObject*) self, "ratio", flags);
#line 180 "../src/common/WaterfallSettings.vala"
	_tmp8_ = self->priv->_settings;
#line 180 "../src/common/WaterfallSettings.vala"
	g_settings_bind (_tmp8_, "waterfall-line-spacing", (GObject*) self, "line-spacing", flags);
#line 181 "../src/common/WaterfallSettings.vala"
	_tmp9_ = self->priv->_settings;
#line 181 "../src/common/WaterfallSettings.vala"
	g_settings_bind_with_mapping (_tmp9_, "predefined-waterfall-size", (GObject*) self, "predefined-size", flags, (GSettingsBindGetMapping) font_manager_predefined_waterfall_size_from_setting, (GSettingsBindSetMapping) font_manager_predefined_waterfall_size_to_setting, NULL, NULL);
#line 188 "../src/common/WaterfallSettings.vala"
	return;
#line 866 "WaterfallSettings.c"
}

static void
_g_free0_ (gpointer var)
{
#line 192 "../src/common/WaterfallSettings.vala"
	var = (g_free (var), NULL);
#line 874 "WaterfallSettings.c"
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 192 "../src/common/WaterfallSettings.vala"
	self = *((gchar**) data);
#line 192 "../src/common/WaterfallSettings.vala"
	_g_free0_ (self);
#line 885 "WaterfallSettings.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 196 "../src/common/WaterfallSettings.vala"
	return self ? g_object_ref (self) : NULL;
#line 893 "WaterfallSettings.c"
}

static void
__lambda6_ (FontManagerWaterfallSettings* self)
{
	GtkDropDown* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 211 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->selection;
#line 211 "../src/common/WaterfallSettings.vala"
	_tmp1_ = gtk_drop_down_get_selected (_tmp0_);
#line 211 "../src/common/WaterfallSettings.vala"
	_tmp2_ = _tmp1_;
#line 211 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_set_predefined_size (self, (gint) _tmp2_);
#line 910 "WaterfallSettings.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 211 "../src/common/WaterfallSettings.vala"
	__lambda6_ ((FontManagerWaterfallSettings*) self);
#line 920 "WaterfallSettings.c"
}

static void
__lambda7_ (FontManagerWaterfallSettings* self)
{
#line 212 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_on_selection_changed (self);
#line 928 "WaterfallSettings.c"
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 212 "../src/common/WaterfallSettings.vala"
	__lambda7_ ((FontManagerWaterfallSettings*) self);
#line 938 "WaterfallSettings.c"
}

static void
font_manager_waterfall_settings_create_preference_row (FontManagerWaterfallSettings* self)
{
	GArray* selections = NULL;
	GArray* _tmp0_;
	GtkStringList* selection_list = NULL;
	GArray* _tmp5_;
	gpointer* _tmp6_;
	gint _tmp6__length1;
	GtkStringList* _tmp7_;
	GListModel* _tmp8_;
	GtkDropDown* _tmp9_;
	GtkDropDown* _tmp10_;
	FontManagerPreferenceRow* _tmp11_;
	GtkSpinButton* _tmp12_ = NULL;
	gchar* _tmp13_;
	GtkSpinButton* _tmp14_ = NULL;
	GtkSpinButton* _tmp15_ = NULL;
	FontManagerPreferenceRow* child = NULL;
	GtkSpinButton* _tmp16_;
	FontManagerPreferenceRow* _tmp17_;
	FontManagerPreferenceRow* _tmp18_;
	FontManagerPreferenceRow* _tmp19_;
	GtkSpinButton* _tmp20_;
	FontManagerPreferenceRow* _tmp21_;
	FontManagerPreferenceRow* _tmp22_;
	FontManagerPreferenceRow* _tmp23_;
	GtkSpinButton* _tmp24_;
	FontManagerPreferenceRow* _tmp25_;
	FontManagerPreferenceRow* _tmp26_;
	FontManagerPreferenceRow* _tmp27_;
	FontManagerPreferenceRow* _tmp28_;
	gint _tmp29_;
	GtkDropDown* _tmp30_;
	GBindingFlags flags = 0U;
	GtkSpinButton* _tmp31_;
	GtkSpinButton* _tmp32_;
	GtkSpinButton* _tmp33_;
	GtkDropDown* _tmp34_;
#line 191 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/common/WaterfallSettings.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 192 "../src/common/WaterfallSettings.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 192 "../src/common/WaterfallSettings.vala"
	selections = _tmp0_;
#line 988 "WaterfallSettings.c"
	{
		gint i = 0;
#line 193 "../src/common/WaterfallSettings.vala"
		i = 0;
#line 993 "WaterfallSettings.c"
		{
			gboolean _tmp1_ = FALSE;
#line 193 "../src/common/WaterfallSettings.vala"
			_tmp1_ = TRUE;
#line 193 "../src/common/WaterfallSettings.vala"
			while (TRUE) {
#line 1000 "WaterfallSettings.c"
				GArray* _tmp3_;
				gchar* _tmp4_;
#line 193 "../src/common/WaterfallSettings.vala"
				if (!_tmp1_) {
#line 1005 "WaterfallSettings.c"
					gint _tmp2_;
#line 193 "../src/common/WaterfallSettings.vala"
					_tmp2_ = i;
#line 193 "../src/common/WaterfallSettings.vala"
					i = _tmp2_ + 1;
#line 1011 "WaterfallSettings.c"
				}
#line 193 "../src/common/WaterfallSettings.vala"
				_tmp1_ = FALSE;
#line 193 "../src/common/WaterfallSettings.vala"
				if (!(i <= ((gint) FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM))) {
#line 193 "../src/common/WaterfallSettings.vala"
					break;
#line 1019 "WaterfallSettings.c"
				}
#line 194 "../src/common/WaterfallSettings.vala"
				_tmp3_ = selections;
#line 194 "../src/common/WaterfallSettings.vala"
				_tmp4_ = font_manager_predefined_waterfall_size_to_string ((FontManagerPredefinedWaterfallSize) i);
#line 194 "../src/common/WaterfallSettings.vala"
				g_array_append_val (_tmp3_, _tmp4_);
#line 1027 "WaterfallSettings.c"
			}
		}
	}
#line 195 "../src/common/WaterfallSettings.vala"
	_tmp5_ = selections;
#line 195 "../src/common/WaterfallSettings.vala"
	_tmp6_ = _tmp5_->data;
#line 195 "../src/common/WaterfallSettings.vala"
	_tmp6__length1 = _tmp5_->len;
#line 195 "../src/common/WaterfallSettings.vala"
	_tmp7_ = gtk_string_list_new (_tmp6_);
#line 195 "../src/common/WaterfallSettings.vala"
	selection_list = _tmp7_;
#line 196 "../src/common/WaterfallSettings.vala"
	_tmp8_ = _g_object_ref0 ((GListModel*) selection_list);
#line 196 "../src/common/WaterfallSettings.vala"
	_tmp9_ = (GtkDropDown*) gtk_drop_down_new (_tmp8_, NULL);
#line 196 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp9_);
#line 196 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->selection);
#line 196 "../src/common/WaterfallSettings.vala"
	self->priv->selection = _tmp9_;
#line 197 "../src/common/WaterfallSettings.vala"
	_tmp10_ = self->priv->selection;
#line 197 "../src/common/WaterfallSettings.vala"
	_tmp11_ = (FontManagerPreferenceRow*) font_manager_preference_row_new (_ ("Waterfall Preview Size Settings"), NULL, NULL, (GtkWidget*) _tmp10_);
#line 197 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp11_);
#line 197 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->row);
#line 197 "../src/common/WaterfallSettings.vala"
	self->priv->row = _tmp11_;
#line 198 "../src/common/WaterfallSettings.vala"
	_tmp12_ = (GtkSpinButton*) gtk_spin_button_new_with_range (6.0, 48.0, 1.0);
#line 198 "../src/common/WaterfallSettings.vala"
	gtk_spin_button_set_value (_tmp12_, 8.0);
#line 198 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp12_);
#line 198 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->min);
#line 198 "../src/common/WaterfallSettings.vala"
	self->priv->min = _tmp12_;
#line 199 "../src/common/WaterfallSettings.vala"
	_tmp13_ = g_strdup (_ ("Higher values may adversely affect performance"));
#line 199 "../src/common/WaterfallSettings.vala"
	_tmp14_ = (GtkSpinButton*) gtk_spin_button_new_with_range (24.0, 192.0, 1.0);
#line 199 "../src/common/WaterfallSettings.vala"
	gtk_spin_button_set_value (_tmp14_, 48.0);
#line 199 "../src/common/WaterfallSettings.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp13_);
#line 199 "../src/common/WaterfallSettings.vala"
	_g_free0 (_tmp13_);
#line 199 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp14_);
#line 199 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->max);
#line 199 "../src/common/WaterfallSettings.vala"
	self->priv->max = _tmp14_;
#line 203 "../src/common/WaterfallSettings.vala"
	_tmp15_ = (GtkSpinButton*) gtk_spin_button_new_with_range (1.0, 24.0, 0.10);
#line 203 "../src/common/WaterfallSettings.vala"
	gtk_spin_button_set_value (_tmp15_, 48.0);
#line 203 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp15_);
#line 203 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->rat);
#line 203 "../src/common/WaterfallSettings.vala"
	self->priv->rat = _tmp15_;
#line 204 "../src/common/WaterfallSettings.vala"
	_tmp16_ = self->priv->min;
#line 204 "../src/common/WaterfallSettings.vala"
	_tmp17_ = (FontManagerPreferenceRow*) font_manager_preference_row_new (_ ("Minimum Waterfall Preview Point Size"), NULL, NULL, (GtkWidget*) _tmp16_);
#line 204 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp17_);
#line 204 "../src/common/WaterfallSettings.vala"
	child = _tmp17_;
#line 205 "../src/common/WaterfallSettings.vala"
	_tmp18_ = self->priv->row;
#line 205 "../src/common/WaterfallSettings.vala"
	_tmp19_ = child;
#line 205 "../src/common/WaterfallSettings.vala"
	font_manager_preference_row_append_child (_tmp18_, _tmp19_);
#line 206 "../src/common/WaterfallSettings.vala"
	_tmp20_ = self->priv->rat;
#line 206 "../src/common/WaterfallSettings.vala"
	_tmp21_ = (FontManagerPreferenceRow*) font_manager_preference_row_new (_ ("Waterfall Preview Point Size Common Ratio"), NULL, NULL, (GtkWidget*) _tmp20_);
#line 206 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp21_);
#line 206 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (child);
#line 206 "../src/common/WaterfallSettings.vala"
	child = _tmp21_;
#line 207 "../src/common/WaterfallSettings.vala"
	_tmp22_ = self->priv->row;
#line 207 "../src/common/WaterfallSettings.vala"
	_tmp23_ = child;
#line 207 "../src/common/WaterfallSettings.vala"
	font_manager_preference_row_append_child (_tmp22_, _tmp23_);
#line 208 "../src/common/WaterfallSettings.vala"
	_tmp24_ = self->priv->max;
#line 208 "../src/common/WaterfallSettings.vala"
	_tmp25_ = (FontManagerPreferenceRow*) font_manager_preference_row_new (_ ("Maximum Waterfall Preview Point Size"), NULL, NULL, (GtkWidget*) _tmp24_);
#line 208 "../src/common/WaterfallSettings.vala"
	g_object_ref_sink (_tmp25_);
#line 208 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (child);
#line 208 "../src/common/WaterfallSettings.vala"
	child = _tmp25_;
#line 209 "../src/common/WaterfallSettings.vala"
	_tmp26_ = self->priv->row;
#line 209 "../src/common/WaterfallSettings.vala"
	_tmp27_ = child;
#line 209 "../src/common/WaterfallSettings.vala"
	font_manager_preference_row_append_child (_tmp26_, _tmp27_);
#line 210 "../src/common/WaterfallSettings.vala"
	_tmp28_ = self->priv->row;
#line 210 "../src/common/WaterfallSettings.vala"
	_tmp29_ = self->priv->_predefined_size;
#line 210 "../src/common/WaterfallSettings.vala"
	font_manager_preference_row_set_reveal_child (_tmp28_, _tmp29_ == ((gint) FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM));
#line 211 "../src/common/WaterfallSettings.vala"
	_tmp30_ = self->priv->selection;
#line 211 "../src/common/WaterfallSettings.vala"
	g_signal_connect_object ((GObject*) _tmp30_, "notify::selected", (GCallback) ___lambda6__g_object_notify, self, 0);
#line 212 "../src/common/WaterfallSettings.vala"
	g_signal_connect_object ((GObject*) self, "notify::predefined-size", (GCallback) ___lambda7__g_object_notify, self, G_CONNECT_AFTER);
#line 213 "../src/common/WaterfallSettings.vala"
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 214 "../src/common/WaterfallSettings.vala"
	_tmp31_ = self->priv->min;
#line 214 "../src/common/WaterfallSettings.vala"
	g_object_bind_property_with_closures ((GObject*) self, "minimum", (GObject*) _tmp31_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 215 "../src/common/WaterfallSettings.vala"
	_tmp32_ = self->priv->max;
#line 215 "../src/common/WaterfallSettings.vala"
	g_object_bind_property_with_closures ((GObject*) self, "maximum", (GObject*) _tmp32_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 216 "../src/common/WaterfallSettings.vala"
	_tmp33_ = self->priv->rat;
#line 216 "../src/common/WaterfallSettings.vala"
	g_object_bind_property_with_closures ((GObject*) self, "ratio", (GObject*) _tmp33_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 217 "../src/common/WaterfallSettings.vala"
	_tmp34_ = self->priv->selection;
#line 217 "../src/common/WaterfallSettings.vala"
	g_object_bind_property_with_closures ((GObject*) self, "predefined-size", (GObject*) _tmp34_, "selected", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 218 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (child);
#line 218 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (selection_list);
#line 218 "../src/common/WaterfallSettings.vala"
	_g_array_unref0 (selections);
#line 218 "../src/common/WaterfallSettings.vala"
	return;
#line 1181 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_on_selection_changed (FontManagerWaterfallSettings* self)
{
	FontManagerPreferenceRow* _tmp0_;
	gint _tmp3_;
	gdouble* selected = NULL;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gdouble* _tmp6_;
	gint selected_length1;
	gint _selected_size_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
	gdouble _tmp12_;
#line 221 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->row;
#line 222 "../src/common/WaterfallSettings.vala"
	if (_tmp0_ != NULL) {
#line 1210 "WaterfallSettings.c"
		FontManagerPreferenceRow* _tmp1_;
		gint _tmp2_;
#line 223 "../src/common/WaterfallSettings.vala"
		_tmp1_ = self->priv->row;
#line 223 "../src/common/WaterfallSettings.vala"
		_tmp2_ = self->priv->_predefined_size;
#line 223 "../src/common/WaterfallSettings.vala"
		font_manager_preference_row_set_reveal_child (_tmp1_, _tmp2_ == ((gint) FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM));
#line 1219 "WaterfallSettings.c"
	}
#line 224 "../src/common/WaterfallSettings.vala"
	_tmp3_ = self->priv->_predefined_size;
#line 224 "../src/common/WaterfallSettings.vala"
	if (_tmp3_ == ((gint) FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM)) {
#line 225 "../src/common/WaterfallSettings.vala"
		return;
#line 1227 "WaterfallSettings.c"
	}
#line 226 "../src/common/WaterfallSettings.vala"
	_tmp4_ = self->priv->_predefined_size;
#line 226 "../src/common/WaterfallSettings.vala"
	_tmp6_ = font_manager_predefined_waterfall_size_to_size_array ((FontManagerPredefinedWaterfallSize) _tmp4_, &_tmp5_);
#line 226 "../src/common/WaterfallSettings.vala"
	selected = _tmp6_;
#line 226 "../src/common/WaterfallSettings.vala"
	selected_length1 = _tmp5_;
#line 226 "../src/common/WaterfallSettings.vala"
	_selected_size_ = selected_length1;
#line 227 "../src/common/WaterfallSettings.vala"
	_tmp7_ = selected;
#line 227 "../src/common/WaterfallSettings.vala"
	_tmp7__length1 = selected_length1;
#line 227 "../src/common/WaterfallSettings.vala"
	_tmp8_ = _tmp7_[0];
#line 227 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_set_minimum (self, _tmp8_);
#line 228 "../src/common/WaterfallSettings.vala"
	_tmp9_ = selected;
#line 228 "../src/common/WaterfallSettings.vala"
	_tmp9__length1 = selected_length1;
#line 228 "../src/common/WaterfallSettings.vala"
	_tmp10_ = _tmp9_[1];
#line 228 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_set_maximum (self, _tmp10_);
#line 229 "../src/common/WaterfallSettings.vala"
	_tmp11_ = selected;
#line 229 "../src/common/WaterfallSettings.vala"
	_tmp11__length1 = selected_length1;
#line 229 "../src/common/WaterfallSettings.vala"
	_tmp12_ = _tmp11_[2];
#line 229 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_set_ratio (self, _tmp12_);
#line 230 "../src/common/WaterfallSettings.vala"
	selected = (g_free (selected), NULL);
#line 230 "../src/common/WaterfallSettings.vala"
	return;
#line 1267 "WaterfallSettings.c"
}

static GMenuModel*
font_manager_waterfall_settings_get_context_menu_model (FontManagerWaterfallSettings* self)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
	GMenu* line_size = NULL;
	GMenu* _tmp1_;
	GMenuItem* line_size_menu_item = NULL;
	GMenuItem* _tmp2_;
	GMenu* _tmp3_;
	GMenuItem* _tmp4_;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* size_section = NULL;
	GMenu* _tmp7_;
	GMenu* _tmp17_;
	GMenu* _tmp18_;
	GMenu* _tmp19_;
	GMenuModel* _tmp20_;
	GMenuModel* result;
#line 233 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "../src/common/WaterfallSettings.vala"
	_tmp0_ = g_menu_new ();
#line 234 "../src/common/WaterfallSettings.vala"
	section = _tmp0_;
#line 235 "../src/common/WaterfallSettings.vala"
	_tmp1_ = g_menu_new ();
#line 235 "../src/common/WaterfallSettings.vala"
	line_size = _tmp1_;
#line 236 "../src/common/WaterfallSettings.vala"
	_tmp2_ = g_menu_item_new (_ ("Show line size"), "show-line-size");
#line 236 "../src/common/WaterfallSettings.vala"
	line_size_menu_item = _tmp2_;
#line 237 "../src/common/WaterfallSettings.vala"
	_tmp3_ = line_size;
#line 237 "../src/common/WaterfallSettings.vala"
	_tmp4_ = line_size_menu_item;
#line 237 "../src/common/WaterfallSettings.vala"
	g_menu_append_item (_tmp3_, _tmp4_);
#line 238 "../src/common/WaterfallSettings.vala"
	_tmp5_ = section;
#line 238 "../src/common/WaterfallSettings.vala"
	_tmp6_ = line_size;
#line 238 "../src/common/WaterfallSettings.vala"
	g_menu_prepend_section (_tmp5_, NULL, (GMenuModel*) _tmp6_);
#line 239 "../src/common/WaterfallSettings.vala"
	_tmp7_ = g_menu_new ();
#line 239 "../src/common/WaterfallSettings.vala"
	size_section = _tmp7_;
#line 1320 "WaterfallSettings.c"
	{
		gint i = 0;
#line 240 "../src/common/WaterfallSettings.vala"
		i = 0;
#line 1325 "WaterfallSettings.c"
		{
			gboolean _tmp8_ = FALSE;
#line 240 "../src/common/WaterfallSettings.vala"
			_tmp8_ = TRUE;
#line 240 "../src/common/WaterfallSettings.vala"
			while (TRUE) {
#line 1332 "WaterfallSettings.c"
				GMenuItem* item = NULL;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GMenuItem* _tmp12_;
				GMenuItem* _tmp13_;
				GMenuItem* _tmp14_;
				GMenu* _tmp15_;
				GMenuItem* _tmp16_;
#line 240 "../src/common/WaterfallSettings.vala"
				if (!_tmp8_) {
#line 1343 "WaterfallSettings.c"
					gint _tmp9_;
#line 240 "../src/common/WaterfallSettings.vala"
					_tmp9_ = i;
#line 240 "../src/common/WaterfallSettings.vala"
					i = _tmp9_ + 1;
#line 1349 "WaterfallSettings.c"
				}
#line 240 "../src/common/WaterfallSettings.vala"
				_tmp8_ = FALSE;
#line 240 "../src/common/WaterfallSettings.vala"
				if (!(i < ((gint) FONT_MANAGER_PREDEFINED_WATERFALL_SIZE_CUSTOM))) {
#line 240 "../src/common/WaterfallSettings.vala"
					break;
#line 1357 "WaterfallSettings.c"
				}
#line 241 "../src/common/WaterfallSettings.vala"
				_tmp10_ = font_manager_predefined_waterfall_size_to_string ((FontManagerPredefinedWaterfallSize) i);
#line 241 "../src/common/WaterfallSettings.vala"
				_tmp11_ = _tmp10_;
#line 241 "../src/common/WaterfallSettings.vala"
				_tmp12_ = g_menu_item_new (_tmp11_, NULL);
#line 241 "../src/common/WaterfallSettings.vala"
				_tmp13_ = _tmp12_;
#line 241 "../src/common/WaterfallSettings.vala"
				_g_free0 (_tmp11_);
#line 241 "../src/common/WaterfallSettings.vala"
				item = _tmp13_;
#line 242 "../src/common/WaterfallSettings.vala"
				_tmp14_ = item;
#line 242 "../src/common/WaterfallSettings.vala"
				g_menu_item_set_action_and_target (_tmp14_, "predefined-size", "i", i, NULL);
#line 243 "../src/common/WaterfallSettings.vala"
				_tmp15_ = size_section;
#line 243 "../src/common/WaterfallSettings.vala"
				_tmp16_ = item;
#line 243 "../src/common/WaterfallSettings.vala"
				g_menu_append_item (_tmp15_, _tmp16_);
#line 240 "../src/common/WaterfallSettings.vala"
				_g_object_unref0 (item);
#line 1383 "WaterfallSettings.c"
			}
		}
	}
#line 245 "../src/common/WaterfallSettings.vala"
	_tmp17_ = section;
#line 245 "../src/common/WaterfallSettings.vala"
	_tmp18_ = size_section;
#line 245 "../src/common/WaterfallSettings.vala"
	g_menu_append_section (_tmp17_, NULL, (GMenuModel*) _tmp18_);
#line 246 "../src/common/WaterfallSettings.vala"
	_tmp19_ = section;
#line 246 "../src/common/WaterfallSettings.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, g_menu_model_get_type (), GMenuModel));
#line 246 "../src/common/WaterfallSettings.vala"
	result = _tmp20_;
#line 246 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (size_section);
#line 246 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (line_size_menu_item);
#line 246 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (line_size);
#line 246 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (section);
#line 246 "../src/common/WaterfallSettings.vala"
	return result;
#line 1409 "WaterfallSettings.c"
}

GSettings*
font_manager_waterfall_settings_get_settings (FontManagerWaterfallSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 133 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->_settings;
#line 133 "../src/common/WaterfallSettings.vala"
	result = _tmp0_;
#line 133 "../src/common/WaterfallSettings.vala"
	return result;
#line 1425 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_settings (FontManagerWaterfallSettings* self,
                                              GSettings* value)
{
	GSettings* old_value;
#line 133 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_settings (self);
#line 133 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 1439 "WaterfallSettings.c"
		GSettings* _tmp0_;
#line 133 "../src/common/WaterfallSettings.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 133 "../src/common/WaterfallSettings.vala"
		_g_object_unref0 (self->priv->_settings);
#line 133 "../src/common/WaterfallSettings.vala"
		self->priv->_settings = _tmp0_;
#line 133 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY]);
#line 1449 "WaterfallSettings.c"
	}
}

gint
font_manager_waterfall_settings_get_predefined_size (FontManagerWaterfallSettings* self)
{
	gint result;
#line 135 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 135 "../src/common/WaterfallSettings.vala"
	result = self->priv->_predefined_size;
#line 135 "../src/common/WaterfallSettings.vala"
	return result;
#line 1463 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_predefined_size (FontManagerWaterfallSettings* self,
                                                     gint value)
{
	gint old_value;
#line 135 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_predefined_size (self);
#line 135 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 135 "../src/common/WaterfallSettings.vala"
		self->priv->_predefined_size = value;
#line 135 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY]);
#line 1481 "WaterfallSettings.c"
	}
}

gdouble
font_manager_waterfall_settings_get_minimum (FontManagerWaterfallSettings* self)
{
	gdouble result;
#line 136 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 136 "../src/common/WaterfallSettings.vala"
	result = self->priv->_minimum;
#line 136 "../src/common/WaterfallSettings.vala"
	return result;
#line 1495 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_minimum (FontManagerWaterfallSettings* self,
                                             gdouble value)
{
	gdouble old_value;
#line 136 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_minimum (self);
#line 136 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 136 "../src/common/WaterfallSettings.vala"
		self->priv->_minimum = value;
#line 136 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY]);
#line 1513 "WaterfallSettings.c"
	}
}

gdouble
font_manager_waterfall_settings_get_maximum (FontManagerWaterfallSettings* self)
{
	gdouble result;
#line 137 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 137 "../src/common/WaterfallSettings.vala"
	result = self->priv->_maximum;
#line 137 "../src/common/WaterfallSettings.vala"
	return result;
#line 1527 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_maximum (FontManagerWaterfallSettings* self,
                                             gdouble value)
{
	gdouble old_value;
#line 137 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_maximum (self);
#line 137 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 137 "../src/common/WaterfallSettings.vala"
		self->priv->_maximum = value;
#line 137 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY]);
#line 1545 "WaterfallSettings.c"
	}
}

gdouble
font_manager_waterfall_settings_get_ratio (FontManagerWaterfallSettings* self)
{
	gdouble result;
#line 138 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 138 "../src/common/WaterfallSettings.vala"
	result = self->priv->_ratio;
#line 138 "../src/common/WaterfallSettings.vala"
	return result;
#line 1559 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_ratio (FontManagerWaterfallSettings* self,
                                           gdouble value)
{
	gdouble old_value;
#line 138 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_ratio (self);
#line 138 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 138 "../src/common/WaterfallSettings.vala"
		self->priv->_ratio = value;
#line 138 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY]);
#line 1577 "WaterfallSettings.c"
	}
}

gboolean
font_manager_waterfall_settings_get_show_line_size (FontManagerWaterfallSettings* self)
{
	gboolean result;
#line 139 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "../src/common/WaterfallSettings.vala"
	result = self->priv->_show_line_size;
#line 139 "../src/common/WaterfallSettings.vala"
	return result;
#line 1591 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_show_line_size (FontManagerWaterfallSettings* self,
                                                    gboolean value)
{
	gboolean old_value;
#line 139 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_show_line_size (self);
#line 139 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 139 "../src/common/WaterfallSettings.vala"
		self->priv->_show_line_size = value;
#line 139 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY]);
#line 1609 "WaterfallSettings.c"
	}
}

gint
font_manager_waterfall_settings_get_line_spacing (FontManagerWaterfallSettings* self)
{
	gint result;
#line 140 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 140 "../src/common/WaterfallSettings.vala"
	result = self->priv->_line_spacing;
#line 140 "../src/common/WaterfallSettings.vala"
	return result;
#line 1623 "WaterfallSettings.c"
}

void
font_manager_waterfall_settings_set_line_spacing (FontManagerWaterfallSettings* self,
                                                  gint value)
{
	gint old_value;
#line 140 "../src/common/WaterfallSettings.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/common/WaterfallSettings.vala"
	old_value = font_manager_waterfall_settings_get_line_spacing (self);
#line 140 "../src/common/WaterfallSettings.vala"
	if (old_value != value) {
#line 140 "../src/common/WaterfallSettings.vala"
		self->priv->_line_spacing = value;
#line 140 "../src/common/WaterfallSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY]);
#line 1641 "WaterfallSettings.c"
	}
}

GtkPopoverMenu*
font_manager_waterfall_settings_get_context_menu (FontManagerWaterfallSettings* self)
{
	GtkPopoverMenu* result;
	GtkPopoverMenu* _tmp0_;
	GtkPopoverMenu* _tmp4_;
#line 143 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->menu;
#line 144 "../src/common/WaterfallSettings.vala"
	if (_tmp0_ == NULL) {
#line 1657 "WaterfallSettings.c"
		GMenuModel* _tmp1_;
		GMenuModel* _tmp2_;
		GtkPopoverMenu* _tmp3_;
#line 145 "../src/common/WaterfallSettings.vala"
		_tmp1_ = font_manager_waterfall_settings_get_context_menu_model (self);
#line 145 "../src/common/WaterfallSettings.vala"
		_tmp2_ = _tmp1_;
#line 145 "../src/common/WaterfallSettings.vala"
		_tmp3_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model (_tmp2_);
#line 145 "../src/common/WaterfallSettings.vala"
		g_object_ref_sink (_tmp3_);
#line 145 "../src/common/WaterfallSettings.vala"
		_g_object_unref0 (self->priv->menu);
#line 145 "../src/common/WaterfallSettings.vala"
		self->priv->menu = _tmp3_;
#line 145 "../src/common/WaterfallSettings.vala"
		_g_object_unref0 (_tmp2_);
#line 1675 "WaterfallSettings.c"
	}
#line 146 "../src/common/WaterfallSettings.vala"
	_tmp4_ = self->priv->menu;
#line 146 "../src/common/WaterfallSettings.vala"
	result = _tmp4_;
#line 146 "../src/common/WaterfallSettings.vala"
	return result;
#line 1683 "WaterfallSettings.c"
}

FontManagerPreferenceRow*
font_manager_waterfall_settings_get_preference_row (FontManagerWaterfallSettings* self)
{
	FontManagerPreferenceRow* result;
	FontManagerPreferenceRow* _tmp0_;
	FontManagerPreferenceRow* _tmp1_;
#line 151 "../src/common/WaterfallSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/common/WaterfallSettings.vala"
	_tmp0_ = self->priv->row;
#line 152 "../src/common/WaterfallSettings.vala"
	if (_tmp0_ == NULL) {
#line 153 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_create_preference_row (self);
#line 1700 "WaterfallSettings.c"
	}
#line 154 "../src/common/WaterfallSettings.vala"
	_tmp1_ = self->priv->row;
#line 154 "../src/common/WaterfallSettings.vala"
	result = _tmp1_;
#line 154 "../src/common/WaterfallSettings.vala"
	return result;
#line 1708 "WaterfallSettings.c"
}

static void
font_manager_waterfall_settings_class_init (FontManagerWaterfallSettingsClass * klass,
                                            gpointer klass_data)
{
#line 131 "../src/common/WaterfallSettings.vala"
	font_manager_waterfall_settings_parent_class = g_type_class_peek_parent (klass);
#line 131 "../src/common/WaterfallSettings.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerWaterfallSettings_private_offset);
#line 131 "../src/common/WaterfallSettings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_waterfall_settings_get_property;
#line 131 "../src/common/WaterfallSettings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_waterfall_settings_set_property;
#line 131 "../src/common/WaterfallSettings.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_waterfall_settings_finalize;
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY] = g_param_spec_int ("predefined-size", "predefined-size", "predefined-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY] = g_param_spec_double ("minimum", "minimum", "minimum", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY] = g_param_spec_double ("maximum", "maximum", "maximum", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY] = g_param_spec_double ("ratio", "ratio", "ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY] = g_param_spec_boolean ("show-line-size", "show-line-size", "show-line-size", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY] = g_param_spec_int ("line-spacing", "line-spacing", "line-spacing", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_CONTEXT_MENU_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_CONTEXT_MENU_PROPERTY] = g_param_spec_object ("context-menu", "context-menu", "context-menu", gtk_popover_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 131 "../src/common/WaterfallSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_WATERFALL_SETTINGS_PREFERENCE_ROW_PROPERTY, font_manager_waterfall_settings_properties[FONT_MANAGER_WATERFALL_SETTINGS_PREFERENCE_ROW_PROPERTY] = g_param_spec_object ("preference-row", "preference-row", "preference-row", font_manager_preference_row_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1743 "WaterfallSettings.c"
}

static void
font_manager_waterfall_settings_instance_init (FontManagerWaterfallSettings * self,
                                               gpointer klass)
{
#line 131 "../src/common/WaterfallSettings.vala"
	self->priv = font_manager_waterfall_settings_get_instance_private (self);
#line 133 "../src/common/WaterfallSettings.vala"
	self->priv->_settings = NULL;
#line 139 "../src/common/WaterfallSettings.vala"
	self->priv->_show_line_size = TRUE;
#line 140 "../src/common/WaterfallSettings.vala"
	self->priv->_line_spacing = 0;
#line 162 "../src/common/WaterfallSettings.vala"
	self->priv->menu = NULL;
#line 164 "../src/common/WaterfallSettings.vala"
	self->priv->row = NULL;
#line 1762 "WaterfallSettings.c"
}

static void
font_manager_waterfall_settings_finalize (GObject * obj)
{
	FontManagerWaterfallSettings * self;
#line 131 "../src/common/WaterfallSettings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettings);
#line 133 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->_settings);
#line 158 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->min);
#line 159 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->max);
#line 160 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->rat);
#line 161 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->selection);
#line 162 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->menu);
#line 164 "../src/common/WaterfallSettings.vala"
	_g_object_unref0 (self->priv->row);
#line 131 "../src/common/WaterfallSettings.vala"
	G_OBJECT_CLASS (font_manager_waterfall_settings_parent_class)->finalize (obj);
#line 1787 "WaterfallSettings.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_waterfall_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerWaterfallSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_waterfall_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerWaterfallSettings), 0, (GInstanceInitFunc) font_manager_waterfall_settings_instance_init, NULL };
	GType font_manager_waterfall_settings_type_id;
	font_manager_waterfall_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerWaterfallSettings", &g_define_type_info, 0);
	FontManagerWaterfallSettings_private_offset = g_type_add_instance_private (font_manager_waterfall_settings_type_id, sizeof (FontManagerWaterfallSettingsPrivate));
	return font_manager_waterfall_settings_type_id;
}

GType
font_manager_waterfall_settings_get_type (void)
{
	static volatile gsize font_manager_waterfall_settings_type_id__once = 0;
	if (g_once_init_enter (&font_manager_waterfall_settings_type_id__once)) {
		GType font_manager_waterfall_settings_type_id;
		font_manager_waterfall_settings_type_id = font_manager_waterfall_settings_get_type_once ();
		g_once_init_leave (&font_manager_waterfall_settings_type_id__once, font_manager_waterfall_settings_type_id);
	}
	return font_manager_waterfall_settings_type_id__once;
}

static void
_vala_font_manager_waterfall_settings_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	FontManagerWaterfallSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettings);
#line 131 "../src/common/WaterfallSettings.vala"
	switch (property_id) {
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_object (value, font_manager_waterfall_settings_get_settings (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_int (value, font_manager_waterfall_settings_get_predefined_size (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_double (value, font_manager_waterfall_settings_get_minimum (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_double (value, font_manager_waterfall_settings_get_maximum (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_double (value, font_manager_waterfall_settings_get_ratio (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_boolean (value, font_manager_waterfall_settings_get_show_line_size (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_int (value, font_manager_waterfall_settings_get_line_spacing (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_CONTEXT_MENU_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_object (value, font_manager_waterfall_settings_get_context_menu (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_PREFERENCE_ROW_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		g_value_set_object (value, font_manager_waterfall_settings_get_preference_row (self));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 1876 "WaterfallSettings.c"
		default:
#line 131 "../src/common/WaterfallSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 1882 "WaterfallSettings.c"
	}
}

static void
_vala_font_manager_waterfall_settings_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	FontManagerWaterfallSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettings);
#line 131 "../src/common/WaterfallSettings.vala"
	switch (property_id) {
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_SETTINGS_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_settings (self, g_value_get_object (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_PREDEFINED_SIZE_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_predefined_size (self, g_value_get_int (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_MINIMUM_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_minimum (self, g_value_get_double (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_MAXIMUM_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_maximum (self, g_value_get_double (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_RATIO_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_ratio (self, g_value_get_double (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_SHOW_LINE_SIZE_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_show_line_size (self, g_value_get_boolean (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 131 "../src/common/WaterfallSettings.vala"
		case FONT_MANAGER_WATERFALL_SETTINGS_LINE_SPACING_PROPERTY:
#line 131 "../src/common/WaterfallSettings.vala"
		font_manager_waterfall_settings_set_line_spacing (self, g_value_get_int (value));
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 1938 "WaterfallSettings.c"
		default:
#line 131 "../src/common/WaterfallSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 131 "../src/common/WaterfallSettings.vala"
		break;
#line 1944 "WaterfallSettings.c"
	}
}

