/* Categories.c generated by valac 0.56.18, the Vala compiler
 * generated from Categories.vala, do not modify */

/* Categories.vala
 *
 * Copyright (C) 2009-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include "font-manager.h"
#include <glib/gi18n-lib.h>
#include <sqlite3.h>

#define FONT_MANAGER_SELECT_FROM_FONTS "SELECT DISTINCT family, description FROM Fonts"
#define FONT_MANAGER_SELECT_FROM_METADATA_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Metada" \
"ta USING (filepath, findex) WHERE"
#define FONT_MANAGER_SELECT_FROM_PANOSE_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Panose" \
" USING (filepath, findex) WHERE"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_CATEGORY_INDEX_ALL,
	FONT_MANAGER_CATEGORY_INDEX_SYSTEM,
	FONT_MANAGER_CATEGORY_INDEX_USER,
	FONT_MANAGER_CATEGORY_INDEX_PANOSE,
	FONT_MANAGER_CATEGORY_INDEX_WIDTH,
	FONT_MANAGER_CATEGORY_INDEX_WEIGHT,
	FONT_MANAGER_CATEGORY_INDEX_SLANT,
	FONT_MANAGER_CATEGORY_INDEX_SPACING,
	FONT_MANAGER_CATEGORY_INDEX_LICENSE,
	FONT_MANAGER_CATEGORY_INDEX_VENDOR,
	FONT_MANAGER_CATEGORY_INDEX_FILETYPE,
	FONT_MANAGER_CATEGORY_INDEX_UNSORTED,
	FONT_MANAGER_CATEGORY_INDEX_DISABLED,
	FONT_MANAGER_CATEGORY_INDEX_LANGUAGE,
	FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES
} FontManagerCategoryIndex;

#define FONT_MANAGER_TYPE_CATEGORY_INDEX (font_manager_category_index_get_type ())

#define FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL (font_manager_font_list_filter_model_get_type ())
#define FONT_MANAGER_FONT_LIST_FILTER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL, FontManagerFontListFilterModel))
#define FONT_MANAGER_FONT_LIST_FILTER_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL, FontManagerFontListFilterModelClass))
#define FONT_MANAGER_IS_FONT_LIST_FILTER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL))
#define FONT_MANAGER_IS_FONT_LIST_FILTER_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL))
#define FONT_MANAGER_FONT_LIST_FILTER_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL, FontManagerFontListFilterModelClass))

typedef struct _FontManagerFontListFilterModel FontManagerFontListFilterModel;
typedef struct _FontManagerFontListFilterModelClass FontManagerFontListFilterModelClass;
typedef struct _FontManagerFontListFilterModelPrivate FontManagerFontListFilterModelPrivate;

#define FONT_MANAGER_TYPE_CACHEABLE (font_manager_cacheable_get_type ())
#define FONT_MANAGER_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheable))
#define FONT_MANAGER_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))
#define FONT_MANAGER_IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))

typedef struct _FontManagerCacheable FontManagerCacheable;
typedef struct _FontManagerCacheableClass FontManagerCacheableClass;

#define FONT_MANAGER_TYPE_FONT_LIST_FILTER (font_manager_font_list_filter_get_type ())
#define FONT_MANAGER_FONT_LIST_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER, FontManagerFontListFilter))
#define FONT_MANAGER_FONT_LIST_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FONT_LIST_FILTER, FontManagerFontListFilterClass))
#define FONT_MANAGER_IS_FONT_LIST_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER))
#define FONT_MANAGER_IS_FONT_LIST_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FONT_LIST_FILTER))
#define FONT_MANAGER_FONT_LIST_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FONT_LIST_FILTER, FontManagerFontListFilterClass))

typedef struct _FontManagerFontListFilter FontManagerFontListFilter;
typedef struct _FontManagerFontListFilterClass FontManagerFontListFilterClass;

#define FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL (font_manager_category_list_model_get_type ())
#define FONT_MANAGER_CATEGORY_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL, FontManagerCategoryListModel))
#define FONT_MANAGER_CATEGORY_LIST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL, FontManagerCategoryListModelClass))
#define FONT_MANAGER_IS_CATEGORY_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL))
#define FONT_MANAGER_IS_CATEGORY_LIST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL))
#define FONT_MANAGER_CATEGORY_LIST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL, FontManagerCategoryListModelClass))

typedef struct _FontManagerCategoryListModel FontManagerCategoryListModel;
typedef struct _FontManagerCategoryListModelClass FontManagerCategoryListModelClass;
typedef struct _FontManagerCategoryListModelPrivate FontManagerCategoryListModelPrivate;
enum  {
	FONT_MANAGER_CATEGORY_LIST_MODEL_0_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_MODEL_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_list_model_properties[FONT_MANAGER_CATEGORY_LIST_MODEL_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_CATEGORY (font_manager_category_get_type ())
#define FONT_MANAGER_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory))
#define FONT_MANAGER_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))
#define FONT_MANAGER_IS_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))

typedef struct _FontManagerCategory FontManagerCategory;
typedef struct _FontManagerCategoryClass FontManagerCategoryClass;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_TYPE_LIST_ITEM_ROW (font_manager_list_item_row_get_type ())
#define FONT_MANAGER_LIST_ITEM_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LIST_ITEM_ROW, FontManagerListItemRow))
#define FONT_MANAGER_LIST_ITEM_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LIST_ITEM_ROW, FontManagerListItemRowClass))
#define FONT_MANAGER_IS_LIST_ITEM_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LIST_ITEM_ROW))
#define FONT_MANAGER_IS_LIST_ITEM_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LIST_ITEM_ROW))
#define FONT_MANAGER_LIST_ITEM_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LIST_ITEM_ROW, FontManagerListItemRowClass))

typedef struct _FontManagerListItemRow FontManagerListItemRow;
typedef struct _FontManagerListItemRowClass FontManagerListItemRowClass;
typedef struct _FontManagerListItemRowPrivate FontManagerListItemRowPrivate;

#define FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW (font_manager_tree_list_item_row_get_type ())
#define FONT_MANAGER_TREE_LIST_ITEM_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW, FontManagerTreeListItemRow))
#define FONT_MANAGER_TREE_LIST_ITEM_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW, FontManagerTreeListItemRowClass))
#define FONT_MANAGER_IS_TREE_LIST_ITEM_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW))
#define FONT_MANAGER_IS_TREE_LIST_ITEM_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW))
#define FONT_MANAGER_TREE_LIST_ITEM_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW, FontManagerTreeListItemRowClass))

typedef struct _FontManagerTreeListItemRow FontManagerTreeListItemRow;
typedef struct _FontManagerTreeListItemRowClass FontManagerTreeListItemRowClass;
typedef struct _FontManagerTreeListItemRowPrivate FontManagerTreeListItemRowPrivate;

#define FONT_MANAGER_TYPE_CATEGORY_LIST_ROW (font_manager_category_list_row_get_type ())
#define FONT_MANAGER_CATEGORY_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_ROW, FontManagerCategoryListRow))
#define FONT_MANAGER_CATEGORY_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_ROW, FontManagerCategoryListRowClass))
#define FONT_MANAGER_IS_CATEGORY_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_ROW))
#define FONT_MANAGER_IS_CATEGORY_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_ROW))
#define FONT_MANAGER_CATEGORY_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_ROW, FontManagerCategoryListRowClass))

typedef struct _FontManagerCategoryListRow FontManagerCategoryListRow;
typedef struct _FontManagerCategoryListRowClass FontManagerCategoryListRowClass;
typedef struct _FontManagerCategoryListRowPrivate FontManagerCategoryListRowPrivate;
enum  {
	FONT_MANAGER_CATEGORY_LIST_ROW_0_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_list_row_properties[FONT_MANAGER_CATEGORY_LIST_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define FONT_MANAGER_TYPE_FILTER_LIST_VIEW (font_manager_filter_list_view_get_type ())
#define FONT_MANAGER_FILTER_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FILTER_LIST_VIEW, FontManagerFilterListView))
#define FONT_MANAGER_FILTER_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FILTER_LIST_VIEW, FontManagerFilterListViewClass))
#define FONT_MANAGER_IS_FILTER_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FILTER_LIST_VIEW))
#define FONT_MANAGER_IS_FILTER_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FILTER_LIST_VIEW))
#define FONT_MANAGER_FILTER_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FILTER_LIST_VIEW, FontManagerFilterListViewClass))

typedef struct _FontManagerFilterListView FontManagerFilterListView;
typedef struct _FontManagerFilterListViewClass FontManagerFilterListViewClass;
typedef struct _FontManagerFilterListViewPrivate FontManagerFilterListViewPrivate;

#define FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW (font_manager_category_list_view_get_type ())
#define FONT_MANAGER_CATEGORY_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListView))
#define FONT_MANAGER_CATEGORY_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListViewClass))
#define FONT_MANAGER_IS_CATEGORY_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW))
#define FONT_MANAGER_IS_CATEGORY_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW))
#define FONT_MANAGER_CATEGORY_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListViewClass))

typedef struct _FontManagerCategoryListView FontManagerCategoryListView;
typedef struct _FontManagerCategoryListViewClass FontManagerCategoryListViewClass;
typedef struct _FontManagerCategoryListViewPrivate FontManagerCategoryListViewPrivate;

#define FONT_MANAGER_TYPE_DISABLED (font_manager_disabled_get_type ())
#define FONT_MANAGER_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled))
#define FONT_MANAGER_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))
#define FONT_MANAGER_IS_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_IS_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_DISABLED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))

typedef struct _FontManagerDisabled FontManagerDisabled;
typedef struct _FontManagerDisabledClass FontManagerDisabledClass;

#define FONT_MANAGER_TYPE_UNSORTED (font_manager_unsorted_get_type ())
#define FONT_MANAGER_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsorted))
#define FONT_MANAGER_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))
#define FONT_MANAGER_IS_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_IS_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_UNSORTED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))

typedef struct _FontManagerUnsorted FontManagerUnsorted;
typedef struct _FontManagerUnsortedClass FontManagerUnsortedClass;

#define FONT_MANAGER_TYPE_LANGUAGE_FILTER (font_manager_language_filter_get_type ())
#define FONT_MANAGER_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter))
#define FONT_MANAGER_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))
#define FONT_MANAGER_IS_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_LANGUAGE_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))

typedef struct _FontManagerLanguageFilter FontManagerLanguageFilter;
typedef struct _FontManagerLanguageFilterClass FontManagerLanguageFilterClass;
enum  {
	FONT_MANAGER_CATEGORY_LIST_VIEW_0_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY,
	FONT_MANAGER_CATEGORY_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_FILTER_DATA (font_manager_filter_data_get_type ())
typedef struct _FontManagerFilterData FontManagerFilterData;

#define FONT_MANAGER_TYPE_USER_FONTS (font_manager_user_fonts_get_type ())
#define FONT_MANAGER_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFonts))
#define FONT_MANAGER_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))
#define FONT_MANAGER_IS_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_IS_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_USER_FONTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))

typedef struct _FontManagerUserFonts FontManagerUserFonts;
typedef struct _FontManagerUserFontsClass FontManagerUserFontsClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerFontListFilterModel {
	GObject parent_instance;
	FontManagerFontListFilterModelPrivate * priv;
};

struct _FontManagerFontListFilterModelClass {
	GObjectClass parent_class;
	void (*add_item) (FontManagerFontListFilterModel* self, FontManagerFontListFilter* item);
	void (*remove_item) (FontManagerFontListFilterModel* self, FontManagerFontListFilter* item);
};

struct _FontManagerCategoryListModel {
	FontManagerFontListFilterModel parent_instance;
	FontManagerCategoryListModelPrivate * priv;
};

struct _FontManagerCategoryListModelClass {
	FontManagerFontListFilterModelClass parent_class;
};

struct _FontManagerListItemRow {
	GtkBox parent_instance;
	FontManagerListItemRowPrivate * priv;
};

struct _FontManagerListItemRowClass {
	GtkBoxClass parent_class;
	void (*on_item_set) (FontManagerListItemRow* self);
	void (*reset) (FontManagerListItemRow* self);
};

struct _FontManagerTreeListItemRow {
	FontManagerListItemRow parent_instance;
	FontManagerTreeListItemRowPrivate * priv;
};

struct _FontManagerTreeListItemRowClass {
	FontManagerListItemRowClass parent_class;
	void (*show_context_menu) (FontManagerTreeListItemRow* self, GdkEvent* event, gdouble x, gdouble y);
};

struct _FontManagerCategoryListRow {
	FontManagerTreeListItemRow parent_instance;
	FontManagerCategoryListRowPrivate * priv;
};

struct _FontManagerCategoryListRowClass {
	FontManagerTreeListItemRowClass parent_class;
};

struct _FontManagerCategoryListRowPrivate {
	gulong handler_id;
};

struct _FontManagerFilterListView {
	GtkBox parent_instance;
	FontManagerFilterListViewPrivate * priv;
	GtkListView* listview;
};

struct _FontManagerFilterListViewClass {
	GtkBoxClass parent_class;
	void (*on_show_context_menu) (FontManagerFilterListView* self, gint n_press, gdouble x, gdouble y);
	void (*setup_list_row) (FontManagerFilterListView* self, GtkSignalListItemFactory* factory, GObject* item);
	void (*bind_list_row) (FontManagerFilterListView* self, GtkSignalListItemFactory* factory, GObject* item);
	void (*collapse_all) (FontManagerFilterListView* self);
	void (*on_row_selected) (FontManagerFilterListView* self, GtkTreeListRow* row);
	void (*on_selection_changed) (FontManagerFilterListView* self, guint position, guint n_items);
};

struct _FontManagerCategoryListView {
	FontManagerFilterListView parent_instance;
	FontManagerCategoryListViewPrivate * priv;
};

struct _FontManagerCategoryListViewClass {
	FontManagerFilterListViewClass parent_class;
};

struct _FontManagerCategoryListViewPrivate {
	FontManagerReject* _disabled_families;
	FontManagerDisabled* _disabled;
	FontManagerStringSet* _sorted;
	FontManagerUnsorted* _unsorted;
	FontManagerLanguageFilter* _language_filter;
};

struct _FontManagerFilterData {
	gint index;
	gchar* name;
	gchar* comment;
	gchar* column;
};

static gpointer font_manager_category_list_model_parent_class = NULL;
static gint FontManagerCategoryListRow_private_offset;
static gpointer font_manager_category_list_row_parent_class = NULL;
static gint FontManagerCategoryListView_private_offset;
static gpointer font_manager_category_list_view_parent_class = NULL;

VALA_EXTERN GType font_manager_category_index_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_font_list_filter_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFontListFilterModel, g_object_unref)
VALA_EXTERN GType font_manager_cacheable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCacheable, g_object_unref)
VALA_EXTERN GType font_manager_font_list_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFontListFilter, g_object_unref)
VALA_EXTERN GType font_manager_category_list_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryListModel, g_object_unref)
VALA_EXTERN FontManagerCategoryListModel* font_manager_category_list_model_new (void);
VALA_EXTERN FontManagerCategoryListModel* font_manager_category_list_model_construct (GType object_type);
VALA_EXTERN FontManagerFontListFilterModel* font_manager_font_list_filter_model_new (void);
VALA_EXTERN FontManagerFontListFilterModel* font_manager_font_list_filter_model_construct (GType object_type);
VALA_EXTERN GType font_manager_category_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategory, g_object_unref)
VALA_EXTERN GPtrArray* font_manager_get_base_categories (void);
VALA_EXTERN void font_manager_font_list_filter_model_set_items (FontManagerFontListFilterModel* self,
                                                    GPtrArray* value);
static void font_manager_category_list_model_on_categories_updated (GObject* source,
                                                             GTask* task);
VALA_EXTERN void font_manager_category_list_model_update_items (FontManagerCategoryListModel* self);
static void _font_manager_category_list_model_on_categories_updated_gasync_ready_callback (GObject* source_object,
                                                                                    GTask* task,
                                                                                    gpointer self);
VALA_EXTERN void font_manager_get_default_categories (GTask* task,
                                          GObject* source,
                                          void* data,
                                          GCancellable* cancellable);
static void _font_manager_get_default_categories_gtask_thread_func (GTask* task,
                                                             GObject* source_object,
                                                             void* task_data,
                                                             GCancellable* cancellable);
VALA_EXTERN GListModel* font_manager_category_list_model_get_child_model (GObject* item);
VALA_EXTERN GPtrArray* font_manager_category_get_children (FontManagerCategory* self);
static GType font_manager_category_list_model_get_type_once (void);
VALA_EXTERN GType font_manager_list_item_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerListItemRow, g_object_unref)
VALA_EXTERN GType font_manager_tree_list_item_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerTreeListItemRow, g_object_unref)
VALA_EXTERN GType font_manager_category_list_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryListRow, g_object_unref)
VALA_EXTERN void font_manager_list_item_row_reset (FontManagerListItemRow* self);
VALA_EXTERN void font_manager_list_item_row_on_item_set (FontManagerListItemRow* self);
static void font_manager_category_list_row_real_reset (FontManagerListItemRow* base);
VALA_EXTERN GtkLabel* font_manager_list_item_row_get_item_label (FontManagerListItemRow* self);
VALA_EXTERN GtkLabel* font_manager_list_item_row_get_item_count (FontManagerListItemRow* self);
VALA_EXTERN GObject* font_manager_list_item_row_get_item (FontManagerListItemRow* self);
static void font_manager_category_list_row_real_on_item_set (FontManagerListItemRow* base);
static void _font_manager_list_item_row_on_item_set_font_manager_cacheable_changed (FontManagerCacheable* _sender,
                                                                             gpointer self);
VALA_EXTERN gint font_manager_font_list_filter_get_index (FontManagerFontListFilter* self);
VALA_EXTERN gint font_manager_font_list_filter_get_depth (FontManagerFontListFilter* self);
VALA_EXTERN gchar* font_manager_font_list_filter_get_name (FontManagerFontListFilter* self);
VALA_EXTERN GtkImage* font_manager_list_item_row_get_item_icon (FontManagerListItemRow* self);
VALA_EXTERN gchar* font_manager_font_list_filter_get_icon (FontManagerFontListFilter* self);
VALA_EXTERN gint font_manager_font_list_filter_get_size (FontManagerFontListFilter* self);
VALA_EXTERN gchar* font_manager_font_list_filter_get_comment (FontManagerFontListFilter* self);
VALA_EXTERN FontManagerCategoryListRow* font_manager_category_list_row_new (void);
VALA_EXTERN FontManagerCategoryListRow* font_manager_category_list_row_construct (GType object_type);
VALA_EXTERN FontManagerTreeListItemRow* font_manager_tree_list_item_row_new (void);
VALA_EXTERN FontManagerTreeListItemRow* font_manager_tree_list_item_row_construct (GType object_type);
static void font_manager_category_list_row_finalize (GObject * obj);
static GType font_manager_category_list_row_get_type_once (void);
VALA_EXTERN GType font_manager_filter_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFilterListView, g_object_unref)
VALA_EXTERN GType font_manager_category_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryListView, g_object_unref)
VALA_EXTERN GType font_manager_disabled_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerDisabled, g_object_unref)
VALA_EXTERN GType font_manager_unsorted_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUnsorted, g_object_unref)
VALA_EXTERN GType font_manager_language_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerLanguageFilter, g_object_unref)
VALA_EXTERN void font_manager_filter_list_view_on_selection_changed (FontManagerFilterListView* self,
                                                         guint position,
                                                         guint n_items);
VALA_EXTERN void font_manager_filter_list_view_setup_list_row (FontManagerFilterListView* self,
                                                   GtkSignalListItemFactory* factory,
                                                   GObject* item);
VALA_EXTERN void font_manager_filter_list_view_bind_list_row (FontManagerFilterListView* self,
                                                  GtkSignalListItemFactory* factory,
                                                  GObject* item);
VALA_EXTERN void font_manager_category_list_view_select_item (FontManagerCategoryListView* self,
                                                  guint position);
static void font_manager_category_list_view_real_on_selection_changed (FontManagerFilterListView* base,
                                                                guint position,
                                                                guint n_items);
VALA_EXTERN GtkSingleSelection* font_manager_filter_list_view_get_selection (FontManagerFilterListView* self);
VALA_EXTERN GtkTreeListModel* font_manager_filter_list_view_get_treemodel (FontManagerFilterListView* self);
VALA_EXTERN FontManagerFontListFilter* font_manager_filter_list_view_get_selected_item (FontManagerFilterListView* self);
VALA_EXTERN void font_manager_font_list_filter_update (FontManagerFontListFilter* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void font_manager_font_list_filter_update_finish (FontManagerFontListFilter* self,
                                                  GAsyncResult* _res_);
static void font_manager_category_list_view_real_setup_list_row (FontManagerFilterListView* base,
                                                          GtkSignalListItemFactory* factory,
                                                          GObject* item);
VALA_EXTERN void font_manager_tree_list_item_row_set_expander (FontManagerTreeListItemRow* self,
                                                   GtkTreeExpander* value);
VALA_EXTERN void font_manager_tree_list_item_row_set_selection (FontManagerTreeListItemRow* self,
                                                    GtkSelectionModel* value);
static void font_manager_category_list_view_update_disabled (FontManagerCategoryListView* self);
VALA_EXTERN FontManagerDisabled* font_manager_category_list_view_get_disabled (FontManagerCategoryListView* self);
VALA_EXTERN FontManagerReject* font_manager_category_list_view_get_disabled_families (FontManagerCategoryListView* self);
static void __lambda32_ (FontManagerCategoryListView* self,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN FontManagerFontListFilterModel* font_manager_filter_list_view_get_model (FontManagerFilterListView* self);
static void ___lambda32__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void font_manager_category_list_view_update_unsorted (FontManagerCategoryListView* self);
VALA_EXTERN FontManagerUnsorted* font_manager_category_list_view_get_unsorted (FontManagerCategoryListView* self);
VALA_EXTERN void font_manager_unsorted_update (FontManagerUnsorted* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void font_manager_unsorted_update_finish (FontManagerUnsorted* self,
                                          GAsyncResult* _res_);
static void __lambda33_ (FontManagerCategoryListView* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda33__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void font_manager_category_list_view_real_bind_list_row (FontManagerFilterListView* base,
                                                         GtkSignalListItemFactory* factory,
                                                         GObject* item);
VALA_EXTERN void font_manager_list_item_row_set_item (FontManagerListItemRow* self,
                                          GObject* value);
VALA_EXTERN void font_manager_category_list_view_set_disabled (FontManagerCategoryListView* self,
                                                   FontManagerDisabled* value);
VALA_EXTERN void font_manager_category_list_view_set_unsorted (FontManagerCategoryListView* self,
                                                   FontManagerUnsorted* value);
VALA_EXTERN void font_manager_category_list_view_set_language_filter (FontManagerCategoryListView* self,
                                                          FontManagerLanguageFilter* value);
VALA_EXTERN FontManagerLanguageFilter* font_manager_category_list_view_get_language_filter (FontManagerCategoryListView* self);
static void ______lambda34_ (FontManagerCategoryListView* self);
static void _______lambda34__font_manager_cacheable_changed (FontManagerCacheable* _sender,
                                                      gpointer self);
VALA_EXTERN FontManagerCategoryListView* font_manager_category_list_view_new (void);
VALA_EXTERN FontManagerCategoryListView* font_manager_category_list_view_construct (GType object_type);
VALA_EXTERN FontManagerFilterListView* font_manager_filter_list_view_new (void);
VALA_EXTERN FontManagerFilterListView* font_manager_filter_list_view_construct (GType object_type);
VALA_EXTERN void font_manager_category_list_view_set_disabled_families (FontManagerCategoryListView* self,
                                                            FontManagerReject* value);
VALA_EXTERN FontManagerStringSet* font_manager_category_list_view_get_sorted (FontManagerCategoryListView* self);
VALA_EXTERN void font_manager_category_list_view_set_sorted (FontManagerCategoryListView* self,
                                                 FontManagerStringSet* value);
static GObject * font_manager_category_list_view_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static GListModel* _font_manager_category_list_model_get_child_model_gtk_tree_list_model_create_model_func (GObject* item,
                                                                                                     gpointer self);
VALA_EXTERN void font_manager_filter_list_view_set_treemodel (FontManagerFilterListView* self,
                                                  GtkTreeListModel* value);
VALA_EXTERN void font_manager_filter_list_view_set_selection (FontManagerFilterListView* self,
                                                  GtkSingleSelection* value);
static void _font_manager_category_list_view___lambda38_ (FontManagerCategoryListView* self);
static void __font_manager_category_list_view___lambda38__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void _font_manager_category_list_view___lambda39_ (FontManagerCategoryListView* self);
static void __font_manager_category_list_view___lambda39__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void _font_manager_category_list_view___lambda40_ (FontManagerCategoryListView* self);
static void ___lambda41_ (FontManagerCategoryListView* self);
static void ____lambda41__font_manager_string_set_changed (FontManagerStringSet* _sender,
                                                    gpointer self);
static void __font_manager_category_list_view___lambda40__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void font_manager_category_list_view_finalize (GObject * obj);
static GType font_manager_category_list_view_get_type_once (void);
static void _vala_font_manager_category_list_view_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_font_manager_category_list_view_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
VALA_EXTERN GType font_manager_filter_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerFilterData* font_manager_filter_data_dup (const FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_free (FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_copy (const FontManagerFilterData* self,
                                    FontManagerFilterData* dest);
VALA_EXTERN void font_manager_filter_data_destroy (FontManagerFilterData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerFilterData, font_manager_filter_data_destroy)
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN FontManagerCategory* font_manager_category_new (const gchar* name,
                                                const gchar* comment,
                                                const gchar* icon,
                                                const gchar* sql,
                                                gint index);
VALA_EXTERN FontManagerCategory* font_manager_category_construct (GType object_type,
                                                      const gchar* name,
                                                      const gchar* comment,
                                                      const gchar* icon,
                                                      const gchar* sql,
                                                      gint index);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_new (void);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_construct (GType object_type);
VALA_EXTERN GType font_manager_user_fonts_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUserFonts, g_object_unref)
VALA_EXTERN FontManagerDatabase* font_manager_database_proxy_get_default_db (void);
VALA_EXTERN FontManagerCategory* font_manager_construct_panose_filter (void);
VALA_EXTERN FontManagerCategory* font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                                              FontManagerFilterData* data);
VALA_EXTERN FontManagerCategory* font_manager_construct_info_filter (FontManagerDatabase* db,
                                                         FontManagerFilterData* data);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_new (void);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_construct (GType object_type);
VALA_EXTERN FontManagerDisabled* font_manager_disabled_new (void);
VALA_EXTERN FontManagerDisabled* font_manager_disabled_construct (GType object_type);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_new (void);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_construct (GType object_type);
static void __lambda35_ (FontManagerCategory* child);
VALA_EXTERN void font_manager_font_list_filter_set_depth (FontManagerFontListFilter* self,
                                              gint value);
static void ___lambda35__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda36_ (FontManagerCategory* child);
static void ___lambda36__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda37_ (FontManagerCategory* child);
static void ___lambda37__gfunc (gconstpointer data,
                         gpointer self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const FontManagerFilterData FONT_MANAGER_attributes[4] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_WIDTH, N_ ("Width"), N_ ("Grouped by font width"), "width"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_WEIGHT, N_ ("Weight"), N_ ("Grouped by font weight"), "weight"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SLANT, N_ ("Slant"), N_ ("Grouped by font angle"), "slant"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SPACING, N_ ("Spacing"), N_ ("Grouped by font spacing"), "spacing"}};
const FontManagerFilterData FONT_MANAGER_metadata[3] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_LICENSE, N_ ("License"), N_ ("Grouped by license type"), "license-type"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_VENDOR, N_ ("Vendor"), N_ ("Grouped by vendor"), "vendor"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE, N_ ("Filetype"), N_ ("Grouped by filetype"), "filetype"}};

 G_GNUC_NO_INLINE static GType
font_manager_category_index_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_CATEGORY_INDEX_ALL, "FONT_MANAGER_CATEGORY_INDEX_ALL", "all"}, {FONT_MANAGER_CATEGORY_INDEX_SYSTEM, "FONT_MANAGER_CATEGORY_INDEX_SYSTEM", "system"}, {FONT_MANAGER_CATEGORY_INDEX_USER, "FONT_MANAGER_CATEGORY_INDEX_USER", "user"}, {FONT_MANAGER_CATEGORY_INDEX_PANOSE, "FONT_MANAGER_CATEGORY_INDEX_PANOSE", "panose"}, {FONT_MANAGER_CATEGORY_INDEX_WIDTH, "FONT_MANAGER_CATEGORY_INDEX_WIDTH", "width"}, {FONT_MANAGER_CATEGORY_INDEX_WEIGHT, "FONT_MANAGER_CATEGORY_INDEX_WEIGHT", "weight"}, {FONT_MANAGER_CATEGORY_INDEX_SLANT, "FONT_MANAGER_CATEGORY_INDEX_SLANT", "slant"}, {FONT_MANAGER_CATEGORY_INDEX_SPACING, "FONT_MANAGER_CATEGORY_INDEX_SPACING", "spacing"}, {FONT_MANAGER_CATEGORY_INDEX_LICENSE, "FONT_MANAGER_CATEGORY_INDEX_LICENSE", "license"}, {FONT_MANAGER_CATEGORY_INDEX_VENDOR, "FONT_MANAGER_CATEGORY_INDEX_VENDOR", "vendor"}, {FONT_MANAGER_CATEGORY_INDEX_FILETYPE, "FONT_MANAGER_CATEGORY_INDEX_FILETYPE", "filetype"}, {FONT_MANAGER_CATEGORY_INDEX_UNSORTED, "FONT_MANAGER_CATEGORY_INDEX_UNSORTED", "unsorted"}, {FONT_MANAGER_CATEGORY_INDEX_DISABLED, "FONT_MANAGER_CATEGORY_INDEX_DISABLED", "disabled"}, {FONT_MANAGER_CATEGORY_INDEX_LANGUAGE, "FONT_MANAGER_CATEGORY_INDEX_LANGUAGE", "language"}, {FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES, "FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES", "n-categories"}, {0, NULL, NULL}};
	GType font_manager_category_index_type_id;
	font_manager_category_index_type_id = g_enum_register_static ("FontManagerCategoryIndex", values);
	return font_manager_category_index_type_id;
}

GType
font_manager_category_index_get_type (void)
{
	static volatile gsize font_manager_category_index_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_index_type_id__once)) {
		GType font_manager_category_index_type_id;
		font_manager_category_index_type_id = font_manager_category_index_get_type_once ();
		g_once_init_leave (&font_manager_category_index_type_id__once, font_manager_category_index_type_id);
	}
	return font_manager_category_index_type_id__once;
}

FontManagerCategoryListModel*
font_manager_category_list_model_construct (GType object_type)
{
	FontManagerCategoryListModel * self = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
#line 43 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListModel*) font_manager_font_list_filter_model_construct (object_type);
#line 44 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_get_base_categories ();
#line 44 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_model_set_items ((FontManagerFontListFilterModel*) self, _tmp1_);
#line 44 "../src/font-manager/Categories.vala"
	_g_ptr_array_unref0 (_tmp1_);
#line 45 "../src/font-manager/Categories.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) self));
#line 43 "../src/font-manager/Categories.vala"
	return self;
#line 641 "Categories.c"
}

FontManagerCategoryListModel*
font_manager_category_list_model_new (void)
{
#line 43 "../src/font-manager/Categories.vala"
	return font_manager_category_list_model_construct (FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL);
#line 649 "Categories.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/font-manager/Categories.vala"
	return self ? g_object_ref (self) : NULL;
#line 657 "Categories.c"
}

static void
font_manager_category_list_model_on_categories_updated (GObject* source,
                                                        GTask* task)
{
	FontManagerCategoryListModel* model = NULL;
	FontManagerCategoryListModel* _tmp0_;
	GValue _result_ = {0};
	GValue _tmp1_ = {0};
	guint n_items = 0U;
	void* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 48 "../src/font-manager/Categories.vala"
	g_return_if_fail (task != NULL);
#line 49 "../src/font-manager/Categories.vala"
	g_return_if_fail (FONT_MANAGER_IS_CATEGORY_LIST_MODEL (source));
#line 50 "../src/font-manager/Categories.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, FONT_MANAGER_TYPE_CATEGORY_LIST_MODEL, FontManagerCategoryListModel));
#line 50 "../src/font-manager/Categories.vala"
	model = _tmp0_;
#line 51 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp1_, G_TYPE_PTR_ARRAY);
#line 51 "../src/font-manager/Categories.vala"
	_result_ = _tmp1_;
#line 683 "Categories.c"
	{
		GValue _tmp2_ = {0};
#line 53 "../src/font-manager/Categories.vala"
		g_task_propagate_value (task, &_tmp2_, &_inner_error0_);
#line 53 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 53 "../src/font-manager/Categories.vala"
		_result_ = _tmp2_;
#line 53 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 694 "Categories.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 52 "../src/font-manager/Categories.vala"
		e = _inner_error0_;
#line 52 "../src/font-manager/Categories.vala"
		_inner_error0_ = NULL;
#line 55 "../src/font-manager/Categories.vala"
		_tmp3_ = e->message;
#line 55 "../src/font-manager/Categories.vala"
		g_critical ("Categories.vala:55: Failed to generate default categories : %s", _tmp3_);
#line 56 "../src/font-manager/Categories.vala"
		g_return_if_reached ();
#line 52 "../src/font-manager/Categories.vala"
		_g_error_free0 (e);
#line 715 "Categories.c"
	}
	__finally0:
#line 52 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 52 "../src/font-manager/Categories.vala"
		_g_object_unref0 (model);
#line 52 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 52 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 52 "../src/font-manager/Categories.vala"
		return;
#line 730 "Categories.c"
	}
#line 58 "../src/font-manager/Categories.vala"
	n_items = g_list_model_get_n_items ((GListModel*) model);
#line 59 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_model_set_items ((FontManagerFontListFilterModel*) model, NULL);
#line 60 "../src/font-manager/Categories.vala"
	g_list_model_items_changed ((GListModel*) model, (guint) 0, n_items, (guint) 0);
#line 61 "../src/font-manager/Categories.vala"
	_tmp4_ = g_value_get_boxed (&_result_);
#line 61 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_model_set_items ((FontManagerFontListFilterModel*) model, (GPtrArray*) _tmp4_);
#line 62 "../src/font-manager/Categories.vala"
	g_list_model_items_changed ((GListModel*) model, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) model));
#line 63 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 63 "../src/font-manager/Categories.vala"
	_g_object_unref0 (model);
#line 63 "../src/font-manager/Categories.vala"
	return;
#line 750 "Categories.c"
}

static void
_font_manager_category_list_model_on_categories_updated_gasync_ready_callback (GObject* source_object,
                                                                               GTask* task,
                                                                               gpointer self)
{
#line 67 "../src/font-manager/Categories.vala"
	font_manager_category_list_model_on_categories_updated (source_object, task);
#line 760 "Categories.c"
}

static void
_font_manager_get_default_categories_gtask_thread_func (GTask* task,
                                                        GObject* source_object,
                                                        void* task_data,
                                                        GCancellable* cancellable)
{
#line 68 "../src/font-manager/Categories.vala"
	font_manager_get_default_categories (task, source_object, task_data, cancellable);
#line 771 "Categories.c"
}

void
font_manager_category_list_model_update_items (FontManagerCategoryListModel* self)
{
	GTask* task = NULL;
	GTask* _tmp0_;
#line 66 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/font-manager/Categories.vala"
	_tmp0_ = g_task_new ((GObject*) self, NULL, _font_manager_category_list_model_on_categories_updated_gasync_ready_callback, NULL);
#line 67 "../src/font-manager/Categories.vala"
	task = _tmp0_;
#line 68 "../src/font-manager/Categories.vala"
	g_task_run_in_thread (task, _font_manager_get_default_categories_gtask_thread_func);
#line 69 "../src/font-manager/Categories.vala"
	_g_object_unref0 (task);
#line 69 "../src/font-manager/Categories.vala"
	return;
#line 791 "Categories.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5954 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5955 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5955 "glib-2.0.vapi"
	return result;
#line 804 "Categories.c"
}

GListModel*
font_manager_category_list_model_get_child_model (GObject* item)
{
	FontManagerCategory* category = NULL;
	FontManagerCategory* _tmp0_;
	FontManagerCategory* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	FontManagerCategoryListModel* child = NULL;
	FontManagerCategoryListModel* _tmp6_;
	FontManagerCategoryListModel* _tmp7_;
	FontManagerCategory* _tmp8_;
	GPtrArray* _tmp9_;
	GPtrArray* _tmp10_;
	GListModel* result;
#line 72 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 73 "../src/font-manager/Categories.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (item, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 73 "../src/font-manager/Categories.vala"
	category = _tmp0_;
#line 74 "../src/font-manager/Categories.vala"
	_tmp1_ = category;
#line 74 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_category_get_children (_tmp1_);
#line 74 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 74 "../src/font-manager/Categories.vala"
	_tmp4_ = vala_g_ptr_array_get_length (_tmp3_);
#line 74 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 74 "../src/font-manager/Categories.vala"
	if (_tmp5_ < 1) {
#line 75 "../src/font-manager/Categories.vala"
		result = NULL;
#line 75 "../src/font-manager/Categories.vala"
		_g_object_unref0 (category);
#line 75 "../src/font-manager/Categories.vala"
		return result;
#line 848 "Categories.c"
	}
#line 76 "../src/font-manager/Categories.vala"
	_tmp6_ = font_manager_category_list_model_new ();
#line 76 "../src/font-manager/Categories.vala"
	child = _tmp6_;
#line 77 "../src/font-manager/Categories.vala"
	_tmp7_ = child;
#line 77 "../src/font-manager/Categories.vala"
	_tmp8_ = category;
#line 77 "../src/font-manager/Categories.vala"
	_tmp9_ = font_manager_category_get_children (_tmp8_);
#line 77 "../src/font-manager/Categories.vala"
	_tmp10_ = _tmp9_;
#line 77 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_model_set_items ((FontManagerFontListFilterModel*) _tmp7_, _tmp10_);
#line 78 "../src/font-manager/Categories.vala"
	result = (GListModel*) child;
#line 78 "../src/font-manager/Categories.vala"
	_g_object_unref0 (category);
#line 78 "../src/font-manager/Categories.vala"
	return result;
#line 870 "Categories.c"
}

static void
font_manager_category_list_model_class_init (FontManagerCategoryListModelClass * klass,
                                             gpointer klass_data)
{
#line 41 "../src/font-manager/Categories.vala"
	font_manager_category_list_model_parent_class = g_type_class_peek_parent (klass);
#line 879 "Categories.c"
}

static void
font_manager_category_list_model_instance_init (FontManagerCategoryListModel * self,
                                                gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
font_manager_category_list_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryListModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_list_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryListModel), 0, (GInstanceInitFunc) font_manager_category_list_model_instance_init, NULL };
	GType font_manager_category_list_model_type_id;
	font_manager_category_list_model_type_id = g_type_register_static (FONT_MANAGER_TYPE_FONT_LIST_FILTER_MODEL, "FontManagerCategoryListModel", &g_define_type_info, 0);
	return font_manager_category_list_model_type_id;
}

GType
font_manager_category_list_model_get_type (void)
{
	static volatile gsize font_manager_category_list_model_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_list_model_type_id__once)) {
		GType font_manager_category_list_model_type_id;
		font_manager_category_list_model_type_id = font_manager_category_list_model_get_type_once ();
		g_once_init_leave (&font_manager_category_list_model_type_id__once, font_manager_category_list_model_type_id);
	}
	return font_manager_category_list_model_type_id__once;
}

static inline gpointer
font_manager_category_list_row_get_instance_private (FontManagerCategoryListRow* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryListRow_private_offset);
}

static void
font_manager_category_list_row_real_reset (FontManagerListItemRow* base)
{
	FontManagerCategoryListRow * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
#line 87 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListRow*) base;
#line 88 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_list_item_row_get_item_label ((FontManagerListItemRow*) self);
#line 88 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 88 "../src/font-manager/Categories.vala"
	gtk_label_set_text (_tmp1_, "");
#line 89 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_list_item_row_get_item_count ((FontManagerListItemRow*) self);
#line 89 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 89 "../src/font-manager/Categories.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 90 "../src/font-manager/Categories.vala"
	_tmp4_ = font_manager_list_item_row_get_item_count ((FontManagerListItemRow*) self);
#line 90 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 90 "../src/font-manager/Categories.vala"
	gtk_label_set_label (_tmp5_, "");
#line 91 "../src/font-manager/Categories.vala"
	if (self->priv->handler_id != ((gulong) 0)) {
#line 947 "Categories.c"
		GObject* _tmp6_;
		GObject* _tmp7_;
#line 92 "../src/font-manager/Categories.vala"
		_tmp6_ = font_manager_list_item_row_get_item ((FontManagerListItemRow*) self);
#line 92 "../src/font-manager/Categories.vala"
		_tmp7_ = _tmp6_;
#line 92 "../src/font-manager/Categories.vala"
		g_signal_handler_disconnect (_tmp7_, self->priv->handler_id);
#line 956 "Categories.c"
	}
#line 93 "../src/font-manager/Categories.vala"
	return;
#line 960 "Categories.c"
}

static void
_font_manager_list_item_row_on_item_set_font_manager_cacheable_changed (FontManagerCacheable* _sender,
                                                                        gpointer self)
{
#line 101 "../src/font-manager/Categories.vala"
	font_manager_list_item_row_on_item_set ((FontManagerListItemRow*) self);
#line 969 "Categories.c"
}

static void
font_manager_category_list_row_real_on_item_set (FontManagerListItemRow* base)
{
	FontManagerCategoryListRow * self;
	GObject* _tmp0_;
	GObject* _tmp1_;
	FontManagerCategory* category = NULL;
	GObject* _tmp2_;
	GObject* _tmp3_;
	FontManagerCategory* _tmp4_;
	FontManagerCategory* _tmp5_;
	gulong _tmp6_;
	gint index = 0;
	FontManagerCategory* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean root_node = FALSE;
	FontManagerCategory* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean root_count = FALSE;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	FontManagerCategory* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	gboolean _tmp25_ = FALSE;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	gboolean _tmp30_ = FALSE;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	FontManagerCategory* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* _tmp43_;
	FontManagerCategory* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_ = NULL;
	FontManagerCategory* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gboolean _tmp54_;
#line 96 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListRow*) base;
#line 97 "../src/font-manager/Categories.vala"
	font_manager_list_item_row_reset ((FontManagerListItemRow*) self);
#line 98 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_list_item_row_get_item ((FontManagerListItemRow*) self);
#line 98 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 98 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 99 "../src/font-manager/Categories.vala"
		return;
#line 1038 "Categories.c"
	}
#line 100 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_list_item_row_get_item ((FontManagerListItemRow*) self);
#line 100 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/font-manager/Categories.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 100 "../src/font-manager/Categories.vala"
	category = _tmp4_;
#line 101 "../src/font-manager/Categories.vala"
	_tmp5_ = category;
#line 101 "../src/font-manager/Categories.vala"
	_tmp6_ = g_signal_connect_object ((FontManagerCacheable*) _tmp5_, "changed", (GCallback) _font_manager_list_item_row_on_item_set_font_manager_cacheable_changed, (FontManagerListItemRow*) self, 0);
#line 101 "../src/font-manager/Categories.vala"
	self->priv->handler_id = _tmp6_;
#line 102 "../src/font-manager/Categories.vala"
	_tmp7_ = category;
#line 102 "../src/font-manager/Categories.vala"
	_tmp8_ = font_manager_font_list_filter_get_index ((FontManagerFontListFilter*) _tmp7_);
#line 102 "../src/font-manager/Categories.vala"
	_tmp9_ = _tmp8_;
#line 102 "../src/font-manager/Categories.vala"
	index = _tmp9_;
#line 103 "../src/font-manager/Categories.vala"
	_tmp10_ = category;
#line 103 "../src/font-manager/Categories.vala"
	_tmp11_ = font_manager_font_list_filter_get_depth ((FontManagerFontListFilter*) _tmp10_);
#line 103 "../src/font-manager/Categories.vala"
	_tmp12_ = _tmp11_;
#line 103 "../src/font-manager/Categories.vala"
	root_node = _tmp12_ < 1;
#line 104 "../src/font-manager/Categories.vala"
	if (root_node) {
#line 1072 "Categories.c"
		gboolean _tmp14_ = FALSE;
#line 105 "../src/font-manager/Categories.vala"
		if (index < ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE)) {
#line 105 "../src/font-manager/Categories.vala"
			_tmp14_ = TRUE;
#line 1078 "Categories.c"
		} else {
#line 105 "../src/font-manager/Categories.vala"
			_tmp14_ = index > ((gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE);
#line 1082 "Categories.c"
		}
#line 105 "../src/font-manager/Categories.vala"
		_tmp13_ = _tmp14_;
#line 1086 "Categories.c"
	} else {
#line 104 "../src/font-manager/Categories.vala"
		_tmp13_ = FALSE;
#line 1090 "Categories.c"
	}
#line 104 "../src/font-manager/Categories.vala"
	root_count = _tmp13_;
#line 106 "../src/font-manager/Categories.vala"
	_tmp15_ = font_manager_list_item_row_get_item_label ((FontManagerListItemRow*) self);
#line 106 "../src/font-manager/Categories.vala"
	_tmp16_ = _tmp15_;
#line 106 "../src/font-manager/Categories.vala"
	_tmp17_ = category;
#line 106 "../src/font-manager/Categories.vala"
	_tmp18_ = font_manager_font_list_filter_get_name ((FontManagerFontListFilter*) _tmp17_);
#line 106 "../src/font-manager/Categories.vala"
	_tmp19_ = _tmp18_;
#line 106 "../src/font-manager/Categories.vala"
	_tmp20_ = _tmp19_;
#line 106 "../src/font-manager/Categories.vala"
	gtk_label_set_text (_tmp16_, _tmp20_);
#line 106 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp20_);
#line 107 "../src/font-manager/Categories.vala"
	if (root_count) {
#line 107 "../src/font-manager/Categories.vala"
		_tmp21_ = TRUE;
#line 1114 "Categories.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 107 "../src/font-manager/Categories.vala"
		if (root_node) {
#line 107 "../src/font-manager/Categories.vala"
			_tmp22_ = index == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
#line 1121 "Categories.c"
		} else {
#line 107 "../src/font-manager/Categories.vala"
			_tmp22_ = FALSE;
#line 1125 "Categories.c"
		}
#line 107 "../src/font-manager/Categories.vala"
		_tmp21_ = _tmp22_;
#line 1129 "Categories.c"
	}
#line 107 "../src/font-manager/Categories.vala"
	_tmp23_ = font_manager_list_item_row_get_item_icon ((FontManagerListItemRow*) self);
#line 107 "../src/font-manager/Categories.vala"
	_tmp24_ = _tmp23_;
#line 107 "../src/font-manager/Categories.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp24_, _tmp21_);
#line 108 "../src/font-manager/Categories.vala"
	if (!root_node) {
#line 108 "../src/font-manager/Categories.vala"
		_tmp25_ = TRUE;
#line 1141 "Categories.c"
	} else {
#line 108 "../src/font-manager/Categories.vala"
		_tmp25_ = root_count;
#line 1145 "Categories.c"
	}
#line 108 "../src/font-manager/Categories.vala"
	_tmp26_ = font_manager_list_item_row_get_item_count ((FontManagerListItemRow*) self);
#line 108 "../src/font-manager/Categories.vala"
	_tmp27_ = _tmp26_;
#line 108 "../src/font-manager/Categories.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp27_, _tmp25_);
#line 109 "../src/font-manager/Categories.vala"
	if (index == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE)) {
#line 1155 "Categories.c"
		GtkLabel* _tmp28_;
		GtkLabel* _tmp29_;
#line 110 "../src/font-manager/Categories.vala"
		_tmp28_ = font_manager_list_item_row_get_item_label ((FontManagerListItemRow*) self);
#line 110 "../src/font-manager/Categories.vala"
		_tmp29_ = _tmp28_;
#line 110 "../src/font-manager/Categories.vala"
		gtk_label_set_ellipsize (_tmp29_, PANGO_ELLIPSIZE_NONE);
#line 1164 "Categories.c"
	}
#line 111 "../src/font-manager/Categories.vala"
	if (root_node) {
#line 1168 "Categories.c"
		gboolean _tmp31_ = FALSE;
#line 112 "../src/font-manager/Categories.vala"
		if (index >= ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE)) {
#line 113 "../src/font-manager/Categories.vala"
			_tmp31_ = index <= ((gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE);
#line 1174 "Categories.c"
		} else {
#line 112 "../src/font-manager/Categories.vala"
			_tmp31_ = FALSE;
#line 1178 "Categories.c"
		}
#line 112 "../src/font-manager/Categories.vala"
		_tmp30_ = _tmp31_;
#line 1182 "Categories.c"
	} else {
#line 111 "../src/font-manager/Categories.vala"
		_tmp30_ = FALSE;
#line 1186 "Categories.c"
	}
#line 111 "../src/font-manager/Categories.vala"
	if (_tmp30_) {
#line 1190 "Categories.c"
		GtkLabel* _tmp32_;
		GtkLabel* _tmp33_;
#line 114 "../src/font-manager/Categories.vala"
		_tmp32_ = font_manager_list_item_row_get_item_label ((FontManagerListItemRow*) self);
#line 114 "../src/font-manager/Categories.vala"
		_tmp33_ = _tmp32_;
#line 114 "../src/font-manager/Categories.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 3);
#line 1199 "Categories.c"
	} else {
#line 115 "../src/font-manager/Categories.vala"
		if (!root_node) {
#line 1203 "Categories.c"
			GtkLabel* _tmp34_;
			GtkLabel* _tmp35_;
#line 116 "../src/font-manager/Categories.vala"
			_tmp34_ = font_manager_list_item_row_get_item_label ((FontManagerListItemRow*) self);
#line 116 "../src/font-manager/Categories.vala"
			_tmp35_ = _tmp34_;
#line 116 "../src/font-manager/Categories.vala"
			gtk_widget_set_margin_start ((GtkWidget*) _tmp35_, 0);
#line 1212 "Categories.c"
		}
	}
#line 117 "../src/font-manager/Categories.vala"
	_tmp36_ = font_manager_list_item_row_get_item_icon ((FontManagerListItemRow*) self);
#line 117 "../src/font-manager/Categories.vala"
	_tmp37_ = _tmp36_;
#line 117 "../src/font-manager/Categories.vala"
	_tmp38_ = category;
#line 117 "../src/font-manager/Categories.vala"
	_tmp39_ = font_manager_font_list_filter_get_icon ((FontManagerFontListFilter*) _tmp38_);
#line 117 "../src/font-manager/Categories.vala"
	_tmp40_ = _tmp39_;
#line 117 "../src/font-manager/Categories.vala"
	_tmp41_ = _tmp40_;
#line 117 "../src/font-manager/Categories.vala"
	gtk_image_set_from_icon_name (_tmp37_, _tmp41_);
#line 117 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp41_);
#line 118 "../src/font-manager/Categories.vala"
	_tmp42_ = font_manager_list_item_row_get_item_count ((FontManagerListItemRow*) self);
#line 118 "../src/font-manager/Categories.vala"
	_tmp43_ = _tmp42_;
#line 118 "../src/font-manager/Categories.vala"
	_tmp44_ = category;
#line 118 "../src/font-manager/Categories.vala"
	_tmp45_ = font_manager_font_list_filter_get_size ((FontManagerFontListFilter*) _tmp44_);
#line 118 "../src/font-manager/Categories.vala"
	_tmp46_ = _tmp45_;
#line 118 "../src/font-manager/Categories.vala"
	_tmp47_ = g_strdup_printf ("%i", _tmp46_);
#line 118 "../src/font-manager/Categories.vala"
	_tmp48_ = _tmp47_;
#line 118 "../src/font-manager/Categories.vala"
	gtk_label_set_label (_tmp43_, _tmp48_);
#line 118 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp48_);
#line 119 "../src/font-manager/Categories.vala"
	_tmp50_ = category;
#line 119 "../src/font-manager/Categories.vala"
	_tmp51_ = font_manager_font_list_filter_get_comment ((FontManagerFontListFilter*) _tmp50_);
#line 119 "../src/font-manager/Categories.vala"
	_tmp52_ = _tmp51_;
#line 119 "../src/font-manager/Categories.vala"
	_tmp53_ = _tmp52_;
#line 119 "../src/font-manager/Categories.vala"
	_tmp54_ = _tmp53_ != NULL;
#line 119 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp53_);
#line 119 "../src/font-manager/Categories.vala"
	if (_tmp54_) {
#line 1263 "Categories.c"
		FontManagerCategory* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 119 "../src/font-manager/Categories.vala"
		_tmp55_ = category;
#line 119 "../src/font-manager/Categories.vala"
		_tmp56_ = font_manager_font_list_filter_get_comment ((FontManagerFontListFilter*) _tmp55_);
#line 119 "../src/font-manager/Categories.vala"
		_tmp57_ = _tmp56_;
#line 119 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp49_);
#line 119 "../src/font-manager/Categories.vala"
		_tmp49_ = _tmp57_;
#line 1277 "Categories.c"
	} else {
		FontManagerCategory* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
#line 119 "../src/font-manager/Categories.vala"
		_tmp58_ = category;
#line 119 "../src/font-manager/Categories.vala"
		_tmp59_ = font_manager_font_list_filter_get_name ((FontManagerFontListFilter*) _tmp58_);
#line 119 "../src/font-manager/Categories.vala"
		_tmp60_ = _tmp59_;
#line 119 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp49_);
#line 119 "../src/font-manager/Categories.vala"
		_tmp49_ = _tmp60_;
#line 1292 "Categories.c"
	}
#line 119 "../src/font-manager/Categories.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp49_);
#line 120 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp49_);
#line 120 "../src/font-manager/Categories.vala"
	_g_object_unref0 (category);
#line 120 "../src/font-manager/Categories.vala"
	return;
#line 1302 "Categories.c"
}

FontManagerCategoryListRow*
font_manager_category_list_row_construct (GType object_type)
{
	FontManagerCategoryListRow * self = NULL;
#line 83 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListRow*) font_manager_tree_list_item_row_construct (object_type);
#line 83 "../src/font-manager/Categories.vala"
	return self;
#line 1313 "Categories.c"
}

FontManagerCategoryListRow*
font_manager_category_list_row_new (void)
{
#line 83 "../src/font-manager/Categories.vala"
	return font_manager_category_list_row_construct (FONT_MANAGER_TYPE_CATEGORY_LIST_ROW);
#line 1321 "Categories.c"
}

static void
font_manager_category_list_row_class_init (FontManagerCategoryListRowClass * klass,
                                           gpointer klass_data)
{
#line 83 "../src/font-manager/Categories.vala"
	font_manager_category_list_row_parent_class = g_type_class_peek_parent (klass);
#line 83 "../src/font-manager/Categories.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryListRow_private_offset);
#line 83 "../src/font-manager/Categories.vala"
	((FontManagerListItemRowClass *) klass)->reset = (void (*) (FontManagerListItemRow*)) font_manager_category_list_row_real_reset;
#line 83 "../src/font-manager/Categories.vala"
	((FontManagerListItemRowClass *) klass)->on_item_set = (void (*) (FontManagerListItemRow*)) font_manager_category_list_row_real_on_item_set;
#line 83 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_list_row_finalize;
#line 1338 "Categories.c"
}

static void
font_manager_category_list_row_instance_init (FontManagerCategoryListRow * self,
                                              gpointer klass)
{
#line 83 "../src/font-manager/Categories.vala"
	self->priv = font_manager_category_list_row_get_instance_private (self);
#line 85 "../src/font-manager/Categories.vala"
	self->priv->handler_id = (gulong) 0;
#line 1349 "Categories.c"
}

static void
font_manager_category_list_row_finalize (GObject * obj)
{
	FontManagerCategoryListRow * self;
#line 83 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_LIST_ROW, FontManagerCategoryListRow);
#line 83 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (font_manager_category_list_row_parent_class)->finalize (obj);
#line 1360 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_category_list_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryListRow), 0, (GInstanceInitFunc) font_manager_category_list_row_instance_init, NULL };
	GType font_manager_category_list_row_type_id;
	font_manager_category_list_row_type_id = g_type_register_static (FONT_MANAGER_TYPE_TREE_LIST_ITEM_ROW, "FontManagerCategoryListRow", &g_define_type_info, 0);
	FontManagerCategoryListRow_private_offset = g_type_add_instance_private (font_manager_category_list_row_type_id, sizeof (FontManagerCategoryListRowPrivate));
	return font_manager_category_list_row_type_id;
}

GType
font_manager_category_list_row_get_type (void)
{
	static volatile gsize font_manager_category_list_row_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_list_row_type_id__once)) {
		GType font_manager_category_list_row_type_id;
		font_manager_category_list_row_type_id = font_manager_category_list_row_get_type_once ();
		g_once_init_leave (&font_manager_category_list_row_type_id__once, font_manager_category_list_row_type_id);
	}
	return font_manager_category_list_row_type_id__once;
}

static inline gpointer
font_manager_category_list_view_get_instance_private (FontManagerCategoryListView* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryListView_private_offset);
}

void
font_manager_category_list_view_select_item (FontManagerCategoryListView* self,
                                             guint position)
{
	GtkListView* _tmp0_;
	GtkListView* _tmp1_;
#line 150 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/font-manager/Categories.vala"
	_tmp0_ = ((FontManagerFilterListView*) self)->listview;
#line 151 "../src/font-manager/Categories.vala"
	gtk_widget_activate_action ((GtkWidget*) _tmp0_, "list.select-item", "(ubb)", position, FALSE, FALSE, NULL);
#line 152 "../src/font-manager/Categories.vala"
	_tmp1_ = ((FontManagerFilterListView*) self)->listview;
#line 152 "../src/font-manager/Categories.vala"
	gtk_widget_activate_action ((GtkWidget*) _tmp1_, "list.scroll-to-item", "u", position, NULL);
#line 153 "../src/font-manager/Categories.vala"
	return;
#line 1409 "Categories.c"
}

static void
font_manager_category_list_view_real_on_selection_changed (FontManagerFilterListView* base,
                                                           guint position,
                                                           guint n_items)
{
	FontManagerCategoryListView * self;
	GtkSingleSelection* _tmp0_;
	GtkSingleSelection* _tmp1_;
	GtkTreeListModel* _tmp2_;
	GtkTreeListModel* _tmp3_;
	FontManagerFontListFilter* _tmp4_;
	FontManagerFontListFilter* _tmp5_;
	FontManagerCategory* category = NULL;
	FontManagerFontListFilter* _tmp6_;
	FontManagerFontListFilter* _tmp7_;
	FontManagerCategory* _tmp8_;
	gboolean _tmp9_ = FALSE;
	FontManagerCategory* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 156 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListView*) base;
#line 156 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_filter_list_view_get_selection ((FontManagerFilterListView*) self);
#line 156 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 156 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_filter_list_view_get_treemodel ((FontManagerFilterListView*) self);
#line 156 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 156 "../src/font-manager/Categories.vala"
	_vala_return_if_fail ((_tmp1_ != NULL) && (_tmp3_ != NULL), "selection != null && treemodel != null");
#line 158 "../src/font-manager/Categories.vala"
	FONT_MANAGER_FILTER_LIST_VIEW_CLASS (font_manager_category_list_view_parent_class)->on_selection_changed (G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_FILTER_LIST_VIEW, FontManagerFilterListView), position, n_items);
#line 159 "../src/font-manager/Categories.vala"
	_tmp4_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 159 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 159 "../src/font-manager/Categories.vala"
	if (_tmp5_ == NULL) {
#line 160 "../src/font-manager/Categories.vala"
		return;
#line 1454 "Categories.c"
	}
#line 161 "../src/font-manager/Categories.vala"
	_tmp6_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 161 "../src/font-manager/Categories.vala"
	_tmp7_ = _tmp6_;
#line 161 "../src/font-manager/Categories.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 161 "../src/font-manager/Categories.vala"
	category = _tmp8_;
#line 162 "../src/font-manager/Categories.vala"
	_tmp10_ = category;
#line 162 "../src/font-manager/Categories.vala"
	_tmp11_ = font_manager_font_list_filter_get_index ((FontManagerFontListFilter*) _tmp10_);
#line 162 "../src/font-manager/Categories.vala"
	_tmp12_ = _tmp11_;
#line 162 "../src/font-manager/Categories.vala"
	if (_tmp12_ >= ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE)) {
#line 162 "../src/font-manager/Categories.vala"
		_tmp9_ = TRUE;
#line 1474 "Categories.c"
	} else {
		FontManagerCategory* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 162 "../src/font-manager/Categories.vala"
		_tmp13_ = category;
#line 162 "../src/font-manager/Categories.vala"
		_tmp14_ = font_manager_font_list_filter_get_index ((FontManagerFontListFilter*) _tmp13_);
#line 162 "../src/font-manager/Categories.vala"
		_tmp15_ = _tmp14_;
#line 162 "../src/font-manager/Categories.vala"
		_tmp9_ = _tmp15_ <= ((gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE);
#line 1487 "Categories.c"
	}
#line 162 "../src/font-manager/Categories.vala"
	if (_tmp9_) {
#line 1491 "Categories.c"
		FontManagerCategory* _tmp16_;
#line 163 "../src/font-manager/Categories.vala"
		_tmp16_ = category;
#line 163 "../src/font-manager/Categories.vala"
		font_manager_font_list_filter_update ((FontManagerFontListFilter*) _tmp16_, NULL, NULL);
#line 1497 "Categories.c"
	}
#line 164 "../src/font-manager/Categories.vala"
	_g_object_unref0 (category);
#line 164 "../src/font-manager/Categories.vala"
	return;
#line 1503 "Categories.c"
}

static void
font_manager_category_list_view_real_setup_list_row (FontManagerFilterListView* base,
                                                     GtkSignalListItemFactory* factory,
                                                     GObject* item)
{
	FontManagerCategoryListView * self;
	GtkListItem* list_item = NULL;
	GtkListItem* _tmp0_;
	GtkTreeExpander* tree_expander = NULL;
	GtkTreeExpander* _tmp1_;
	FontManagerCategoryListRow* row = NULL;
	FontManagerCategoryListRow* _tmp2_;
	GtkSingleSelection* _tmp3_;
	GtkSingleSelection* _tmp4_;
#line 167 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListView*) base;
#line 167 "../src/font-manager/Categories.vala"
	g_return_if_fail (factory != NULL);
#line 167 "../src/font-manager/Categories.vala"
	g_return_if_fail (item != NULL);
#line 168 "../src/font-manager/Categories.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (item, gtk_list_item_get_type (), GtkListItem));
#line 168 "../src/font-manager/Categories.vala"
	list_item = _tmp0_;
#line 169 "../src/font-manager/Categories.vala"
	_tmp1_ = (GtkTreeExpander*) gtk_tree_expander_new ();
#line 169 "../src/font-manager/Categories.vala"
	g_object_ref_sink (_tmp1_);
#line 169 "../src/font-manager/Categories.vala"
	tree_expander = _tmp1_;
#line 170 "../src/font-manager/Categories.vala"
	gtk_tree_expander_set_indent_for_icon (tree_expander, FALSE);
#line 171 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_category_list_row_new ();
#line 171 "../src/font-manager/Categories.vala"
	g_object_ref_sink (_tmp2_);
#line 171 "../src/font-manager/Categories.vala"
	row = _tmp2_;
#line 172 "../src/font-manager/Categories.vala"
	font_manager_tree_list_item_row_set_expander ((FontManagerTreeListItemRow*) row, tree_expander);
#line 173 "../src/font-manager/Categories.vala"
	_tmp3_ = font_manager_filter_list_view_get_selection ((FontManagerFilterListView*) self);
#line 173 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_;
#line 173 "../src/font-manager/Categories.vala"
	font_manager_tree_list_item_row_set_selection ((FontManagerTreeListItemRow*) row, (GtkSelectionModel*) _tmp4_);
#line 174 "../src/font-manager/Categories.vala"
	gtk_tree_expander_set_child (tree_expander, (GtkWidget*) row);
#line 175 "../src/font-manager/Categories.vala"
	gtk_list_item_set_child (list_item, (GtkWidget*) tree_expander);
#line 176 "../src/font-manager/Categories.vala"
	_g_object_unref0 (row);
#line 176 "../src/font-manager/Categories.vala"
	_g_object_unref0 (tree_expander);
#line 176 "../src/font-manager/Categories.vala"
	_g_object_unref0 (list_item);
#line 176 "../src/font-manager/Categories.vala"
	return;
#line 1564 "Categories.c"
}

static void
__lambda32_ (FontManagerCategoryListView* self,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerDisabled* _tmp0_;
	FontManagerFontListFilterModel* _tmp1_;
	FontManagerFontListFilterModel* _tmp2_;
	FontManagerFontListFilter* _tmp3_;
	FontManagerFontListFilter* _tmp4_;
#line 182 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 183 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_disabled;
#line 183 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_update_finish ((FontManagerFontListFilter*) _tmp0_, res);
#line 184 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_filter_list_view_get_model ((FontManagerFilterListView*) self);
#line 184 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 184 "../src/font-manager/Categories.vala"
	g_list_model_items_changed ((GListModel*) _tmp2_, (guint) 0, (guint) 0, (guint) 0);
#line 185 "../src/font-manager/Categories.vala"
	_tmp3_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 185 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_;
#line 185 "../src/font-manager/Categories.vala"
	if (FONT_MANAGER_IS_DISABLED (_tmp4_)) {
#line 1595 "Categories.c"
		FontManagerFontListFilter* _tmp5_;
		FontManagerFontListFilter* _tmp6_;
#line 186 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", NULL);
#line 187 "../src/font-manager/Categories.vala"
		_tmp5_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 187 "../src/font-manager/Categories.vala"
		_tmp6_ = _tmp5_;
#line 187 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", _tmp6_);
#line 1606 "Categories.c"
	}
}

static void
___lambda32__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 182 "../src/font-manager/Categories.vala"
	__lambda32_ ((FontManagerCategoryListView*) self, source_object, res);
#line 182 "../src/font-manager/Categories.vala"
	g_object_unref (self);
#line 1619 "Categories.c"
}

static void
font_manager_category_list_view_update_disabled (FontManagerCategoryListView* self)
{
	gboolean _tmp0_ = FALSE;
	FontManagerDisabled* _tmp1_;
	FontManagerDisabled* _tmp3_;
#line 179 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_disabled;
#line 180 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 180 "../src/font-manager/Categories.vala"
		_tmp0_ = TRUE;
#line 1636 "Categories.c"
	} else {
		FontManagerReject* _tmp2_;
#line 180 "../src/font-manager/Categories.vala"
		_tmp2_ = self->priv->_disabled_families;
#line 180 "../src/font-manager/Categories.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1643 "Categories.c"
	}
#line 180 "../src/font-manager/Categories.vala"
	if (_tmp0_) {
#line 181 "../src/font-manager/Categories.vala"
		return;
#line 1649 "Categories.c"
	}
#line 182 "../src/font-manager/Categories.vala"
	_tmp3_ = self->priv->_disabled;
#line 182 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_update ((FontManagerFontListFilter*) _tmp3_, ___lambda32__gasync_ready_callback, g_object_ref (self));
#line 190 "../src/font-manager/Categories.vala"
	return;
#line 1657 "Categories.c"
}

static void
__lambda33_ (FontManagerCategoryListView* self,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerUnsorted* _tmp0_;
	FontManagerFontListFilterModel* _tmp1_;
	FontManagerFontListFilterModel* _tmp2_;
	FontManagerFontListFilter* _tmp3_;
	FontManagerFontListFilter* _tmp4_;
#line 196 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 197 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_unsorted;
#line 197 "../src/font-manager/Categories.vala"
	font_manager_unsorted_update_finish (_tmp0_, res);
#line 198 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_filter_list_view_get_model ((FontManagerFilterListView*) self);
#line 198 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 198 "../src/font-manager/Categories.vala"
	g_list_model_items_changed ((GListModel*) _tmp2_, (guint) 0, (guint) 0, (guint) 0);
#line 199 "../src/font-manager/Categories.vala"
	_tmp3_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 199 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_;
#line 199 "../src/font-manager/Categories.vala"
	if (FONT_MANAGER_IS_UNSORTED (_tmp4_)) {
#line 1688 "Categories.c"
		FontManagerFontListFilter* _tmp5_;
		FontManagerFontListFilter* _tmp6_;
#line 200 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", NULL);
#line 201 "../src/font-manager/Categories.vala"
		_tmp5_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 201 "../src/font-manager/Categories.vala"
		_tmp6_ = _tmp5_;
#line 201 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", _tmp6_);
#line 1699 "Categories.c"
	}
}

static void
___lambda33__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 196 "../src/font-manager/Categories.vala"
	__lambda33_ ((FontManagerCategoryListView*) self, source_object, res);
#line 196 "../src/font-manager/Categories.vala"
	g_object_unref (self);
#line 1712 "Categories.c"
}

static void
font_manager_category_list_view_update_unsorted (FontManagerCategoryListView* self)
{
	FontManagerUnsorted* _tmp0_;
	FontManagerUnsorted* _tmp1_;
#line 193 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_unsorted;
#line 194 "../src/font-manager/Categories.vala"
	if (_tmp0_ == NULL) {
#line 195 "../src/font-manager/Categories.vala"
		return;
#line 1728 "Categories.c"
	}
#line 196 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_unsorted;
#line 196 "../src/font-manager/Categories.vala"
	font_manager_unsorted_update (_tmp1_, ___lambda33__gasync_ready_callback, g_object_ref (self));
#line 204 "../src/font-manager/Categories.vala"
	return;
#line 1736 "Categories.c"
}

static void
______lambda34_ (FontManagerCategoryListView* self)
{
	FontManagerFontListFilter* _tmp0_;
	FontManagerFontListFilter* _tmp1_;
#line 234 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 234 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 234 "../src/font-manager/Categories.vala"
	if (FONT_MANAGER_IS_LANGUAGE_FILTER (_tmp1_)) {
#line 1750 "Categories.c"
		FontManagerFontListFilter* _tmp2_;
		FontManagerFontListFilter* _tmp3_;
#line 235 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", NULL);
#line 236 "../src/font-manager/Categories.vala"
		_tmp2_ = font_manager_filter_list_view_get_selected_item ((FontManagerFilterListView*) self);
#line 236 "../src/font-manager/Categories.vala"
		_tmp3_ = _tmp2_;
#line 236 "../src/font-manager/Categories.vala"
		g_signal_emit_by_name ((FontManagerFilterListView*) self, "selection-changed", _tmp3_);
#line 1761 "Categories.c"
	}
}

static void
_______lambda34__font_manager_cacheable_changed (FontManagerCacheable* _sender,
                                                 gpointer self)
{
#line 233 "../src/font-manager/Categories.vala"
	______lambda34_ ((FontManagerCategoryListView*) self);
#line 1771 "Categories.c"
}

static void
font_manager_category_list_view_real_bind_list_row (FontManagerFilterListView* base,
                                                    GtkSignalListItemFactory* factory,
                                                    GObject* item)
{
	FontManagerCategoryListView * self;
	GtkListItem* list_item = NULL;
	GtkListItem* _tmp0_;
	GtkTreeListRow* list_row = NULL;
	GtkTreeListModel* _tmp1_;
	GtkTreeListModel* _tmp2_;
	GtkListItem* _tmp3_;
	GtkTreeListRow* _tmp4_;
	GtkTreeExpander* tree_expander = NULL;
	GtkListItem* _tmp5_;
	GtkWidget* _tmp6_;
	GtkTreeExpander* _tmp7_;
	GtkTreeExpander* _tmp8_;
	GtkTreeExpander* _tmp9_;
	GtkTreeListRow* _tmp10_;
	FontManagerCategoryListRow* row = NULL;
	GtkTreeExpander* _tmp11_;
	GtkWidget* _tmp12_;
	FontManagerCategoryListRow* _tmp13_;
	GObject* _item = NULL;
	GtkTreeListRow* _tmp14_;
	GObject* _tmp15_;
	FontManagerCategoryListRow* _tmp16_;
	GObject* _tmp17_;
	GObject* _tmp18_;
	FontManagerCategory* category = NULL;
	GObject* _tmp19_;
	FontManagerCategory* _tmp20_;
	FontManagerCategory* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 207 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListView*) base;
#line 207 "../src/font-manager/Categories.vala"
	g_return_if_fail (factory != NULL);
#line 207 "../src/font-manager/Categories.vala"
	g_return_if_fail (item != NULL);
#line 208 "../src/font-manager/Categories.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (item, gtk_list_item_get_type (), GtkListItem));
#line 208 "../src/font-manager/Categories.vala"
	list_item = _tmp0_;
#line 209 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_filter_list_view_get_treemodel ((FontManagerFilterListView*) self);
#line 209 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 209 "../src/font-manager/Categories.vala"
	_tmp3_ = list_item;
#line 209 "../src/font-manager/Categories.vala"
	_tmp4_ = gtk_tree_list_model_get_row (_tmp2_, gtk_list_item_get_position (_tmp3_));
#line 209 "../src/font-manager/Categories.vala"
	list_row = _tmp4_;
#line 210 "../src/font-manager/Categories.vala"
	_tmp5_ = list_item;
#line 210 "../src/font-manager/Categories.vala"
	_tmp6_ = gtk_list_item_get_child (_tmp5_);
#line 210 "../src/font-manager/Categories.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_tree_expander_get_type (), GtkTreeExpander));
#line 210 "../src/font-manager/Categories.vala"
	tree_expander = _tmp7_;
#line 211 "../src/font-manager/Categories.vala"
	_tmp8_ = tree_expander;
#line 211 "../src/font-manager/Categories.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 2);
#line 212 "../src/font-manager/Categories.vala"
	_tmp9_ = tree_expander;
#line 212 "../src/font-manager/Categories.vala"
	_tmp10_ = list_row;
#line 212 "../src/font-manager/Categories.vala"
	gtk_tree_expander_set_list_row (_tmp9_, _tmp10_);
#line 213 "../src/font-manager/Categories.vala"
	_tmp11_ = tree_expander;
#line 213 "../src/font-manager/Categories.vala"
	_tmp12_ = gtk_tree_expander_get_child (_tmp11_);
#line 213 "../src/font-manager/Categories.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, FONT_MANAGER_TYPE_CATEGORY_LIST_ROW, FontManagerCategoryListRow));
#line 213 "../src/font-manager/Categories.vala"
	row = _tmp13_;
#line 214 "../src/font-manager/Categories.vala"
	_tmp14_ = list_row;
#line 214 "../src/font-manager/Categories.vala"
	_tmp15_ = gtk_tree_list_row_get_item (_tmp14_);
#line 214 "../src/font-manager/Categories.vala"
	_item = _tmp15_;
#line 216 "../src/font-manager/Categories.vala"
	_tmp16_ = row;
#line 216 "../src/font-manager/Categories.vala"
	_tmp17_ = _item;
#line 216 "../src/font-manager/Categories.vala"
	font_manager_list_item_row_set_item ((FontManagerListItemRow*) _tmp16_, _tmp17_);
#line 217 "../src/font-manager/Categories.vala"
	_tmp18_ = _item;
#line 217 "../src/font-manager/Categories.vala"
	g_return_if_fail (_tmp18_ != NULL);
#line 218 "../src/font-manager/Categories.vala"
	_tmp19_ = _item;
#line 218 "../src/font-manager/Categories.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 218 "../src/font-manager/Categories.vala"
	category = _tmp20_;
#line 219 "../src/font-manager/Categories.vala"
	_tmp21_ = category;
#line 219 "../src/font-manager/Categories.vala"
	_tmp22_ = font_manager_font_list_filter_get_index ((FontManagerFontListFilter*) _tmp21_);
#line 219 "../src/font-manager/Categories.vala"
	_tmp23_ = _tmp22_;
#line 219 "../src/font-manager/Categories.vala"
	if (_tmp23_ < ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE)) {
#line 1886 "Categories.c"
		FontManagerCategory* _tmp24_;
#line 220 "../src/font-manager/Categories.vala"
		_tmp24_ = category;
#line 220 "../src/font-manager/Categories.vala"
		font_manager_font_list_filter_update ((FontManagerFontListFilter*) _tmp24_, NULL, NULL);
#line 1892 "Categories.c"
	} else {
		FontManagerCategory* _tmp25_;
#line 221 "../src/font-manager/Categories.vala"
		_tmp25_ = category;
#line 221 "../src/font-manager/Categories.vala"
		if (FONT_MANAGER_IS_DISABLED (_tmp25_)) {
#line 1899 "Categories.c"
			FontManagerCategory* _tmp26_;
			GBindingFlags flags = 0U;
			FontManagerDisabled* _tmp27_;
#line 222 "../src/font-manager/Categories.vala"
			_tmp26_ = category;
#line 222 "../src/font-manager/Categories.vala"
			font_manager_category_list_view_set_disabled (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled));
#line 223 "../src/font-manager/Categories.vala"
			flags = G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE;
#line 224 "../src/font-manager/Categories.vala"
			_tmp27_ = self->priv->_disabled;
#line 224 "../src/font-manager/Categories.vala"
			g_object_bind_property_with_closures ((GObject*) self, "disabled-families", (GObject*) _tmp27_, "disabled-families", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1913 "Categories.c"
		} else {
			FontManagerCategory* _tmp28_;
#line 226 "../src/font-manager/Categories.vala"
			_tmp28_ = category;
#line 226 "../src/font-manager/Categories.vala"
			if (FONT_MANAGER_IS_UNSORTED (_tmp28_)) {
#line 1920 "Categories.c"
				FontManagerCategory* _tmp29_;
				GBindingFlags flags = 0U;
				FontManagerUnsorted* _tmp30_;
#line 227 "../src/font-manager/Categories.vala"
				_tmp29_ = category;
#line 227 "../src/font-manager/Categories.vala"
				font_manager_category_list_view_set_unsorted (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsorted));
#line 228 "../src/font-manager/Categories.vala"
				flags = G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE;
#line 229 "../src/font-manager/Categories.vala"
				_tmp30_ = self->priv->_unsorted;
#line 229 "../src/font-manager/Categories.vala"
				g_object_bind_property_with_closures ((GObject*) self, "sorted", (GObject*) _tmp30_, "sorted", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 230 "../src/font-manager/Categories.vala"
				font_manager_category_list_view_update_unsorted (self);
#line 1936 "Categories.c"
			} else {
				FontManagerCategory* _tmp31_;
#line 231 "../src/font-manager/Categories.vala"
				_tmp31_ = category;
#line 231 "../src/font-manager/Categories.vala"
				if (FONT_MANAGER_IS_LANGUAGE_FILTER (_tmp31_)) {
#line 1943 "Categories.c"
					FontManagerCategory* _tmp32_;
					FontManagerLanguageFilter* _tmp33_;
#line 232 "../src/font-manager/Categories.vala"
					_tmp32_ = category;
#line 232 "../src/font-manager/Categories.vala"
					font_manager_category_list_view_set_language_filter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter));
#line 233 "../src/font-manager/Categories.vala"
					_tmp33_ = self->priv->_language_filter;
#line 233 "../src/font-manager/Categories.vala"
					g_signal_connect_object ((FontManagerCacheable*) _tmp33_, "changed", (GCallback) _______lambda34__font_manager_cacheable_changed, self, 0);
#line 1954 "Categories.c"
				}
			}
		}
	}
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (category);
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_item);
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (row);
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (tree_expander);
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (list_row);
#line 240 "../src/font-manager/Categories.vala"
	_g_object_unref0 (list_item);
#line 240 "../src/font-manager/Categories.vala"
	return;
#line 1973 "Categories.c"
}

FontManagerCategoryListView*
font_manager_category_list_view_construct (GType object_type)
{
	FontManagerCategoryListView * self = NULL;
#line 125 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryListView*) font_manager_filter_list_view_construct (object_type);
#line 125 "../src/font-manager/Categories.vala"
	return self;
#line 1984 "Categories.c"
}

FontManagerCategoryListView*
font_manager_category_list_view_new (void)
{
#line 125 "../src/font-manager/Categories.vala"
	return font_manager_category_list_view_construct (FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW);
#line 1992 "Categories.c"
}

FontManagerReject*
font_manager_category_list_view_get_disabled_families (FontManagerCategoryListView* self)
{
	FontManagerReject* result;
	FontManagerReject* _tmp0_;
#line 127 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_disabled_families;
#line 127 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 127 "../src/font-manager/Categories.vala"
	return result;
#line 2008 "Categories.c"
}

void
font_manager_category_list_view_set_disabled_families (FontManagerCategoryListView* self,
                                                       FontManagerReject* value)
{
	FontManagerReject* old_value;
#line 127 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_list_view_get_disabled_families (self);
#line 127 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2022 "Categories.c"
		FontManagerReject* _tmp0_;
#line 127 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 127 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_disabled_families);
#line 127 "../src/font-manager/Categories.vala"
		self->priv->_disabled_families = _tmp0_;
#line 127 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY]);
#line 2032 "Categories.c"
	}
}

FontManagerDisabled*
font_manager_category_list_view_get_disabled (FontManagerCategoryListView* self)
{
	FontManagerDisabled* result;
	FontManagerDisabled* _tmp0_;
#line 128 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_disabled;
#line 128 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 128 "../src/font-manager/Categories.vala"
	return result;
#line 2049 "Categories.c"
}

void
font_manager_category_list_view_set_disabled (FontManagerCategoryListView* self,
                                              FontManagerDisabled* value)
{
	FontManagerDisabled* old_value;
#line 128 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_list_view_get_disabled (self);
#line 128 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2063 "Categories.c"
		FontManagerDisabled* _tmp0_;
#line 128 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 128 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_disabled);
#line 128 "../src/font-manager/Categories.vala"
		self->priv->_disabled = _tmp0_;
#line 128 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY]);
#line 2073 "Categories.c"
	}
}

FontManagerStringSet*
font_manager_category_list_view_get_sorted (FontManagerCategoryListView* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
#line 129 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_sorted;
#line 129 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 129 "../src/font-manager/Categories.vala"
	return result;
#line 2090 "Categories.c"
}

void
font_manager_category_list_view_set_sorted (FontManagerCategoryListView* self,
                                            FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
#line 129 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_list_view_get_sorted (self);
#line 129 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2104 "Categories.c"
		FontManagerStringSet* _tmp0_;
#line 129 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 129 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_sorted);
#line 129 "../src/font-manager/Categories.vala"
		self->priv->_sorted = _tmp0_;
#line 129 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY]);
#line 2114 "Categories.c"
	}
}

FontManagerUnsorted*
font_manager_category_list_view_get_unsorted (FontManagerCategoryListView* self)
{
	FontManagerUnsorted* result;
	FontManagerUnsorted* _tmp0_;
#line 130 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_unsorted;
#line 130 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 130 "../src/font-manager/Categories.vala"
	return result;
#line 2131 "Categories.c"
}

void
font_manager_category_list_view_set_unsorted (FontManagerCategoryListView* self,
                                              FontManagerUnsorted* value)
{
	FontManagerUnsorted* old_value;
#line 130 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_list_view_get_unsorted (self);
#line 130 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2145 "Categories.c"
		FontManagerUnsorted* _tmp0_;
#line 130 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 130 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_unsorted);
#line 130 "../src/font-manager/Categories.vala"
		self->priv->_unsorted = _tmp0_;
#line 130 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY]);
#line 2155 "Categories.c"
	}
}

FontManagerLanguageFilter*
font_manager_category_list_view_get_language_filter (FontManagerCategoryListView* self)
{
	FontManagerLanguageFilter* result;
	FontManagerLanguageFilter* _tmp0_;
#line 131 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_language_filter;
#line 131 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 131 "../src/font-manager/Categories.vala"
	return result;
#line 2172 "Categories.c"
}

void
font_manager_category_list_view_set_language_filter (FontManagerCategoryListView* self,
                                                     FontManagerLanguageFilter* value)
{
	FontManagerLanguageFilter* old_value;
#line 131 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_list_view_get_language_filter (self);
#line 131 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2186 "Categories.c"
		FontManagerLanguageFilter* _tmp0_;
#line 131 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 131 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_language_filter);
#line 131 "../src/font-manager/Categories.vala"
		self->priv->_language_filter = _tmp0_;
#line 131 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY]);
#line 2196 "Categories.c"
	}
}

static GListModel*
_font_manager_category_list_model_get_child_model_gtk_tree_list_model_create_model_func (GObject* item,
                                                                                         gpointer self)
{
	GListModel* result;
	result = font_manager_category_list_model_get_child_model (item);
#line 135 "../src/font-manager/Categories.vala"
	return result;
#line 2208 "Categories.c"
}

static void
_font_manager_category_list_view___lambda38_ (FontManagerCategoryListView* self)
{
#line 140 "../src/font-manager/Categories.vala"
	font_manager_category_list_view_update_disabled (self);
#line 2216 "Categories.c"
}

static void
__font_manager_category_list_view___lambda38__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 140 "../src/font-manager/Categories.vala"
	_font_manager_category_list_view___lambda38_ ((FontManagerCategoryListView*) self);
#line 2226 "Categories.c"
}

static void
_font_manager_category_list_view___lambda39_ (FontManagerCategoryListView* self)
{
#line 141 "../src/font-manager/Categories.vala"
	font_manager_category_list_view_update_unsorted (self);
#line 2234 "Categories.c"
}

static void
__font_manager_category_list_view___lambda39__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 141 "../src/font-manager/Categories.vala"
	_font_manager_category_list_view___lambda39_ ((FontManagerCategoryListView*) self);
#line 2244 "Categories.c"
}

static void
___lambda41_ (FontManagerCategoryListView* self)
{
#line 144 "../src/font-manager/Categories.vala"
	font_manager_category_list_view_update_disabled (self);
#line 2252 "Categories.c"
}

static void
____lambda41__font_manager_string_set_changed (FontManagerStringSet* _sender,
                                               gpointer self)
{
#line 144 "../src/font-manager/Categories.vala"
	___lambda41_ ((FontManagerCategoryListView*) self);
#line 2261 "Categories.c"
}

static void
_font_manager_category_list_view___lambda40_ (FontManagerCategoryListView* self)
{
	FontManagerReject* _tmp0_;
#line 143 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_disabled_families;
#line 143 "../src/font-manager/Categories.vala"
	if (_tmp0_ != NULL) {
#line 2272 "Categories.c"
		FontManagerReject* _tmp1_;
#line 144 "../src/font-manager/Categories.vala"
		_tmp1_ = self->priv->_disabled_families;
#line 144 "../src/font-manager/Categories.vala"
		g_signal_connect_object ((FontManagerStringSet*) _tmp1_, "changed", (GCallback) ____lambda41__font_manager_string_set_changed, self, 0);
#line 2278 "Categories.c"
	}
#line 145 "../src/font-manager/Categories.vala"
	font_manager_category_list_view_update_disabled (self);
#line 2282 "Categories.c"
}

static void
__font_manager_category_list_view___lambda40__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 142 "../src/font-manager/Categories.vala"
	_font_manager_category_list_view___lambda40_ ((FontManagerCategoryListView*) self);
#line 2292 "Categories.c"
}

static GObject *
font_manager_category_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerCategoryListView * self;
	GtkListView* _tmp0_;
	FontManagerCategoryListModel* _tmp1_;
	GtkTreeListModel* _tmp2_;
	GtkTreeListModel* _tmp3_;
	GtkTreeListModel* _tmp4_;
	GtkTreeListModel* _tmp5_;
	GListModel* _tmp6_;
	GtkSingleSelection* _tmp7_;
	GtkSingleSelection* _tmp8_;
	GtkSingleSelection* _tmp9_;
	GtkSingleSelection* _tmp10_;
#line 133 "../src/font-manager/Categories.vala"
	parent_class = G_OBJECT_CLASS (font_manager_category_list_view_parent_class);
#line 133 "../src/font-manager/Categories.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 133 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListView);
#line 134 "../src/font-manager/Categories.vala"
	_tmp0_ = ((FontManagerFilterListView*) self)->listview;
#line 134 "../src/font-manager/Categories.vala"
	font_manager_widget_set_name ((GtkWidget*) _tmp0_, "FontManagerCategoryListView");
#line 135 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_category_list_model_new ();
#line 135 "../src/font-manager/Categories.vala"
	_tmp2_ = gtk_tree_list_model_new ((GListModel*) _tmp1_, FALSE, FALSE, _font_manager_category_list_model_get_child_model_gtk_tree_list_model_create_model_func, NULL, NULL);
#line 135 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 135 "../src/font-manager/Categories.vala"
	font_manager_filter_list_view_set_treemodel ((FontManagerFilterListView*) self, _tmp3_);
#line 135 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_tmp3_);
#line 139 "../src/font-manager/Categories.vala"
	_tmp4_ = font_manager_filter_list_view_get_treemodel ((FontManagerFilterListView*) self);
#line 139 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 139 "../src/font-manager/Categories.vala"
	_tmp6_ = _g_object_ref0 ((GListModel*) _tmp5_);
#line 139 "../src/font-manager/Categories.vala"
	_tmp7_ = gtk_single_selection_new (_tmp6_);
#line 139 "../src/font-manager/Categories.vala"
	_tmp8_ = _tmp7_;
#line 139 "../src/font-manager/Categories.vala"
	font_manager_filter_list_view_set_selection ((FontManagerFilterListView*) self, _tmp8_);
#line 139 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_tmp8_);
#line 140 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GObject*) self, "notify::disabled", (GCallback) __font_manager_category_list_view___lambda38__g_object_notify, self, G_CONNECT_AFTER);
#line 141 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GObject*) self, "notify::sorted", (GCallback) __font_manager_category_list_view___lambda39__g_object_notify, self, G_CONNECT_AFTER);
#line 142 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GObject*) self, "notify::disabled-families", (GCallback) __font_manager_category_list_view___lambda40__g_object_notify, self, G_CONNECT_AFTER);
#line 147 "../src/font-manager/Categories.vala"
	_tmp9_ = font_manager_filter_list_view_get_selection ((FontManagerFilterListView*) self);
#line 147 "../src/font-manager/Categories.vala"
	_tmp10_ = _tmp9_;
#line 147 "../src/font-manager/Categories.vala"
	gtk_single_selection_set_selected (_tmp10_, GTK_INVALID_LIST_POSITION);
#line 133 "../src/font-manager/Categories.vala"
	return obj;
#line 2362 "Categories.c"
}

static void
font_manager_category_list_view_class_init (FontManagerCategoryListViewClass * klass,
                                            gpointer klass_data)
{
#line 125 "../src/font-manager/Categories.vala"
	font_manager_category_list_view_parent_class = g_type_class_peek_parent (klass);
#line 125 "../src/font-manager/Categories.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryListView_private_offset);
#line 125 "../src/font-manager/Categories.vala"
	((FontManagerFilterListViewClass *) klass)->on_selection_changed = (void (*) (FontManagerFilterListView*, guint, guint)) font_manager_category_list_view_real_on_selection_changed;
#line 125 "../src/font-manager/Categories.vala"
	((FontManagerFilterListViewClass *) klass)->setup_list_row = (void (*) (FontManagerFilterListView*, GtkSignalListItemFactory*, GObject*)) font_manager_category_list_view_real_setup_list_row;
#line 125 "../src/font-manager/Categories.vala"
	((FontManagerFilterListViewClass *) klass)->bind_list_row = (void (*) (FontManagerFilterListView*, GtkSignalListItemFactory*, GObject*)) font_manager_category_list_view_real_bind_list_row;
#line 125 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_category_list_view_get_property;
#line 125 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_category_list_view_set_property;
#line 125 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_category_list_view_constructor;
#line 125 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_list_view_finalize;
#line 125 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY] = g_param_spec_object ("disabled-families", "disabled-families", "disabled-families", font_manager_reject_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 125 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY] = g_param_spec_object ("disabled", "disabled", "disabled", FONT_MANAGER_TYPE_DISABLED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 125 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY] = g_param_spec_object ("sorted", "sorted", "sorted", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 125 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY] = g_param_spec_object ("unsorted", "unsorted", "unsorted", FONT_MANAGER_TYPE_UNSORTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 125 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY, font_manager_category_list_view_properties[FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY] = g_param_spec_object ("language-filter", "language-filter", "language-filter", FONT_MANAGER_TYPE_LANGUAGE_FILTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2397 "Categories.c"
}

static void
font_manager_category_list_view_instance_init (FontManagerCategoryListView * self,
                                               gpointer klass)
{
	FontManagerStringSet* _tmp0_;
#line 125 "../src/font-manager/Categories.vala"
	self->priv = font_manager_category_list_view_get_instance_private (self);
#line 127 "../src/font-manager/Categories.vala"
	self->priv->_disabled_families = NULL;
#line 128 "../src/font-manager/Categories.vala"
	self->priv->_disabled = NULL;
#line 129 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_string_set_new ();
#line 129 "../src/font-manager/Categories.vala"
	self->priv->_sorted = _tmp0_;
#line 130 "../src/font-manager/Categories.vala"
	self->priv->_unsorted = NULL;
#line 131 "../src/font-manager/Categories.vala"
	self->priv->_language_filter = NULL;
#line 2419 "Categories.c"
}

static void
font_manager_category_list_view_finalize (GObject * obj)
{
	FontManagerCategoryListView * self;
#line 125 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListView);
#line 127 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_disabled_families);
#line 128 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_disabled);
#line 129 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_sorted);
#line 130 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_unsorted);
#line 131 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_language_filter);
#line 125 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (font_manager_category_list_view_parent_class)->finalize (obj);
#line 2440 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_category_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryListView), 0, (GInstanceInitFunc) font_manager_category_list_view_instance_init, NULL };
	GType font_manager_category_list_view_type_id;
	font_manager_category_list_view_type_id = g_type_register_static (FONT_MANAGER_TYPE_FILTER_LIST_VIEW, "FontManagerCategoryListView", &g_define_type_info, 0);
	FontManagerCategoryListView_private_offset = g_type_add_instance_private (font_manager_category_list_view_type_id, sizeof (FontManagerCategoryListViewPrivate));
	return font_manager_category_list_view_type_id;
}

GType
font_manager_category_list_view_get_type (void)
{
	static volatile gsize font_manager_category_list_view_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_list_view_type_id__once)) {
		GType font_manager_category_list_view_type_id;
		font_manager_category_list_view_type_id = font_manager_category_list_view_get_type_once ();
		g_once_init_leave (&font_manager_category_list_view_type_id__once, font_manager_category_list_view_type_id);
	}
	return font_manager_category_list_view_type_id__once;
}

static void
_vala_font_manager_category_list_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	FontManagerCategoryListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListView);
#line 125 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_list_view_get_disabled_families (self));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_list_view_get_disabled (self));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_list_view_get_sorted (self));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_list_view_get_unsorted (self));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_list_view_get_language_filter (self));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 2505 "Categories.c"
		default:
#line 125 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 2511 "Categories.c"
	}
}

static void
_vala_font_manager_category_list_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	FontManagerCategoryListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_LIST_VIEW, FontManagerCategoryListView);
#line 125 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_FAMILIES_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		font_manager_category_list_view_set_disabled_families (self, g_value_get_object (value));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_DISABLED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		font_manager_category_list_view_set_disabled (self, g_value_get_object (value));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_SORTED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		font_manager_category_list_view_set_sorted (self, g_value_get_object (value));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_UNSORTED_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		font_manager_category_list_view_set_unsorted (self, g_value_get_object (value));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 125 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_LIST_VIEW_LANGUAGE_FILTER_PROPERTY:
#line 125 "../src/font-manager/Categories.vala"
		font_manager_category_list_view_set_language_filter (self, g_value_get_object (value));
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 2555 "Categories.c"
		default:
#line 125 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 125 "../src/font-manager/Categories.vala"
		break;
#line 2561 "Categories.c"
	}
}

void
font_manager_filter_data_copy (const FontManagerFilterData* self,
                               FontManagerFilterData* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 251 "../src/font-manager/Categories.vala"
	(*dest).index = (*self).index;
#line 251 "../src/font-manager/Categories.vala"
	_tmp0_ = (*self).name;
#line 251 "../src/font-manager/Categories.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 251 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).name);
#line 251 "../src/font-manager/Categories.vala"
	(*dest).name = _tmp1_;
#line 251 "../src/font-manager/Categories.vala"
	_tmp2_ = (*self).comment;
#line 251 "../src/font-manager/Categories.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 251 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).comment);
#line 251 "../src/font-manager/Categories.vala"
	(*dest).comment = _tmp3_;
#line 251 "../src/font-manager/Categories.vala"
	_tmp4_ = (*self).column;
#line 251 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 251 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).column);
#line 251 "../src/font-manager/Categories.vala"
	(*dest).column = _tmp5_;
#line 2601 "Categories.c"
}

void
font_manager_filter_data_destroy (FontManagerFilterData* self)
{
#line 253 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).name);
#line 254 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).comment);
#line 255 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).column);
#line 2613 "Categories.c"
}

FontManagerFilterData*
font_manager_filter_data_dup (const FontManagerFilterData* self)
{
	FontManagerFilterData* dup;
#line 251 "../src/font-manager/Categories.vala"
	dup = g_new0 (FontManagerFilterData, 1);
#line 251 "../src/font-manager/Categories.vala"
	font_manager_filter_data_copy (self, dup);
#line 251 "../src/font-manager/Categories.vala"
	return dup;
#line 2626 "Categories.c"
}

void
font_manager_filter_data_free (FontManagerFilterData* self)
{
#line 251 "../src/font-manager/Categories.vala"
	font_manager_filter_data_destroy (self);
#line 251 "../src/font-manager/Categories.vala"
	g_free (self);
#line 2636 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_filter_data_get_type_once (void)
{
	GType font_manager_filter_data_type_id;
	font_manager_filter_data_type_id = g_boxed_type_register_static ("FontManagerFilterData", (GBoxedCopyFunc) font_manager_filter_data_dup, (GBoxedFreeFunc) font_manager_filter_data_free);
	return font_manager_filter_data_type_id;
}

GType
font_manager_filter_data_get_type (void)
{
	static volatile gsize font_manager_filter_data_type_id__once = 0;
	if (g_once_init_enter (&font_manager_filter_data_type_id__once)) {
		GType font_manager_filter_data_type_id;
		font_manager_filter_data_type_id = font_manager_filter_data_get_type_once ();
		g_once_init_leave (&font_manager_filter_data_type_id__once, font_manager_filter_data_type_id);
	}
	return font_manager_filter_data_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 273 "../src/font-manager/Categories.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2664 "Categories.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 2677 "Categories.c"
}

GPtrArray*
font_manager_get_base_categories (void)
{
	GPtrArray* filters = NULL;
	GPtrArray* _tmp0_;
	const gchar* _tmp1_;
	FontManagerCategory* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerCategory* _tmp6_;
	FontManagerUserFonts* _tmp7_;
	GPtrArray* result;
#line 273 "../src/font-manager/Categories.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 273 "../src/font-manager/Categories.vala"
	filters = _tmp0_;
#line 274 "../src/font-manager/Categories.vala"
	_tmp1_ = string_to_string (FONT_MANAGER_SELECT_FROM_FONTS);
#line 274 "../src/font-manager/Categories.vala"
	_tmp2_ = font_manager_category_new (_ ("All"), _ ("All Fonts"), "edit-select-all-symbolic", _tmp1_, (gint) FONT_MANAGER_CATEGORY_INDEX_ALL);
#line 274 "../src/font-manager/Categories.vala"
	g_ptr_array_add (filters, _tmp2_);
#line 275 "../src/font-manager/Categories.vala"
	_tmp3_ = string_to_string (FONT_MANAGER_SELECT_FROM_METADATA_WHERE);
#line 275 "../src/font-manager/Categories.vala"
	_tmp4_ = g_strconcat (_tmp3_, " owner!=0 AND filepath LIKE '/usr%';", NULL);
#line 275 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 275 "../src/font-manager/Categories.vala"
	_tmp6_ = font_manager_category_new (_ ("System"), _ ("Fonts available to all users"), "computer-symbolic", _tmp5_, (gint) FONT_MANAGER_CATEGORY_INDEX_SYSTEM);
#line 275 "../src/font-manager/Categories.vala"
	g_ptr_array_add (filters, _tmp6_);
#line 275 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp5_);
#line 276 "../src/font-manager/Categories.vala"
	_tmp7_ = font_manager_user_fonts_new ();
#line 276 "../src/font-manager/Categories.vala"
	g_ptr_array_add (filters, (FontManagerCategory*) _tmp7_);
#line 277 "../src/font-manager/Categories.vala"
	result = filters;
#line 277 "../src/font-manager/Categories.vala"
	return result;
#line 2723 "Categories.c"
}

void
font_manager_get_default_categories (GTask* task,
                                     GObject* source,
                                     void* data,
                                     GCancellable* cancellable)
{
	FontManagerDatabase* db = NULL;
	FontManagerDatabase* _tmp0_;
	GPtrArray* filters = NULL;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	FontManagerCategory* _tmp3_;
	GPtrArray* _tmp12_;
	FontManagerUnsorted* _tmp13_;
	GPtrArray* _tmp14_;
	FontManagerDisabled* _tmp15_;
	GPtrArray* _tmp16_;
	FontManagerLanguageFilter* _tmp17_;
	GValue return_val = {0};
	GValue _tmp18_ = {0};
	GPtrArray* _tmp19_;
	GValue _tmp20_;
#line 280 "../src/font-manager/Categories.vala"
	g_return_if_fail (task != NULL);
#line 280 "../src/font-manager/Categories.vala"
	g_return_if_fail (source != NULL);
#line 281 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_database_proxy_get_default_db ();
#line 281 "../src/font-manager/Categories.vala"
	db = _tmp0_;
#line 282 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_get_base_categories ();
#line 282 "../src/font-manager/Categories.vala"
	filters = _tmp1_;
#line 283 "../src/font-manager/Categories.vala"
	_tmp2_ = filters;
#line 283 "../src/font-manager/Categories.vala"
	_tmp3_ = font_manager_construct_panose_filter ();
#line 283 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp2_, _tmp3_);
#line 2766 "Categories.c"
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 284 "../src/font-manager/Categories.vala"
		entry_collection = FONT_MANAGER_attributes;
#line 284 "../src/font-manager/Categories.vala"
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_attributes);
#line 284 "../src/font-manager/Categories.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 2778 "Categories.c"
			FontManagerFilterData entry = {0};
#line 284 "../src/font-manager/Categories.vala"
			entry = entry_collection[entry_it];
#line 2782 "Categories.c"
			{
				GPtrArray* _tmp4_;
				FontManagerDatabase* _tmp5_;
				FontManagerFilterData _tmp6_;
				FontManagerCategory* _tmp7_;
#line 285 "../src/font-manager/Categories.vala"
				_tmp4_ = filters;
#line 285 "../src/font-manager/Categories.vala"
				_tmp5_ = db;
#line 285 "../src/font-manager/Categories.vala"
				_tmp6_ = entry;
#line 285 "../src/font-manager/Categories.vala"
				_tmp7_ = font_manager_construct_attribute_filter (_tmp5_, &_tmp6_);
#line 285 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp4_, _tmp7_);
#line 2798 "Categories.c"
			}
		}
	}
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 286 "../src/font-manager/Categories.vala"
		entry_collection = FONT_MANAGER_metadata;
#line 286 "../src/font-manager/Categories.vala"
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_metadata);
#line 286 "../src/font-manager/Categories.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 2813 "Categories.c"
			FontManagerFilterData entry = {0};
#line 286 "../src/font-manager/Categories.vala"
			entry = entry_collection[entry_it];
#line 2817 "Categories.c"
			{
				GPtrArray* _tmp8_;
				FontManagerDatabase* _tmp9_;
				FontManagerFilterData _tmp10_;
				FontManagerCategory* _tmp11_;
#line 287 "../src/font-manager/Categories.vala"
				_tmp8_ = filters;
#line 287 "../src/font-manager/Categories.vala"
				_tmp9_ = db;
#line 287 "../src/font-manager/Categories.vala"
				_tmp10_ = entry;
#line 287 "../src/font-manager/Categories.vala"
				_tmp11_ = font_manager_construct_info_filter (_tmp9_, &_tmp10_);
#line 287 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp8_, _tmp11_);
#line 2833 "Categories.c"
			}
		}
	}
#line 288 "../src/font-manager/Categories.vala"
	_tmp12_ = filters;
#line 288 "../src/font-manager/Categories.vala"
	_tmp13_ = font_manager_unsorted_new ();
#line 288 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp12_, (FontManagerCategory*) _tmp13_);
#line 289 "../src/font-manager/Categories.vala"
	_tmp14_ = filters;
#line 289 "../src/font-manager/Categories.vala"
	_tmp15_ = font_manager_disabled_new ();
#line 289 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp14_, (FontManagerCategory*) _tmp15_);
#line 290 "../src/font-manager/Categories.vala"
	_tmp16_ = filters;
#line 290 "../src/font-manager/Categories.vala"
	_tmp17_ = font_manager_language_filter_new ();
#line 290 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp16_, (FontManagerCategory*) _tmp17_);
#line 291 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp18_, G_TYPE_PTR_ARRAY);
#line 291 "../src/font-manager/Categories.vala"
	return_val = _tmp18_;
#line 292 "../src/font-manager/Categories.vala"
	_tmp19_ = filters;
#line 292 "../src/font-manager/Categories.vala"
	g_value_set_boxed (&return_val, _tmp19_);
#line 293 "../src/font-manager/Categories.vala"
	_tmp20_ = return_val;
#line 293 "../src/font-manager/Categories.vala"
	g_task_return_value (task, &_tmp20_);
#line 294 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&return_val) ? (g_value_unset (&return_val), NULL) : NULL;
#line 294 "../src/font-manager/Categories.vala"
	_g_ptr_array_unref0 (filters);
#line 294 "../src/font-manager/Categories.vala"
	_g_object_unref0 (db);
#line 294 "../src/font-manager/Categories.vala"
	return;
#line 2875 "Categories.c"
}

static void
__lambda35_ (FontManagerCategory* child)
{
#line 302 "../src/font-manager/Categories.vala"
	g_return_if_fail (child != NULL);
#line 302 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_set_depth ((FontManagerFontListFilter*) child, 1);
#line 2885 "Categories.c"
}

static void
___lambda35__gfunc (gconstpointer data,
                    gpointer self)
{
#line 302 "../src/font-manager/Categories.vala"
	__lambda35_ ((FontManagerCategory*) data);
#line 2894 "Categories.c"
}

FontManagerCategory*
font_manager_construct_panose_filter (void)
{
	FontManagerCategory* panose = NULL;
	FontManagerCategory* _tmp0_;
	gchar** kind = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint kind_length1;
	gint _kind_size_;
	FontManagerCategory* _tmp24_;
	GPtrArray* _tmp25_;
	GPtrArray* _tmp26_;
	FontManagerCategory* result;
#line 298 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_category_new (_ ("Family Kind"), _ ("Only fonts which include Panose information will be grouped here."), "folder-symbolic", NULL, (gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE);
#line 298 "../src/font-manager/Categories.vala"
	panose = _tmp0_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp1_ = g_strdup (_ ("Any"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp2_ = g_strdup (_ ("No Fit"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp3_ = g_strdup (_ ("Text and Display"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp4_ = g_strdup (_ ("Script"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (_ ("Decorative"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp6_ = g_strdup (_ ("Pictorial"));
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_ = g_new0 (gchar*, 6 + 1);
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[0] = _tmp1_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[1] = _tmp2_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[2] = _tmp3_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[3] = _tmp4_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[4] = _tmp5_;
#line 299 "../src/font-manager/Categories.vala"
	_tmp7_[5] = _tmp6_;
#line 299 "../src/font-manager/Categories.vala"
	kind = _tmp7_;
#line 299 "../src/font-manager/Categories.vala"
	kind_length1 = 6;
#line 299 "../src/font-manager/Categories.vala"
	_kind_size_ = kind_length1;
#line 2952 "Categories.c"
	{
		gint i = 0;
#line 300 "../src/font-manager/Categories.vala"
		i = 0;
#line 2957 "Categories.c"
		{
			gboolean _tmp8_ = FALSE;
#line 300 "../src/font-manager/Categories.vala"
			_tmp8_ = TRUE;
#line 300 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 2964 "Categories.c"
				gchar** _tmp10_;
				gint _tmp10__length1;
				FontManagerCategory* _tmp11_;
				GPtrArray* _tmp12_;
				GPtrArray* _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				FontManagerCategory* _tmp23_;
#line 300 "../src/font-manager/Categories.vala"
				if (!_tmp8_) {
#line 2984 "Categories.c"
					gint _tmp9_;
#line 300 "../src/font-manager/Categories.vala"
					_tmp9_ = i;
#line 300 "../src/font-manager/Categories.vala"
					i = _tmp9_ + 1;
#line 2990 "Categories.c"
				}
#line 300 "../src/font-manager/Categories.vala"
				_tmp8_ = FALSE;
#line 300 "../src/font-manager/Categories.vala"
				_tmp10_ = kind;
#line 300 "../src/font-manager/Categories.vala"
				_tmp10__length1 = kind_length1;
#line 300 "../src/font-manager/Categories.vala"
				if (!(i < _tmp10__length1)) {
#line 300 "../src/font-manager/Categories.vala"
					break;
#line 3002 "Categories.c"
				}
#line 301 "../src/font-manager/Categories.vala"
				_tmp11_ = panose;
#line 301 "../src/font-manager/Categories.vala"
				_tmp12_ = font_manager_category_get_children (_tmp11_);
#line 301 "../src/font-manager/Categories.vala"
				_tmp13_ = _tmp12_;
#line 301 "../src/font-manager/Categories.vala"
				_tmp14_ = kind;
#line 301 "../src/font-manager/Categories.vala"
				_tmp14__length1 = kind_length1;
#line 301 "../src/font-manager/Categories.vala"
				_tmp15_ = _tmp14_[i];
#line 301 "../src/font-manager/Categories.vala"
				_tmp16_ = kind;
#line 301 "../src/font-manager/Categories.vala"
				_tmp16__length1 = kind_length1;
#line 301 "../src/font-manager/Categories.vala"
				_tmp17_ = _tmp16_[i];
#line 301 "../src/font-manager/Categories.vala"
				_tmp18_ = string_to_string (FONT_MANAGER_SELECT_FROM_PANOSE_WHERE);
#line 301 "../src/font-manager/Categories.vala"
				_tmp19_ = g_strdup_printf ("%i", i);
#line 301 "../src/font-manager/Categories.vala"
				_tmp20_ = _tmp19_;
#line 301 "../src/font-manager/Categories.vala"
				_tmp21_ = g_strconcat (_tmp18_, " P0 = '", _tmp20_, "';", NULL);
#line 301 "../src/font-manager/Categories.vala"
				_tmp22_ = _tmp21_;
#line 301 "../src/font-manager/Categories.vala"
				_tmp23_ = font_manager_category_new (_tmp15_, _tmp17_, "emblem-documents-symbolic", _tmp22_, i);
#line 301 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp13_, _tmp23_);
#line 301 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp22_);
#line 301 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp20_);
#line 3040 "Categories.c"
			}
		}
	}
#line 302 "../src/font-manager/Categories.vala"
	_tmp24_ = panose;
#line 302 "../src/font-manager/Categories.vala"
	_tmp25_ = font_manager_category_get_children (_tmp24_);
#line 302 "../src/font-manager/Categories.vala"
	_tmp26_ = _tmp25_;
#line 302 "../src/font-manager/Categories.vala"
	g_ptr_array_foreach (_tmp26_, ___lambda35__gfunc, NULL);
#line 303 "../src/font-manager/Categories.vala"
	result = panose;
#line 303 "../src/font-manager/Categories.vala"
	kind = (_vala_array_free (kind, kind_length1, (GDestroyNotify) g_free), NULL);
#line 303 "../src/font-manager/Categories.vala"
	return result;
#line 3058 "Categories.c"
}

static void
__lambda36_ (FontManagerCategory* child)
{
#line 338 "../src/font-manager/Categories.vala"
	g_return_if_fail (child != NULL);
#line 338 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_set_depth ((FontManagerFontListFilter*) child, 1);
#line 3068 "Categories.c"
}

static void
___lambda36__gfunc (gconstpointer data,
                    gpointer self)
{
#line 338 "../src/font-manager/Categories.vala"
	__lambda36_ ((FontManagerCategory*) data);
#line 3077 "Categories.c"
}

FontManagerCategory*
font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                         FontManagerFilterData* data)
{
	gchar* name = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	FontManagerFilterData _tmp8_;
	FontManagerCategory* _tmp9_;
	FontManagerCategory* _tmp63_;
	GPtrArray* _tmp64_;
	GPtrArray* _tmp65_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
#line 306 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 306 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 307 "../src/font-manager/Categories.vala"
	_tmp0_ = *data;
#line 307 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_.name;
#line 307 "../src/font-manager/Categories.vala"
	_tmp2_ = g_strdup (g_dgettext (NULL, _tmp1_));
#line 307 "../src/font-manager/Categories.vala"
	name = _tmp2_;
#line 308 "../src/font-manager/Categories.vala"
	_tmp3_ = *data;
#line 308 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.comment;
#line 308 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (g_dgettext (NULL, _tmp4_));
#line 308 "../src/font-manager/Categories.vala"
	comment = _tmp5_;
#line 309 "../src/font-manager/Categories.vala"
	_tmp6_ = name;
#line 309 "../src/font-manager/Categories.vala"
	_tmp7_ = comment;
#line 309 "../src/font-manager/Categories.vala"
	_tmp8_ = *data;
#line 309 "../src/font-manager/Categories.vala"
	_tmp9_ = font_manager_category_new (_tmp6_, _tmp7_, "folder-symbolic", NULL, _tmp8_.index);
#line 309 "../src/font-manager/Categories.vala"
	filter = _tmp9_;
#line 3132 "Categories.c"
	{
		gchar* keyword = NULL;
		FontManagerFilterData _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 311 "../src/font-manager/Categories.vala"
		_tmp10_ = *data;
#line 311 "../src/font-manager/Categories.vala"
		_tmp11_ = _tmp10_.column;
#line 311 "../src/font-manager/Categories.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 311 "../src/font-manager/Categories.vala"
		keyword = _tmp12_;
#line 312 "../src/font-manager/Categories.vala"
		_tmp13_ = keyword;
#line 312 "../src/font-manager/Categories.vala"
		_tmp14_ = string_to_string (_tmp13_);
#line 312 "../src/font-manager/Categories.vala"
		_tmp15_ = keyword;
#line 312 "../src/font-manager/Categories.vala"
		_tmp16_ = string_to_string (_tmp15_);
#line 312 "../src/font-manager/Categories.vala"
		_tmp17_ = g_strconcat ("SELECT DISTINCT ", _tmp14_, " FROM Fonts ORDER BY ", _tmp16_, ";", NULL);
#line 312 "../src/font-manager/Categories.vala"
		_tmp18_ = _tmp17_;
#line 312 "../src/font-manager/Categories.vala"
		font_manager_database_execute_query (db, _tmp18_, &_inner_error0_);
#line 312 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp18_);
#line 312 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "../src/font-manager/Categories.vala"
			_g_free0 (keyword);
#line 312 "../src/font-manager/Categories.vala"
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3174 "Categories.c"
				goto __catch0_font_manager_database_error;
			}
#line 312 "../src/font-manager/Categories.vala"
			_g_object_unref0 (filter);
#line 312 "../src/font-manager/Categories.vala"
			_g_free0 (comment);
#line 312 "../src/font-manager/Categories.vala"
			_g_free0 (name);
#line 312 "../src/font-manager/Categories.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 312 "../src/font-manager/Categories.vala"
			g_clear_error (&_inner_error0_);
#line 312 "../src/font-manager/Categories.vala"
			return NULL;
#line 3189 "Categories.c"
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp19_;
#line 313 "../src/font-manager/Categories.vala"
			_tmp19_ = font_manager_database_iterator (db);
#line 313 "../src/font-manager/Categories.vala"
			_row_it = _tmp19_;
#line 313 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 3200 "Categories.c"
				FontManagerDatabaseIterator* _tmp20_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp21_;
				sqlite3_stmt* _tmp22_;
				gint val = 0;
				sqlite3_stmt* _tmp23_;
				gchar* type = NULL;
				const gchar* _tmp24_;
				const gchar* _tmp36_;
				FontManagerCategory* _tmp47_;
				GPtrArray* _tmp48_;
				GPtrArray* _tmp49_;
				const gchar* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				FontManagerFilterData _tmp59_;
				FontManagerCategory* _tmp60_;
#line 313 "../src/font-manager/Categories.vala"
				_tmp20_ = _row_it;
#line 313 "../src/font-manager/Categories.vala"
				if (!font_manager_database_iterator_next (_tmp20_)) {
#line 313 "../src/font-manager/Categories.vala"
					break;
#line 3230 "Categories.c"
				}
#line 313 "../src/font-manager/Categories.vala"
				_tmp21_ = _row_it;
#line 313 "../src/font-manager/Categories.vala"
				_tmp22_ = font_manager_database_iterator_get (_tmp21_);
#line 313 "../src/font-manager/Categories.vala"
				row = _tmp22_;
#line 314 "../src/font-manager/Categories.vala"
				_tmp23_ = row;
#line 314 "../src/font-manager/Categories.vala"
				val = sqlite3_column_int (_tmp23_, 0);
#line 315 "../src/font-manager/Categories.vala"
				type = NULL;
#line 316 "../src/font-manager/Categories.vala"
				_tmp24_ = keyword;
#line 316 "../src/font-manager/Categories.vala"
				if (g_strcmp0 (_tmp24_, "slant") == 0) {
#line 3248 "Categories.c"
					const gchar* _tmp25_;
					gchar* _tmp26_;
#line 317 "../src/font-manager/Categories.vala"
					_tmp25_ = font_manager_slant_to_string ((FontManagerSlant) val);
#line 317 "../src/font-manager/Categories.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 317 "../src/font-manager/Categories.vala"
					_g_free0 (type);
#line 317 "../src/font-manager/Categories.vala"
					type = _tmp26_;
#line 3259 "Categories.c"
				} else {
					const gchar* _tmp27_;
#line 318 "../src/font-manager/Categories.vala"
					_tmp27_ = keyword;
#line 318 "../src/font-manager/Categories.vala"
					if (g_strcmp0 (_tmp27_, "spacing") == 0) {
#line 3266 "Categories.c"
						const gchar* _tmp28_;
						gchar* _tmp29_;
#line 319 "../src/font-manager/Categories.vala"
						_tmp28_ = font_manager_spacing_to_string ((FontManagerSpacing) val);
#line 319 "../src/font-manager/Categories.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 319 "../src/font-manager/Categories.vala"
						_g_free0 (type);
#line 319 "../src/font-manager/Categories.vala"
						type = _tmp29_;
#line 3277 "Categories.c"
					} else {
						const gchar* _tmp30_;
#line 320 "../src/font-manager/Categories.vala"
						_tmp30_ = keyword;
#line 320 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp30_, "weight") == 0) {
#line 3284 "Categories.c"
							const gchar* _tmp31_;
							gchar* _tmp32_;
#line 321 "../src/font-manager/Categories.vala"
							_tmp31_ = font_manager_weight_to_string ((FontManagerWeight) val);
#line 321 "../src/font-manager/Categories.vala"
							_tmp32_ = g_strdup (_tmp31_);
#line 321 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 321 "../src/font-manager/Categories.vala"
							type = _tmp32_;
#line 3295 "Categories.c"
						} else {
							const gchar* _tmp33_;
#line 322 "../src/font-manager/Categories.vala"
							_tmp33_ = keyword;
#line 322 "../src/font-manager/Categories.vala"
							if (g_strcmp0 (_tmp33_, "width") == 0) {
#line 3302 "Categories.c"
								const gchar* _tmp34_;
								gchar* _tmp35_;
#line 323 "../src/font-manager/Categories.vala"
								_tmp34_ = font_manager_width_to_string ((FontManagerWidth) val);
#line 323 "../src/font-manager/Categories.vala"
								_tmp35_ = g_strdup (_tmp34_);
#line 323 "../src/font-manager/Categories.vala"
								_g_free0 (type);
#line 323 "../src/font-manager/Categories.vala"
								type = _tmp35_;
#line 3313 "Categories.c"
							}
						}
					}
				}
#line 324 "../src/font-manager/Categories.vala"
				_tmp36_ = type;
#line 324 "../src/font-manager/Categories.vala"
				if (_tmp36_ == NULL) {
#line 3322 "Categories.c"
					gboolean _tmp37_ = FALSE;
					const gchar* _tmp38_;
#line 325 "../src/font-manager/Categories.vala"
					_tmp38_ = keyword;
#line 325 "../src/font-manager/Categories.vala"
					if (g_strcmp0 (_tmp38_, "slant") == 0) {
#line 325 "../src/font-manager/Categories.vala"
						_tmp37_ = TRUE;
#line 3331 "Categories.c"
					} else {
						gboolean _tmp39_ = FALSE;
						const gchar* _tmp40_;
#line 325 "../src/font-manager/Categories.vala"
						_tmp40_ = keyword;
#line 325 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp40_, "width") == 0) {
#line 325 "../src/font-manager/Categories.vala"
							_tmp39_ = font_manager_width_defined ((FontManagerWidth) val);
#line 3341 "Categories.c"
						} else {
#line 325 "../src/font-manager/Categories.vala"
							_tmp39_ = FALSE;
#line 3345 "Categories.c"
						}
#line 325 "../src/font-manager/Categories.vala"
						_tmp37_ = _tmp39_;
#line 3349 "Categories.c"
					}
#line 325 "../src/font-manager/Categories.vala"
					if (_tmp37_) {
#line 3353 "Categories.c"
						gchar* _tmp41_;
#line 326 "../src/font-manager/Categories.vala"
						_tmp41_ = g_strdup (_ ("Normal"));
#line 326 "../src/font-manager/Categories.vala"
						_g_free0 (type);
#line 326 "../src/font-manager/Categories.vala"
						type = _tmp41_;
#line 3361 "Categories.c"
					} else {
						gboolean _tmp42_ = FALSE;
						const gchar* _tmp43_;
#line 328 "../src/font-manager/Categories.vala"
						_tmp43_ = keyword;
#line 328 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp43_, "width") == 0) {
#line 328 "../src/font-manager/Categories.vala"
							_tmp42_ = TRUE;
#line 3371 "Categories.c"
						} else {
							gboolean _tmp44_ = FALSE;
							const gchar* _tmp45_;
#line 328 "../src/font-manager/Categories.vala"
							_tmp45_ = keyword;
#line 328 "../src/font-manager/Categories.vala"
							if (g_strcmp0 (_tmp45_, "weight") == 0) {
#line 328 "../src/font-manager/Categories.vala"
								_tmp44_ = !font_manager_weight_defined ((FontManagerWeight) val);
#line 3381 "Categories.c"
							} else {
#line 328 "../src/font-manager/Categories.vala"
								_tmp44_ = FALSE;
#line 3385 "Categories.c"
							}
#line 328 "../src/font-manager/Categories.vala"
							_tmp42_ = _tmp44_;
#line 3389 "Categories.c"
						}
#line 328 "../src/font-manager/Categories.vala"
						if (_tmp42_) {
#line 329 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 329 "../src/font-manager/Categories.vala"
							continue;
#line 3397 "Categories.c"
						} else {
							gchar* _tmp46_;
#line 331 "../src/font-manager/Categories.vala"
							_tmp46_ = g_strdup (_ ("Regular"));
#line 331 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 331 "../src/font-manager/Categories.vala"
							type = _tmp46_;
#line 3406 "Categories.c"
						}
					}
				}
#line 332 "../src/font-manager/Categories.vala"
				_tmp47_ = filter;
#line 332 "../src/font-manager/Categories.vala"
				_tmp48_ = font_manager_category_get_children (_tmp47_);
#line 332 "../src/font-manager/Categories.vala"
				_tmp49_ = _tmp48_;
#line 332 "../src/font-manager/Categories.vala"
				_tmp50_ = type;
#line 332 "../src/font-manager/Categories.vala"
				_tmp51_ = type;
#line 332 "../src/font-manager/Categories.vala"
				_tmp52_ = string_to_string (FONT_MANAGER_SELECT_FROM_FONTS);
#line 332 "../src/font-manager/Categories.vala"
				_tmp53_ = keyword;
#line 332 "../src/font-manager/Categories.vala"
				_tmp54_ = string_to_string (_tmp53_);
#line 332 "../src/font-manager/Categories.vala"
				_tmp55_ = g_strdup_printf ("%i", val);
#line 332 "../src/font-manager/Categories.vala"
				_tmp56_ = _tmp55_;
#line 332 "../src/font-manager/Categories.vala"
				_tmp57_ = g_strconcat (_tmp52_, " WHERE ", _tmp54_, "='", _tmp56_, "';", NULL);
#line 332 "../src/font-manager/Categories.vala"
				_tmp58_ = _tmp57_;
#line 332 "../src/font-manager/Categories.vala"
				_tmp59_ = *data;
#line 332 "../src/font-manager/Categories.vala"
				_tmp60_ = font_manager_category_new (_tmp50_, _tmp51_, "emblem-documents-symbolic", _tmp58_, _tmp59_.index);
#line 332 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp49_, _tmp60_);
#line 332 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp58_);
#line 332 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp56_);
#line 313 "../src/font-manager/Categories.vala"
				_g_free0 (type);
#line 3446 "Categories.c"
			}
#line 313 "../src/font-manager/Categories.vala"
			_g_object_unref0 (_row_it);
#line 3450 "Categories.c"
		}
#line 334 "../src/font-manager/Categories.vala"
		font_manager_database_end_query (db);
#line 310 "../src/font-manager/Categories.vala"
		_g_free0 (keyword);
#line 3456 "Categories.c"
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		GError* e = NULL;
		GError* _tmp61_;
		const gchar* _tmp62_;
#line 310 "../src/font-manager/Categories.vala"
		e = _inner_error0_;
#line 310 "../src/font-manager/Categories.vala"
		_inner_error0_ = NULL;
#line 336 "../src/font-manager/Categories.vala"
		_tmp61_ = e;
#line 336 "../src/font-manager/Categories.vala"
		_tmp62_ = _tmp61_->message;
#line 336 "../src/font-manager/Categories.vala"
		g_warning ("Categories.vala:336: %s", _tmp62_);
#line 310 "../src/font-manager/Categories.vala"
		_g_error_free0 (e);
#line 3476 "Categories.c"
	}
	__finally0:
#line 310 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 310 "../src/font-manager/Categories.vala"
		_g_object_unref0 (filter);
#line 310 "../src/font-manager/Categories.vala"
		_g_free0 (comment);
#line 310 "../src/font-manager/Categories.vala"
		_g_free0 (name);
#line 310 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 310 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 310 "../src/font-manager/Categories.vala"
		return NULL;
#line 3493 "Categories.c"
	}
#line 338 "../src/font-manager/Categories.vala"
	_tmp63_ = filter;
#line 338 "../src/font-manager/Categories.vala"
	_tmp64_ = font_manager_category_get_children (_tmp63_);
#line 338 "../src/font-manager/Categories.vala"
	_tmp65_ = _tmp64_;
#line 338 "../src/font-manager/Categories.vala"
	g_ptr_array_foreach (_tmp65_, ___lambda36__gfunc, NULL);
#line 339 "../src/font-manager/Categories.vala"
	result = filter;
#line 339 "../src/font-manager/Categories.vala"
	_g_free0 (comment);
#line 339 "../src/font-manager/Categories.vala"
	_g_free0 (name);
#line 339 "../src/font-manager/Categories.vala"
	return result;
#line 3511 "Categories.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3533 "Categories.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3537 "Categories.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3543 "Categories.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3547 "Categories.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3551 "Categories.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 3559 "Categories.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3587 "Categories.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 3596 "Categories.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3610 "Categories.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 3619 "Categories.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 3633 "Categories.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 3642 "Categories.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 3651 "Categories.c"
}

static void
__lambda37_ (FontManagerCategory* child)
{
#line 358 "../src/font-manager/Categories.vala"
	g_return_if_fail (child != NULL);
#line 358 "../src/font-manager/Categories.vala"
	font_manager_font_list_filter_set_depth ((FontManagerFontListFilter*) child, 1);
#line 3661 "Categories.c"
}

static void
___lambda37__gfunc (gconstpointer data,
                    gpointer self)
{
#line 358 "../src/font-manager/Categories.vala"
	__lambda37_ ((FontManagerCategory*) data);
#line 3670 "Categories.c"
}

FontManagerCategory*
font_manager_construct_info_filter (FontManagerDatabase* db,
                                    FontManagerFilterData* data)
{
	gchar* keyword = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* name = NULL;
	FontManagerFilterData _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	FontManagerFilterData _tmp14_;
	FontManagerCategory* _tmp15_;
	FontManagerCategory* _tmp47_;
	GPtrArray* _tmp48_;
	GPtrArray* _tmp49_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
#line 342 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 342 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 343 "../src/font-manager/Categories.vala"
	_tmp0_ = *data;
#line 343 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_.column;
#line 343 "../src/font-manager/Categories.vala"
	_tmp2_ = string_replace (_tmp1_, "\"", "\\\"");
#line 343 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 343 "../src/font-manager/Categories.vala"
	_tmp4_ = string_replace (_tmp3_, "'", "''");
#line 343 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 343 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp3_);
#line 343 "../src/font-manager/Categories.vala"
	keyword = _tmp5_;
#line 344 "../src/font-manager/Categories.vala"
	_tmp6_ = *data;
#line 344 "../src/font-manager/Categories.vala"
	_tmp7_ = _tmp6_.name;
#line 344 "../src/font-manager/Categories.vala"
	_tmp8_ = g_strdup (g_dgettext (NULL, _tmp7_));
#line 344 "../src/font-manager/Categories.vala"
	name = _tmp8_;
#line 345 "../src/font-manager/Categories.vala"
	_tmp9_ = *data;
#line 345 "../src/font-manager/Categories.vala"
	_tmp10_ = _tmp9_.comment;
#line 345 "../src/font-manager/Categories.vala"
	_tmp11_ = g_strdup (g_dgettext (NULL, _tmp10_));
#line 345 "../src/font-manager/Categories.vala"
	comment = _tmp11_;
#line 346 "../src/font-manager/Categories.vala"
	_tmp12_ = name;
#line 346 "../src/font-manager/Categories.vala"
	_tmp13_ = comment;
#line 346 "../src/font-manager/Categories.vala"
	_tmp14_ = *data;
#line 346 "../src/font-manager/Categories.vala"
	_tmp15_ = font_manager_category_new (_tmp12_, _tmp13_, "folder-symbolic", NULL, _tmp14_.index);
#line 346 "../src/font-manager/Categories.vala"
	filter = _tmp15_;
#line 3748 "Categories.c"
	{
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 348 "../src/font-manager/Categories.vala"
		_tmp16_ = keyword;
#line 348 "../src/font-manager/Categories.vala"
		_tmp17_ = string_to_string (_tmp16_);
#line 348 "../src/font-manager/Categories.vala"
		_tmp18_ = keyword;
#line 348 "../src/font-manager/Categories.vala"
		_tmp19_ = string_to_string (_tmp18_);
#line 348 "../src/font-manager/Categories.vala"
		_tmp20_ = g_strconcat ("SELECT DISTINCT [", _tmp17_, "] FROM Metadata ORDER BY [", _tmp19_, "];", NULL);
#line 348 "../src/font-manager/Categories.vala"
		_tmp21_ = _tmp20_;
#line 348 "../src/font-manager/Categories.vala"
		font_manager_database_execute_query (db, _tmp21_, &_inner_error0_);
#line 348 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp21_);
#line 348 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "../src/font-manager/Categories.vala"
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3776 "Categories.c"
				goto __catch0_font_manager_database_error;
			}
#line 348 "../src/font-manager/Categories.vala"
			_g_object_unref0 (filter);
#line 348 "../src/font-manager/Categories.vala"
			_g_free0 (comment);
#line 348 "../src/font-manager/Categories.vala"
			_g_free0 (name);
#line 348 "../src/font-manager/Categories.vala"
			_g_free0 (keyword);
#line 348 "../src/font-manager/Categories.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../src/font-manager/Categories.vala"
			g_clear_error (&_inner_error0_);
#line 348 "../src/font-manager/Categories.vala"
			return NULL;
#line 3793 "Categories.c"
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp22_;
#line 349 "../src/font-manager/Categories.vala"
			_tmp22_ = font_manager_database_iterator (db);
#line 349 "../src/font-manager/Categories.vala"
			_row_it = _tmp22_;
#line 349 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 3804 "Categories.c"
				FontManagerDatabaseIterator* _tmp23_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp24_;
				sqlite3_stmt* _tmp25_;
				gchar* _type = NULL;
				sqlite3_stmt* _tmp26_;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* type = NULL;
				const gchar* _tmp29_;
				gchar* _tmp30_;
				FontManagerCategory* _tmp31_;
				GPtrArray* _tmp32_;
				GPtrArray* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				FontManagerFilterData _tmp43_;
				FontManagerCategory* _tmp44_;
#line 349 "../src/font-manager/Categories.vala"
				_tmp23_ = _row_it;
#line 349 "../src/font-manager/Categories.vala"
				if (!font_manager_database_iterator_next (_tmp23_)) {
#line 349 "../src/font-manager/Categories.vala"
					break;
#line 3836 "Categories.c"
				}
#line 349 "../src/font-manager/Categories.vala"
				_tmp24_ = _row_it;
#line 349 "../src/font-manager/Categories.vala"
				_tmp25_ = font_manager_database_iterator_get (_tmp24_);
#line 349 "../src/font-manager/Categories.vala"
				row = _tmp25_;
#line 350 "../src/font-manager/Categories.vala"
				_tmp26_ = row;
#line 350 "../src/font-manager/Categories.vala"
				_tmp27_ = (const gchar*) sqlite3_column_text (_tmp26_, 0);
#line 350 "../src/font-manager/Categories.vala"
				_tmp28_ = g_strdup (_tmp27_);
#line 350 "../src/font-manager/Categories.vala"
				_type = _tmp28_;
#line 351 "../src/font-manager/Categories.vala"
				_tmp29_ = _type;
#line 351 "../src/font-manager/Categories.vala"
				_tmp30_ = g_strdup (g_dgettext (NULL, _tmp29_));
#line 351 "../src/font-manager/Categories.vala"
				type = _tmp30_;
#line 352 "../src/font-manager/Categories.vala"
				_tmp31_ = filter;
#line 352 "../src/font-manager/Categories.vala"
				_tmp32_ = font_manager_category_get_children (_tmp31_);
#line 352 "../src/font-manager/Categories.vala"
				_tmp33_ = _tmp32_;
#line 352 "../src/font-manager/Categories.vala"
				_tmp34_ = type;
#line 352 "../src/font-manager/Categories.vala"
				_tmp35_ = type;
#line 352 "../src/font-manager/Categories.vala"
				_tmp36_ = string_to_string (FONT_MANAGER_SELECT_FROM_METADATA_WHERE);
#line 352 "../src/font-manager/Categories.vala"
				_tmp37_ = keyword;
#line 352 "../src/font-manager/Categories.vala"
				_tmp38_ = string_to_string (_tmp37_);
#line 352 "../src/font-manager/Categories.vala"
				_tmp39_ = _type;
#line 352 "../src/font-manager/Categories.vala"
				_tmp40_ = string_to_string (_tmp39_);
#line 352 "../src/font-manager/Categories.vala"
				_tmp41_ = g_strconcat (_tmp36_, " [", _tmp38_, "]='", _tmp40_, "';", NULL);
#line 352 "../src/font-manager/Categories.vala"
				_tmp42_ = _tmp41_;
#line 352 "../src/font-manager/Categories.vala"
				_tmp43_ = *data;
#line 352 "../src/font-manager/Categories.vala"
				_tmp44_ = font_manager_category_new (_tmp34_, _tmp35_, "emblem-documents", _tmp42_, _tmp43_.index);
#line 352 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp33_, _tmp44_);
#line 352 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp42_);
#line 349 "../src/font-manager/Categories.vala"
				_g_free0 (type);
#line 349 "../src/font-manager/Categories.vala"
				_g_free0 (_type);
#line 3894 "Categories.c"
			}
#line 349 "../src/font-manager/Categories.vala"
			_g_object_unref0 (_row_it);
#line 3898 "Categories.c"
		}
#line 354 "../src/font-manager/Categories.vala"
		font_manager_database_end_query (db);
#line 3902 "Categories.c"
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		GError* e = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 347 "../src/font-manager/Categories.vala"
		e = _inner_error0_;
#line 347 "../src/font-manager/Categories.vala"
		_inner_error0_ = NULL;
#line 356 "../src/font-manager/Categories.vala"
		_tmp45_ = e;
#line 356 "../src/font-manager/Categories.vala"
		_tmp46_ = _tmp45_->message;
#line 356 "../src/font-manager/Categories.vala"
		g_warning ("Categories.vala:356: %s", _tmp46_);
#line 347 "../src/font-manager/Categories.vala"
		_g_error_free0 (e);
#line 3922 "Categories.c"
	}
	__finally0:
#line 347 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 347 "../src/font-manager/Categories.vala"
		_g_object_unref0 (filter);
#line 347 "../src/font-manager/Categories.vala"
		_g_free0 (comment);
#line 347 "../src/font-manager/Categories.vala"
		_g_free0 (name);
#line 347 "../src/font-manager/Categories.vala"
		_g_free0 (keyword);
#line 347 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 347 "../src/font-manager/Categories.vala"
		return NULL;
#line 3941 "Categories.c"
	}
#line 358 "../src/font-manager/Categories.vala"
	_tmp47_ = filter;
#line 358 "../src/font-manager/Categories.vala"
	_tmp48_ = font_manager_category_get_children (_tmp47_);
#line 358 "../src/font-manager/Categories.vala"
	_tmp49_ = _tmp48_;
#line 358 "../src/font-manager/Categories.vala"
	g_ptr_array_foreach (_tmp49_, ___lambda37__gfunc, NULL);
#line 359 "../src/font-manager/Categories.vala"
	result = filter;
#line 359 "../src/font-manager/Categories.vala"
	_g_free0 (comment);
#line 359 "../src/font-manager/Categories.vala"
	_g_free0 (name);
#line 359 "../src/font-manager/Categories.vala"
	_g_free0 (keyword);
#line 359 "../src/font-manager/Categories.vala"
	return result;
#line 3961 "Categories.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

