/* PreviewPage.c generated by valac 0.56.18, the Vala compiler
 * generated from PreviewPage.vala, do not modify */

/* PreviewPage.vala
 *
 * Copyright (C) 2020-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <webkit/webkit.h>
#include "config.h"
#include "font-manager.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include "vala-common.h"
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <locale.h>

#define HEADER "\n" \
"<html dir=\"%s\">\n" \
"  <head>\n" \
"    <style>\n" \
"      body, textarea {\n" \
"        color: %s;\n" \
"        background-color: %s;\n" \
"      }\n" \
"      textarea {\n" \
"        width: 95%;\n" \
"        height: 95%;\n" \
"        resize: none;\n" \
"        wrap: soft;\n" \
"        -webkit-box-sizing: border-box;\n" \
"      }\n" \
"      .aligned {\n" \
"        text-align: %s;\n" \
"      }\n" \
"      .padded {\n" \
"        padding: 64px;\n" \
"      }\n" \
"      .bodyText {\n" \
"        margin: 12px 8px 12px 8px;\n" \
"        text-align: justify;\n" \
"      }\n" \
"      .previewText {\n" \
"        font-size: %.0lfpx;\n" \
"        font-family: %s, adobe-notdef;\n" \
"        font-style: %s;\n" \
"        font-weight: %i;\n" \
"      }\n" \
"      .noWrap {\n" \
"        overflow: visible;\n" \
"        white-space: nowrap;\n" \
"        display:block;\n" \
"        width:100%;\n" \
"      }\n" \
"      %s\n" \
"      @font-face {\n" \
"            font-family: 'adobe-notdef';\n" \
"            src:\n" \
"                url('https://github.com/adobe-fonts/adobe-notdef/blob/" \
"master/AND-Regular.ttf?raw=true')\n" \
"                format('truetype');\n" \
"      }\n" \
"    </style>\n" \
"  </head>\n" \
"  <script>\n" \
"    function onInput() {\n" \
"      document.title = document.getElementById(\"textArea\").value;\n" \
"    }\n" \
"  </script>\n" \
"  <body oncontextmenu=\"return false;\">\n" \
"    <div>\n"
#define WATERFALL_ROW "\n" \
"      <p id=\"%.0lf\" class=\"noWrap\">\n" \
"        <span style=\"font-family: monospace;font-size: 10px;\">%s</sp" \
"an>\n" \
"        <span class=\"previewText\" style=\"font-size:%.0lfpx;\">%s</s" \
"pan>\n" \
"      </p>\n"
#define BODY_TEXT "\n" \
"      <p class=\"bodyText\">\n" \
"        <span class=\"previewText\">%s</span>\n" \
"      </p>\n"
#define ACTIVE_PREVIEW "\n" \
"      <div class=\"aligned\">\n" \
"        <div class=\"padded\">\n" \
"          <p class=\"previewText\" style=\"white-space: pre-line;\">%s" \
"</p>\n" \
"        </div>\n" \
"      </div>\n"
#define DEFAULT_ACTIVE_TEXT "\n" \
"The quick brown fox jumps over the lazy dog.\n" \
"ABCDEFGHIJKLMNOPQRSTUVWXYZ\n" \
"abcdefghijklmnopqrstuvwxyz\n" \
"1234567890.:,;(*!?')\n"
#define FOOTER "\n    </div>\n  </body>\n</html>\n"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE (font_manager_google_fonts_preview_page_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPageClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPageClass))

typedef struct _FontManagerGoogleFontsPreviewPage FontManagerGoogleFontsPreviewPage;
typedef struct _FontManagerGoogleFontsPreviewPageClass FontManagerGoogleFontsPreviewPageClass;
typedef struct _FontManagerGoogleFontsPreviewPagePrivate FontManagerGoogleFontsPreviewPagePrivate;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;

#define FONT_MANAGER_TYPE_PREVIEW_ENTRY (font_manager_preview_entry_get_type ())
#define FONT_MANAGER_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntry))
#define FONT_MANAGER_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))
#define FONT_MANAGER_IS_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_IS_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_PREVIEW_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))

typedef struct _FontManagerPreviewEntry FontManagerPreviewEntry;
typedef struct _FontManagerPreviewEntryClass FontManagerPreviewEntryClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST (font_manager_google_fonts_sample_list_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleList))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))

typedef struct _FontManagerGoogleFontsSampleList FontManagerGoogleFontsSampleList;
typedef struct _FontManagerGoogleFontsSampleListClass FontManagerGoogleFontsSampleListClass;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL (font_manager_google_fonts_sample_model_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModel))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))

typedef struct _FontManagerGoogleFontsSampleModel FontManagerGoogleFontsSampleModel;
typedef struct _FontManagerGoogleFontsSampleModelClass FontManagerGoogleFontsSampleModelClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerGoogleFontsPreviewPage {
	GtkBox parent_instance;
	FontManagerGoogleFontsPreviewPagePrivate * priv;
};

struct _FontManagerGoogleFontsPreviewPageClass {
	GtkBoxClass parent_class;
};

struct _FontManagerGoogleFontsPreviewPagePrivate {
	gint _predefined_size;
	gboolean _show_line_size;
	gdouble _preview_size;
	gdouble _min_waterfall_size;
	gdouble _max_waterfall_size;
	gdouble _waterfall_size_ratio;
	GObject* _selected_item;
	GtkJustification _justification;
	FontManagerPreviewPageMode _preview_mode;
	FontManagerWaterfallSettings* _waterfall_settings;
	gchar* _preview_text;
	gchar* waterfall_body;
	gchar* _active_preview_text;
	gchar* default_pangram;
	GtkCenterBox* controls;
	GtkMenuButton* menu_button;
	GtkMenuButton* sample_button;
	FontManagerPreviewColors* preview_colors;
	FontManagerGoogleFontsFont* font;
	FontManagerFontScale* fontscale;
	FontManagerPreviewEntry* entry;
	FontManagerPreviewControls* preview_controls;
	FontManagerGoogleFontsSampleList* samples;
	GdkRectangle clicked_area;
	WebKitWebView* webview;
	GtkRevealer* controls_revealer;
	GtkRevealer* fontscale_revealer;
	GtkStack* preview_stack;
	GtkTextView* textview;
	gchar** requires_reload;
	gint requires_reload_length1;
	gint _requires_reload_size_;
	gchar** affects_waterfall;
	gint affects_waterfall_length1;
	gint _affects_waterfall_size_;
};

static gint FontManagerGoogleFontsPreviewPage_private_offset;
static gpointer font_manager_google_fonts_preview_page_parent_class = NULL;

VALA_EXTERN WebKitWebView* font_manager_google_fonts_create_webview (void);
VALA_EXTERN GType font_manager_google_fonts_preview_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsPreviewPage, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN GType font_manager_preview_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPreviewEntry, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_sample_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleList, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsPreviewPage* font_manager_google_fonts_preview_page_new (void);
VALA_EXTERN FontManagerGoogleFontsPreviewPage* font_manager_google_fonts_preview_page_construct (GType object_type);
VALA_EXTERN FontManagerPreviewEntry* font_manager_preview_entry_new (void);
VALA_EXTERN FontManagerPreviewEntry* font_manager_preview_entry_construct (GType object_type);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_new (void);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_construct (GType object_type);
static void font_manager_google_fonts_preview_page_on_mode_action_activated (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      FontManagerGoogleFontsPreviewPage* self);
static void __lambda168_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_reload_preview (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda168__font_manager_preview_colors_style_updated (FontManagerPreviewColors* _sender,
                                                              gpointer self);
static void font_manager_google_fonts_preview_page_on_item_selected (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_item_selected_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self);
static void font_manager_google_fonts_preview_page_on_sample_selected (FontManagerGoogleFontsPreviewPage* self,
                                                                const gchar* sample);
static void _font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                                    const gchar* sample,
                                                                                                                    gpointer self);
static void font_manager_google_fonts_preview_page_on_undo_clicked (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked (FontManagerPreviewControls* _sender,
                                                                                                         gpointer self);
static void font_manager_google_fonts_preview_page_on_entry_changed (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                                    gpointer self);
static void font_manager_google_fonts_preview_page_update_waterfall_body (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self);
static void _font_manager_google_fonts_preview_page_reload_preview_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self);
static void font_manager_google_fonts_preview_page_on_edit_toggled (FontManagerGoogleFontsPreviewPage* self,
                                                             gboolean active);
static void _font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled (FontManagerPreviewControls* _sender,
                                                                                                         gboolean object,
                                                                                                         gpointer self);
static void __lambda176_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN FontManagerWaterfallSettings* font_manager_google_fonts_preview_page_get_waterfall_settings (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda176__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda177_ (FontManagerGoogleFontsPreviewPage* self);
static gboolean __lambda178_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self,
                                                                      gdouble value);
static gboolean ___lambda178__gsource_func (gpointer self);
static void ___lambda177__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda179_ (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda179__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void font_manager_google_fonts_preview_page_on_show_context_menu (FontManagerGoogleFontsPreviewPage* self,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y);
static void _font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                             gint n_press,
                                                                                             gdouble x,
                                                                                             gdouble y,
                                                                                             gpointer self);
static void __lambda180_ (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda180__gtk_widget_map (GtkWidget* _sender,
                                   gpointer self);
static void font_manager_google_fonts_preview_page_update_menu_button (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN FontManagerPreviewPageMode font_manager_google_fonts_preview_page_get_preview_mode (FontManagerGoogleFontsPreviewPage* self);
static GVariant* _variant_new4 (const gchar* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_restore_state (FontManagerGoogleFontsPreviewPage* self,
                                                           GSettings* settings);
static void __lambda181_ (FontManagerGoogleFontsPreviewPage* self,
                   const gchar* key);
static void ___lambda181__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                              const gchar* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_active_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                                     const gchar* value);
static gchar* _variant_get3 (GVariant* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_mode (FontManagerGoogleFontsPreviewPage* self,
                                                              FontManagerPreviewPageMode value);
static gchar* font_manager_google_fonts_preview_page_generate_waterfall (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_generate_active_preview (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_sample_list_set_items (FontManagerGoogleFontsSampleList* self,
                                                      FontManagerStringSet* value);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_preview_page_get_active_preview_text (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GObject* font_manager_google_fonts_preview_page_get_selected_item (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self);
VALA_EXTERN GType font_manager_google_fonts_sample_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleModel, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsSampleModel* font_manager_google_fonts_sample_list_get_model (FontManagerGoogleFontsSampleList* self);
static gdouble font_manager_google_fonts_preview_page_get_next_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                                   gdouble current);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_get_current_header (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GtkJustification font_manager_google_fonts_preview_page_get_justification (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_preview_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gboolean font_manager_google_fonts_preview_page_get_show_line_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN const gchar* font_manager_google_fonts_preview_page_get_preview_text (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gint font_manager_google_fonts_preview_page_get_predefined_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_predefined_size (FontManagerGoogleFontsPreviewPage* self,
                                                                 gint value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_show_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_size (FontManagerGoogleFontsPreviewPage* self,
                                                              gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_selected_item (FontManagerGoogleFontsPreviewPage* self,
                                                               GObject* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_justification (FontManagerGoogleFontsPreviewPage* self,
                                                               GtkJustification value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_waterfall_settings (FontManagerGoogleFontsPreviewPage* self,
                                                                    FontManagerWaterfallSettings* value);
static void font_manager_google_fonts_preview_page_finalize (GObject * obj);
static GType font_manager_google_fonts_preview_page_get_type_once (void);
static void _vala_font_manager_google_fonts_preview_page_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_font_manager_google_fonts_preview_page_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

WebKitWebView*
font_manager_google_fonts_create_webview (void)
{
	WebKitWebView* webview = NULL;
	WebKitWebView* _tmp0_;
	WebKitSettings* settings = NULL;
	WebKitSettings* _tmp1_ = NULL;
	WebKitWebContext* _tmp2_;
	WebKitWebContext* _tmp3_;
	WebKitWebContext* _tmp4_;
	WebKitNetworkSession* _tmp5_;
	WebKitNetworkSession* _tmp6_;
	WebKitWebView* result;
#line 115 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = (WebKitWebView*) webkit_web_view_new ();
#line 115 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp0_);
#line 115 "../src/font-manager/web/google/PreviewPage.vala"
	webview = _tmp0_;
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = webkit_settings_new ();
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_allow_modal_dialogs (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_auto_load_images (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_back_forward_navigation_gestures (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_developer_extras (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_fullscreen (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_media (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_media_stream (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_site_specific_quirks (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_smooth_scrolling (_tmp1_, TRUE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_webaudio (_tmp1_, FALSE);
#line 116 "../src/font-manager/web/google/PreviewPage.vala"
	settings = _tmp1_;
#line 128 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_user_agent_with_application_details (settings, PACKAGE_NAME, PACKAGE_VERSION);
#line 130 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_view_set_settings (webview, settings);
#line 131 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_get (webview, "web-context", &_tmp2_, NULL);
#line 131 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 131 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = _tmp3_;
#line 131 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_context_set_cache_model (_tmp4_, WEBKIT_CACHE_MODEL_DOCUMENT_BROWSER);
#line 131 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (_tmp4_);
#line 132 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = webkit_web_view_get_network_session (webview);
#line 132 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = _tmp5_;
#line 132 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_network_session_prefetch_dns (_tmp6_, "http://fonts.gstatic.com/");
#line 133 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_widget_set_expand ((GtkWidget*) webview, TRUE);
#line 134 "../src/font-manager/web/google/PreviewPage.vala"
	result = webview;
#line 134 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (settings);
#line 134 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 434 "PreviewPage.c"
}

static inline gpointer
font_manager_google_fonts_preview_page_get_instance_private (FontManagerGoogleFontsPreviewPage* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsPreviewPage_private_offset);
}

static void
__lambda168_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 448 "PreviewPage.c"
}

static void
___lambda168__font_manager_preview_colors_style_updated (FontManagerPreviewColors* _sender,
                                                         gpointer self)
{
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda168_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 457 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_item_selected_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self)
{
#line 241 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_item_selected ((FontManagerGoogleFontsPreviewPage*) self);
#line 467 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                               const gchar* sample,
                                                                                                               gpointer self)
{
#line 242 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_sample_selected ((FontManagerGoogleFontsPreviewPage*) self, sample);
#line 477 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked (FontManagerPreviewControls* _sender,
                                                                                                    gpointer self)
{
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_undo_clicked ((FontManagerGoogleFontsPreviewPage*) self);
#line 486 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                               gpointer self)
{
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_entry_changed ((FontManagerGoogleFontsPreviewPage*) self);
#line 495 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self)
{
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body ((FontManagerGoogleFontsPreviewPage*) self);
#line 505 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_reload_preview_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self)
{
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview ((FontManagerGoogleFontsPreviewPage*) self);
#line 515 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled (FontManagerPreviewControls* _sender,
                                                                                                    gboolean object,
                                                                                                    gpointer self)
{
#line 249 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_edit_toggled ((FontManagerGoogleFontsPreviewPage*) self, object);
#line 525 "PreviewPage.c"
}

static void
__lambda176_ (FontManagerGoogleFontsPreviewPage* self)
{
	GBindingFlags _flags = 0U;
	FontManagerWaterfallSettings* _tmp0_;
	FontManagerWaterfallSettings* _tmp1_;
#line 253 "../src/font-manager/web/google/PreviewPage.vala"
	_flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 254 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 254 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp0_, "predefined-size", (GObject*) self, "predefined-size", _flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 255 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 255 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp1_, "show-line-size", (GObject*) self, "show-line-size", _flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 544 "PreviewPage.c"
}

static void
___lambda176__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 252 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda176_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 554 "PreviewPage.c"
}

static gboolean
__lambda178_ (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerWaterfallSettings* _tmp0_;
	FontManagerWaterfallSettings* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	FontManagerWaterfallSettings* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	FontManagerWaterfallSettings* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gboolean result;
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_waterfall_settings_on_selection_changed (_tmp0_);
#line 261 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 261 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_waterfall_settings_get_minimum (_tmp1_);
#line 261 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 261 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_min_waterfall_size (self, _tmp3_);
#line 262 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = self->priv->_waterfall_settings;
#line 262 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = font_manager_waterfall_settings_get_maximum (_tmp4_);
#line 262 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = _tmp5_;
#line 262 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_max_waterfall_size (self, _tmp6_);
#line 263 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = self->priv->_waterfall_settings;
#line 263 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = font_manager_waterfall_settings_get_ratio (_tmp7_);
#line 263 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = _tmp8_;
#line 263 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_waterfall_size_ratio (self, _tmp9_);
#line 264 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 265 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 266 "../src/font-manager/web/google/PreviewPage.vala"
	result = G_SOURCE_REMOVE;
#line 266 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 607 "PreviewPage.c"
}

static gboolean
___lambda178__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda178_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 258 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 617 "PreviewPage.c"
}

static void
__lambda177_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 258 "../src/font-manager/web/google/PreviewPage.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda178__gsource_func, g_object_ref (self), g_object_unref);
#line 625 "PreviewPage.c"
}

static void
___lambda177__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 257 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda177_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 635 "PreviewPage.c"
}

static void
__lambda179_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 270 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 271 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 645 "PreviewPage.c"
}

static void
___lambda179__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 269 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda179_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 655 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                        gint n_press,
                                                                                        gdouble x,
                                                                                        gdouble y,
                                                                                        gpointer self)
{
#line 277 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_show_context_menu ((FontManagerGoogleFontsPreviewPage*) self, n_press, x, y);
#line 667 "PreviewPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 278 "../src/font-manager/web/google/PreviewPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 675 "PreviewPage.c"
}

static void
__lambda180_ (FontManagerGoogleFontsPreviewPage* self)
{
	GtkTextView* _tmp0_;
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->textview;
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 686 "PreviewPage.c"
}

static void
___lambda180__gtk_widget_map (GtkWidget* _sender,
                              gpointer self)
{
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda180_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 695 "PreviewPage.c"
}

FontManagerGoogleFontsPreviewPage*
font_manager_google_fonts_preview_page_construct (GType object_type)
{
	FontManagerGoogleFontsPreviewPage * self = NULL;
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
	WebKitWebView* _tmp2_;
	GtkWidget* _tmp3_;
	GtkTextView* _tmp4_ = NULL;
	GtkTextView* _tmp5_;
	GtkTextView* _tmp6_;
	FontManagerPreviewControls* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkRevealer* _tmp9_;
	FontManagerPreviewControls* _tmp10_;
	GtkRevealer* _tmp11_;
	GtkStack* _tmp12_;
	GtkStack* _tmp13_;
	GtkStack* _tmp14_;
	WebKitWebView* _tmp15_;
	GtkStack* _tmp16_;
	GtkTextView* _tmp17_;
	GtkStack* _tmp18_;
	FontManagerPreviewEntry* _tmp19_;
	GtkCenterBox* _tmp20_;
	FontManagerPreviewEntry* _tmp21_;
	FontManagerFontScale* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	FontManagerFontScale* _tmp25_;
	GtkRevealer* _tmp26_;
	FontManagerGoogleFontsSampleList* _tmp27_;
	GtkMenuButton* _tmp28_;
	FontManagerGoogleFontsSampleList* _tmp29_;
	GtkMenuButton* _tmp30_;
	FontManagerPreviewColors* _tmp31_;
	GBindingFlags flags = 0U;
	FontManagerFontScale* _tmp32_;
	FontManagerPreviewEntry* _tmp33_;
	FontManagerPreviewControls* _tmp34_;
	GtkTextView* _tmp35_;
	GtkTextView* _tmp36_;
	GtkTextBuffer* _tmp37_;
	GtkTextBuffer* _tmp38_;
	FontManagerGoogleFontsSampleList* _tmp39_;
	FontManagerPreviewControls* _tmp40_;
	FontManagerPreviewEntry* _tmp41_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	gchar** _tmp46_;
	gint _tmp46__length1;
	FontManagerPreviewControls* _tmp50_;
	GtkGesture* right_click = NULL;
	GtkGestureClick* _tmp51_ = NULL;
	WebKitWebView* _tmp52_;
	GtkEventController* _tmp53_;
	GtkTextView* _tmp54_;
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	self = (FontManagerGoogleFontsPreviewPage*) g_object_new (object_type, NULL);
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = font_manager_google_fonts_create_webview ();
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->webview);
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->webview = _tmp0_;
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->webview;
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "FontManagerFontPreviewArea");
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = self->priv->webview;
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = gtk_widget_get_first_child ((GtkWidget*) _tmp2_);
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_css_class (_tmp3_, "FontManagerFontPreviewArea");
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = (GtkTextView*) gtk_text_view_new ();
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_text_view_set_monospace (_tmp4_, TRUE);
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp4_);
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->textview);
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->textview = _tmp4_;
#line 214 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = self->priv->textview;
#line 214 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "FontManagerFontPreviewArea");
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = self->priv->textview;
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_widget_set_margin ((GtkWidget*) _tmp6_, 64);
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = (FontManagerPreviewControls*) font_manager_preview_controls_new ();
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp7_);
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_controls);
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->preview_controls = _tmp7_;
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = (GtkRevealer*) gtk_revealer_new ();
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp8_);
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->controls_revealer);
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->controls_revealer = _tmp8_;
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = self->priv->controls_revealer;
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = self->priv->preview_controls;
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_child (_tmp9_, (GtkWidget*) _tmp10_);
#line 219 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = self->priv->controls_revealer;
#line 219 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp11_);
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp12_ = (GtkStack*) gtk_stack_new ();
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp12_);
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_stack);
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->preview_stack = _tmp12_;
#line 221 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = self->priv->preview_stack;
#line 221 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp13_, "FontManagerFontPreviewArea");
#line 222 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = self->priv->preview_stack;
#line 222 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = self->priv->webview;
#line 222 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_stack_add_named (_tmp14_, (GtkWidget*) _tmp15_, "WebView");
#line 223 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = self->priv->preview_stack;
#line 223 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = self->priv->textview;
#line 223 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_stack_add_named (_tmp16_, (GtkWidget*) _tmp17_, "TextView");
#line 224 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = self->priv->preview_stack;
#line 224 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp18_);
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = font_manager_preview_entry_new ();
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp19_);
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->entry);
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->entry = _tmp19_;
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = self->priv->controls;
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = self->priv->entry;
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_center_box_set_center_widget (_tmp20_, (GtkWidget*) _tmp21_);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = (FontManagerFontScale*) font_manager_font_scale_new ();
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp22_);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->fontscale = _tmp22_;
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = (GtkRevealer*) gtk_revealer_new ();
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp23_);
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale_revealer);
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->fontscale_revealer = _tmp23_;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = self->priv->fontscale_revealer;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = self->priv->fontscale;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_child (_tmp24_, (GtkWidget*) _tmp25_);
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = self->priv->fontscale_revealer;
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp26_);
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp27_ = font_manager_google_fonts_sample_list_new ();
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp27_);
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->samples);
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->samples = _tmp27_;
#line 232 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp28_ = self->priv->sample_button;
#line 232 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp29_ = self->priv->samples;
#line 232 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_menu_button_set_popover (_tmp28_, (GtkWidget*) _tmp29_);
#line 233 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = self->priv->menu_button;
#line 233 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_set_preview_page_mode_menu_and_actions ((GtkWidget*) self, (GtkWidget*) _tmp30_, (GCallback) font_manager_google_fonts_preview_page_on_mode_action_activated);
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp31_ = self->priv->preview_colors;
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp31_, "style-updated", (GCallback) ___lambda168__font_manager_preview_colors_style_updated, self, 0);
#line 235 "../src/font-manager/web/google/PreviewPage.vala"
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 236 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp32_ = self->priv->fontscale;
#line 236 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "preview-size", (GObject*) _tmp32_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 237 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp33_ = self->priv->entry;
#line 237 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "preview-text", (GObject*) _tmp33_, "placeholder-text", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 238 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp34_ = self->priv->preview_controls;
#line 238 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "justification", (GObject*) _tmp34_, "justification", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 239 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp35_ = self->priv->textview;
#line 239 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "justification", (GObject*) _tmp35_, "justification", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp36_ = self->priv->textview;
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp37_ = gtk_text_view_get_buffer (_tmp36_);
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp38_ = _tmp37_;
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "active-preview-text", (GObject*) _tmp38_, "text", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 241 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::selected-item", (GCallback) _font_manager_google_fonts_preview_page_on_item_selected_g_object_notify, self, G_CONNECT_AFTER);
#line 242 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp39_ = self->priv->samples;
#line 242 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp39_, "row-selected", (GCallback) _font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected, self, 0);
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp40_ = self->priv->preview_controls;
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp40_, "undo-clicked", (GCallback) _font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked, self, 0);
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp41_ = self->priv->entry;
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GtkEditable*) _tmp41_, "changed", (GCallback) _font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed, self, 0);
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp42_ = self->priv->affects_waterfall;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp42__length1 = self->priv->affects_waterfall_length1;
#line 951 "PreviewPage.c"
	{
		gchar** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection = _tmp42_;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection_length1 = _tmp42__length1;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
		for (property_it = 0; property_it < property_collection_length1; property_it = property_it + 1) {
#line 963 "PreviewPage.c"
			gchar* _tmp43_;
			gchar* property = NULL;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp43_ = g_strdup (property_collection[property_it]);
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
			property = _tmp43_;
#line 970 "PreviewPage.c"
			{
				const gchar* _tmp44_;
				gchar* _tmp45_;
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp44_ = property;
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp45_ = g_strconcat ("notify::", _tmp44_, NULL);
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
				g_signal_connect_object ((GObject*) self, _tmp45_, (GCallback) _font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify, self, G_CONNECT_AFTER);
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp45_);
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (property);
#line 984 "PreviewPage.c"
			}
		}
	}
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp46_ = self->priv->requires_reload;
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp46__length1 = self->priv->requires_reload_length1;
#line 992 "PreviewPage.c"
	{
		gchar** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection = _tmp46_;
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection_length1 = _tmp46__length1;
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
		for (property_it = 0; property_it < property_collection_length1; property_it = property_it + 1) {
#line 1004 "PreviewPage.c"
			gchar* _tmp47_;
			gchar* property = NULL;
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp47_ = g_strdup (property_collection[property_it]);
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
			property = _tmp47_;
#line 1011 "PreviewPage.c"
			{
				const gchar* _tmp48_;
				gchar* _tmp49_;
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp48_ = property;
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp49_ = g_strconcat ("notify::", _tmp48_, NULL);
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
				g_signal_connect_object ((GObject*) self, _tmp49_, (GCallback) _font_manager_google_fonts_preview_page_reload_preview_g_object_notify, self, G_CONNECT_AFTER);
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp49_);
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (property);
#line 1025 "PreviewPage.c"
			}
		}
	}
#line 249 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp50_ = self->priv->preview_controls;
#line 249 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp50_, "edit-toggled", (GCallback) _font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled, self, 0);
#line 250 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 251 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 252 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::waterfall-settings", (GCallback) ___lambda176__g_object_notify, self, 0);
#line 257 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::predefined-size", (GCallback) ___lambda177__g_object_notify, self, G_CONNECT_AFTER);
#line 269 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::show-line-size", (GCallback) ___lambda179__g_object_notify, self, G_CONNECT_AFTER);
#line 273 "../src/font-manager/web/google/PreviewPage.vala"
	memset (&self->priv->clicked_area, 0, sizeof (GdkRectangle));
#line 274 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp51_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 274 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp51_, (guint) GDK_BUTTON_SECONDARY);
#line 274 "../src/font-manager/web/google/PreviewPage.vala"
	right_click = (GtkGesture*) _tmp51_;
#line 277 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (right_click, gtk_gesture_click_get_type (), GtkGestureClick), "pressed", (GCallback) _font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed, self, 0);
#line 278 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp52_ = self->priv->webview;
#line 278 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp53_ = _g_object_ref0 ((GtkEventController*) right_click);
#line 278 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp52_, _tmp53_);
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp54_ = self->priv->textview;
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GtkWidget*) _tmp54_, "map", (GCallback) ___lambda180__gtk_widget_map, self, G_CONNECT_AFTER);
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (right_click);
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	return self;
#line 1067 "PreviewPage.c"
}

FontManagerGoogleFontsPreviewPage*
font_manager_google_fonts_preview_page_new (void)
{
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	return font_manager_google_fonts_preview_page_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE);
#line 1075 "PreviewPage.c"
}

static GVariant*
_variant_new4 (const gchar* value)
{
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1083 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_update_menu_button (FontManagerGoogleFontsPreviewPage* self)
{
	GVariant* args = NULL;
	FontManagerPreviewPageMode _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
#line 283 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_preview_mode;
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = font_manager_preview_page_mode_to_string (_tmp0_);
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = _variant_new4 (_tmp1_);
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	args = _tmp2_;
#line 285 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_activate_action_variant ((GtkWidget*) self, "preview.mode", args);
#line 286 "../src/font-manager/web/google/PreviewPage.vala"
	_g_variant_unref0 (args);
#line 286 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1109 "PreviewPage.c"
}

static void
__lambda181_ (FontManagerGoogleFontsPreviewPage* self,
              const gchar* key)
{
#line 297 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (key != NULL);
#line 298 "../src/font-manager/web/google/PreviewPage.vala"
	if (g_strcmp0 (key, "preview-mode") == 0) {
#line 299 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_update_menu_button (self);
#line 1122 "PreviewPage.c"
	}
}

static void
___lambda181__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
#line 297 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda181_ ((FontManagerGoogleFontsPreviewPage*) self, key);
#line 1133 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_restore_state (FontManagerGoogleFontsPreviewPage* self,
                                                      GSettings* settings)
{
	FontManagerPreviewColors* _tmp0_;
	GSettingsBindFlags flags = 0U;
#line 289 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/font-manager/web/google/PreviewPage.vala"
	if (settings == NULL) {
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		return;
#line 1148 "PreviewPage.c"
	}
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->preview_colors;
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_preview_colors_restore_state (_tmp0_, settings);
#line 293 "../src/font-manager/web/google/PreviewPage.vala"
	flags = G_SETTINGS_BIND_DEFAULT;
#line 294 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "preview-font-size", (GObject*) self, "preview-size", flags);
#line 295 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "preview-mode", (GObject*) self, "preview-mode", flags);
#line 296 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_menu_button (self);
#line 297 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (settings, "changed", (GCallback) ___lambda181__g_settings_changed, self, G_CONNECT_AFTER);
#line 301 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "google-fonts-preview-text", (GObject*) self, "preview-text", flags);
#line 302 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1168 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_sample_selected (FontManagerGoogleFontsPreviewPage* self,
                                                           const gchar* sample)
{
	FontManagerPreviewEntry* _tmp0_;
	FontManagerPreviewPageMode _tmp1_;
#line 305 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (sample != NULL);
#line 306 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->entry;
#line 306 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, sample);
#line 307 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_preview_mode;
#line 307 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW) {
#line 308 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_text (self, sample);
#line 309 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_reload_preview (self);
#line 1193 "PreviewPage.c"
	}
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1197 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_undo_clicked (FontManagerGoogleFontsPreviewPage* self)
{
#line 314 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_active_preview_text (self, NULL);
#line 316 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 317 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1211 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_edit_toggled (FontManagerGoogleFontsPreviewPage* self,
                                                        gboolean active)
{
	const gchar* _tmp0_ = NULL;
	GtkStack* _tmp1_;
#line 320 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
	if (active) {
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = "TextView";
#line 1226 "PreviewPage.c"
	} else {
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = "WebView";
#line 1230 "PreviewPage.c"
	}
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->preview_stack;
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_stack_set_visible_child_name (_tmp1_, _tmp0_);
#line 322 "../src/font-manager/web/google/PreviewPage.vala"
	if (!active) {
#line 323 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_reload_preview (self);
#line 1240 "PreviewPage.c"
	}
#line 324 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1244 "PreviewPage.c"
}

static gchar*
_variant_get3 (GVariant* value)
{
#line 330 "../src/font-manager/web/google/PreviewPage.vala"
	return g_variant_dup_string (value, NULL);
#line 1252 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_mode_action_activated (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerPreviewPageMode mode = 0;
	gchar* param = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkMenuButton* _tmp3_;
#line 328 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (action != NULL);
#line 328 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (parameter != NULL);
#line 329 "../src/font-manager/web/google/PreviewPage.vala"
	mode = FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM;
#line 330 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = _variant_get3 (parameter);
#line 330 "../src/font-manager/web/google/PreviewPage.vala"
	param = _tmp0_;
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = param;
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
	if (g_strcmp0 (_tmp1_, "Waterfall") == 0) {
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		mode = FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 1284 "PreviewPage.c"
	}
#line 333 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = param;
#line 333 "../src/font-manager/web/google/PreviewPage.vala"
	if (g_strcmp0 (_tmp2_, "Preview") == 0) {
#line 334 "../src/font-manager/web/google/PreviewPage.vala"
		mode = FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW;
#line 1292 "PreviewPage.c"
	}
#line 335 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_preview_mode (self, mode);
#line 336 "../src/font-manager/web/google/PreviewPage.vala"
	g_simple_action_set_state (action, parameter);
#line 337 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->sample_button;
#line 337 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, mode == FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL);
#line 338 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (param);
#line 338 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1306 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_entry_changed (FontManagerGoogleFontsPreviewPage* self)
{
	const gchar* _tmp0_ = NULL;
	FontManagerPreviewEntry* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 341 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->entry;
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = gtk_entry_get_text_length ((GtkEntry*) _tmp1_);
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp3_ > ((guint) 0)) {
#line 1326 "PreviewPage.c"
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp4_ = self->priv->entry;
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp6_ = _tmp5_;
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp6_;
#line 1338 "PreviewPage.c"
	} else {
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = NULL;
#line 1342 "PreviewPage.c"
	}
#line 342 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_preview_text (self, _tmp0_);
#line 343 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1348 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_reload_preview (FontManagerGoogleFontsPreviewPage* self)
{
	gchar* html = NULL;
	gchar* _tmp0_;
	FontManagerGoogleFontsFont* _tmp1_;
	GtkMenuButton* _tmp20_;
	FontManagerPreviewPageMode _tmp21_;
	GtkRevealer* _tmp22_;
	FontManagerPreviewPageMode _tmp23_;
	FontManagerPreviewControls* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	GtkRevealer* _tmp27_;
	FontManagerPreviewPageMode _tmp28_;
	FontManagerPreviewEntry* _tmp29_;
	FontManagerPreviewPageMode _tmp30_;
	WebKitWebView* _tmp31_;
	const gchar* _tmp32_;
#line 346 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup ("<html><body><p> </p></body></html>");
#line 347 "../src/font-manager/web/google/PreviewPage.vala"
	html = _tmp0_;
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->font;
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ != NULL) {
#line 1380 "PreviewPage.c"
		FontManagerPreviewPageMode _tmp2_;
		FontManagerGoogleFontsSampleList* _tmp6_;
		FontManagerGoogleFontsFont* _tmp7_;
		FontManagerStringSet* _tmp8_;
		FontManagerStringSet* _tmp9_;
		gchar* description = NULL;
		FontManagerGoogleFontsFont* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		FontManagerGoogleFontsFont* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		FontManagerPreviewControls* _tmp18_;
		const gchar* _tmp19_;
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_mode;
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
		switch (_tmp2_) {
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL:
#line 1403 "PreviewPage.c"
			{
				gchar* _tmp3_;
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp3_ = font_manager_google_fonts_preview_page_generate_waterfall (self);
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp3_;
#line 352 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1414 "PreviewPage.c"
			}
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM:
#line 1418 "PreviewPage.c"
			{
				gchar* _tmp4_;
#line 354 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp4_ = font_manager_google_fonts_preview_page_generate_lorem_ipsum (self);
#line 354 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 354 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp4_;
#line 355 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1429 "PreviewPage.c"
			}
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW:
#line 1433 "PreviewPage.c"
			{
				gchar* _tmp5_;
#line 357 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp5_ = font_manager_google_fonts_preview_page_generate_active_preview (self);
#line 357 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 357 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp5_;
#line 358 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1444 "PreviewPage.c"
			}
			default:
			{
#line 360 "../src/font-manager/web/google/PreviewPage.vala"
				g_assert_not_reached ();
#line 1450 "PreviewPage.c"
			}
		}
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp6_ = self->priv->samples;
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp7_ = self->priv->font;
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = font_manager_google_fonts_font_get_subsets (_tmp7_);
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp9_ = _tmp8_;
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_sample_list_set_items (_tmp6_, _tmp9_);
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp10_ = self->priv->font;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp11_ = font_manager_google_fonts_font_get_family (_tmp10_);
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp12_ = _tmp11_;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp13_ = self->priv->font;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp14_ = font_manager_google_fonts_font_to_display_name (_tmp13_);
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp15_ = _tmp14_;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp16_ = g_strdup_printf ("%s %s", _tmp12_, _tmp15_);
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp17_ = _tmp16_;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_g_free0 (_tmp15_);
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		description = _tmp17_;
#line 364 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp18_ = self->priv->preview_controls;
#line 364 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp19_ = description;
#line 364 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_set (_tmp18_, "description", _tmp19_, NULL);
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
		_g_free0 (description);
#line 1491 "PreviewPage.c"
	}
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = self->priv->sample_button;
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = self->priv->_preview_mode;
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, _tmp21_ != FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM);
#line 367 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = self->priv->controls_revealer;
#line 367 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = self->priv->_preview_mode;
#line 367 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_reveal_child (_tmp22_, _tmp23_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW);
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = self->priv->preview_controls;
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = font_manager_google_fonts_preview_page_get_active_preview_text (self);
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = _tmp25_;
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_set (_tmp24_, "undo-available", g_strcmp0 (_tmp26_, DEFAULT_ACTIVE_TEXT) != 0, NULL);
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp27_ = self->priv->fontscale_revealer;
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp28_ = self->priv->_preview_mode;
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_reveal_child (_tmp27_, _tmp28_ != FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL);
#line 370 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp29_ = self->priv->entry;
#line 370 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = self->priv->_preview_mode;
#line 370 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp29_, _tmp30_ == FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL);
#line 371 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp31_ = self->priv->webview;
#line 371 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp32_ = html;
#line 371 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_view_load_html (_tmp31_, _tmp32_, NULL);
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (html);
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1535 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_item_selected (FontManagerGoogleFontsPreviewPage* self)
{
	GObject* _tmp0_;
	guint langs = 0U;
	FontManagerGoogleFontsSampleList* _tmp5_;
	FontManagerGoogleFontsSampleModel* _tmp6_;
	FontManagerGoogleFontsSampleModel* _tmp7_;
	GtkMenuButton* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 375 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_selected_item;
#line 376 "../src/font-manager/web/google/PreviewPage.vala"
	if (FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY (_tmp0_)) {
#line 1555 "PreviewPage.c"
		GObject* _tmp1_;
		FontManagerGoogleFontsFont* _tmp2_;
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp1_ = self->priv->_selected_item;
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = font_manager_google_fonts_family_get_default_variant (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily));
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->font);
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->font = _tmp2_;
#line 1566 "PreviewPage.c"
	} else {
		GObject* _tmp3_;
		FontManagerGoogleFontsFont* _tmp4_;
#line 379 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp3_ = self->priv->_selected_item;
#line 379 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont));
#line 379 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->font);
#line 379 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->font = _tmp4_;
#line 1578 "PreviewPage.c"
	}
#line 380 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 381 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = self->priv->samples;
#line 381 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = font_manager_google_fonts_sample_list_get_model (_tmp5_);
#line 381 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = _tmp6_;
#line 381 "../src/font-manager/web/google/PreviewPage.vala"
	langs = g_list_model_get_n_items ((GListModel*) _tmp7_);
#line 382 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = self->priv->sample_button;
#line 382 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup_printf (ngettext ("%i Language Sample Available ", "%i Language Samples Available", (gulong) langs), (gint) langs);
#line 382 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = _tmp9_;
#line 382 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp10_);
#line 382 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp10_);
#line 387 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1602 "PreviewPage.c"
}

static gdouble
font_manager_google_fonts_preview_page_get_next_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                           gdouble current)
{
	gdouble _tmp0_;
	gdouble next = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble result;
#line 390 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 391 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_size_ratio;
#line 391 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp0_ <= 1.0) {
#line 392 "../src/font-manager/web/google/PreviewPage.vala"
		result = current + 1.0;
#line 392 "../src/font-manager/web/google/PreviewPage.vala"
		return result;
#line 1625 "PreviewPage.c"
	}
#line 393 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_size_ratio;
#line 393 "../src/font-manager/web/google/PreviewPage.vala"
	next = current * _tmp1_;
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->_waterfall_size_ratio;
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp3_ > 1.1) {
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = floor (next);
#line 1637 "PreviewPage.c"
	} else {
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = ceil (next);
#line 1641 "PreviewPage.c"
	}
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp2_;
#line 394 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 1647 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_get_current_header (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	gchar* justify = NULL;
	gchar* _tmp1_;
	PangoDirection dir = 0;
	FontManagerPreviewEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	FontManagerPreviewPageMode _tmp5_;
	const gchar* _tmp10_ = NULL;
	FontManagerPreviewColors* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	GdkRGBA _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	FontManagerPreviewColors* _tmp16_;
	GdkRGBA _tmp17_ = {0};
	GdkRGBA _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gdouble _tmp22_;
	FontManagerGoogleFontsFont* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	FontManagerGoogleFontsFont* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	FontManagerGoogleFontsFont* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	FontManagerGoogleFontsFont* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* result;
#line 397 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 397 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 397 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 399 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_strdup ("justify");
#line 399 "../src/font-manager/web/google/PreviewPage.vala"
	justify = _tmp1_;
#line 400 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = self->priv->entry;
#line 400 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = gtk_editable_get_text ((GtkEditable*) _tmp2_);
#line 400 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = _tmp3_;
#line 400 "../src/font-manager/web/google/PreviewPage.vala"
	dir = pango_find_base_dir (_tmp4_, -1);
#line 401 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = self->priv->_preview_mode;
#line 401 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp5_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW) {
#line 1711 "PreviewPage.c"
		GtkJustification _tmp6_;
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp6_ = self->priv->_justification;
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
		switch (_tmp6_) {
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_LEFT:
#line 1719 "PreviewPage.c"
			{
				gchar* _tmp7_;
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp7_ = g_strdup ("left");
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp7_;
#line 405 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1730 "PreviewPage.c"
			}
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_CENTER:
#line 1734 "PreviewPage.c"
			{
				gchar* _tmp8_;
#line 407 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp8_ = g_strdup ("center");
#line 407 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 407 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp8_;
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1745 "PreviewPage.c"
			}
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_RIGHT:
#line 1749 "PreviewPage.c"
			{
				gchar* _tmp9_;
#line 410 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp9_ = g_strdup ("right");
#line 410 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 410 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp9_;
#line 411 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1760 "PreviewPage.c"
			}
			default:
			{
#line 413 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1766 "PreviewPage.c"
			}
		}
	}
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	if (dir == PANGO_DIRECTION_RTL) {
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp10_ = "rtl";
#line 1774 "PreviewPage.c"
	} else {
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp10_ = "ltr";
#line 1778 "PreviewPage.c"
	}
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = self->priv->preview_colors;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_preview_colors_get_foreground_color (_tmp11_, &_tmp12_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = _tmp12_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = gdk_rgba_to_string (&_tmp13_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = _tmp14_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = self->priv->preview_colors;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_preview_colors_get_background_color (_tmp16_, &_tmp17_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = _tmp17_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = gdk_rgba_to_string (&_tmp18_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = _tmp19_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = justify;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = self->priv->_preview_size;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = self->priv->font;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = font_manager_google_fonts_font_get_family (_tmp23_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = _tmp24_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = self->priv->font;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp27_ = font_manager_google_fonts_font_get_style (_tmp26_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp28_ = _tmp27_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp29_ = self->priv->font;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = font_manager_google_fonts_font_get_weight (_tmp29_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp31_ = _tmp30_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp32_ = self->priv->font;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp33_ = font_manager_google_fonts_font_to_font_face_rule (_tmp32_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp34_ = _tmp33_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp35_ = g_strdup_printf (HEADER, _tmp10_, _tmp15_, _tmp20_, _tmp21_, _tmp22_, _tmp25_, _tmp28_, _tmp31_, _tmp34_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp36_ = _tmp35_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp34_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp20_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp15_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp36_;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (justify);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 1844 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_update_waterfall_body (FontManagerGoogleFontsPreviewPage* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_string_new ("");
#line 427 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp0_;
#line 1861 "PreviewPage.c"
	{
		gdouble i = 0.0;
		gdouble _tmp1_;
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp1_ = self->priv->_min_waterfall_size;
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
		i = _tmp1_;
#line 1869 "PreviewPage.c"
		{
			gboolean _tmp2_ = FALSE;
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp2_ = TRUE;
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
			while (TRUE) {
#line 1876 "PreviewPage.c"
				gdouble _tmp3_;
				gchar* pixels = NULL;
				gchar* _tmp4_;
				gboolean _tmp5_;
				GString* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
				if (!_tmp2_) {
#line 430 "../src/font-manager/web/google/PreviewPage.vala"
					i = font_manager_google_fonts_preview_page_get_next_line_size (self, i);
#line 1891 "PreviewPage.c"
				}
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp2_ = FALSE;
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp3_ = self->priv->_max_waterfall_size;
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
				if (!(i <= _tmp3_)) {
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
					break;
#line 1901 "PreviewPage.c"
				}
#line 431 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp4_ = g_strdup ("&nbsp;");
#line 431 "../src/font-manager/web/google/PreviewPage.vala"
				pixels = _tmp4_;
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp5_ = self->priv->_show_line_size;
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
				if (_tmp5_) {
#line 1911 "PreviewPage.c"
					gchar* _tmp6_ = NULL;
					gchar* _tmp9_;
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
					if (i < ((gdouble) 10)) {
#line 1916 "PreviewPage.c"
						gchar* _tmp7_;
#line 434 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp7_ = g_strdup_printf ("&nbsp;&nbsp;%.0lfpx&nbsp", i);
#line 434 "../src/font-manager/web/google/PreviewPage.vala"
						_g_free0 (_tmp6_);
#line 434 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp6_ = _tmp7_;
#line 1924 "PreviewPage.c"
					} else {
						gchar* _tmp8_;
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp8_ = g_strdup_printf ("&nbsp;%.0lfpx&nbsp;", i);
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
						_g_free0 (_tmp6_);
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp6_ = _tmp8_;
#line 1933 "PreviewPage.c"
					}
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
					_tmp9_ = g_strdup (_tmp6_);
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
					_g_free0 (pixels);
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
					pixels = _tmp9_;
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
					_g_free0 (_tmp6_);
#line 1943 "PreviewPage.c"
				}
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp10_ = builder;
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp11_ = pixels;
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp12_ = font_manager_google_fonts_preview_page_get_preview_text (self);
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp13_ = _tmp12_;
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp14_ = g_strdup_printf (WATERFALL_ROW, i, _tmp11_, i, _tmp13_);
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp15_ = _tmp14_;
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				g_string_append (_tmp10_, _tmp15_);
#line 436 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp15_);
#line 428 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (pixels);
#line 1963 "PreviewPage.c"
			}
		}
	}
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = builder;
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = _tmp16_->str;
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->waterfall_body);
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->waterfall_body = _tmp18_;
#line 439 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 439 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1981 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_active_preview (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 445 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 445 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 445 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp3_);
#line 445 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp3_);
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = font_manager_google_fonts_preview_page_get_active_preview_text (self);
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = _tmp4_;
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup_printf (ACTIVE_PREVIEW, _tmp5_);
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = _tmp6_;
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp7_);
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp7_);
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, FOOTER);
#line 448 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = builder->str;
#line 448 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 448 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp9_;
#line 448 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 448 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2041 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_waterfall (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 453 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 453 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 454 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 454 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 454 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp3_);
#line 454 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp3_);
#line 455 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = self->priv->waterfall_body;
#line 455 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp4_);
#line 456 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, FOOTER);
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = builder->str;
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp6_;
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2090 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* pref_loc = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 462 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 462 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 463 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 463 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 463 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp3_);
#line 463 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp3_);
#line 464 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = setlocale (LC_ALL, "");
#line 464 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 464 "../src/font-manager/web/google/PreviewPage.vala"
	pref_loc = _tmp5_;
#line 465 "../src/font-manager/web/google/PreviewPage.vala"
	setlocale (LC_ALL, "C");
#line 466 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup_printf (BODY_TEXT, FONT_MANAGER_LOREM_IPSUM);
#line 466 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = _tmp6_;
#line 466 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp7_);
#line 466 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp7_);
#line 467 "../src/font-manager/web/google/PreviewPage.vala"
	setlocale (LC_ALL, pref_loc);
#line 468 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, FOOTER);
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = builder->str;
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp9_;
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (pref_loc);
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 469 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2159 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_show_context_menu (FontManagerGoogleFontsPreviewPage* self,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y)
{
	gboolean _tmp0_ = FALSE;
	FontManagerWaterfallSettings* _tmp1_;
	FontManagerWaterfallSettings* _tmp3_;
	GtkPopoverMenu* _tmp4_;
	GtkPopoverMenu* _tmp5_;
	GtkWidget* _tmp6_;
	FontManagerWaterfallSettings* _tmp10_;
	GtkPopoverMenu* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	WebKitWebView* _tmp13_;
	FontManagerWaterfallSettings* _tmp14_;
	GtkPopoverMenu* _tmp15_;
	GtkPopoverMenu* _tmp16_;
	GdkRectangle _tmp17_;
	FontManagerWaterfallSettings* _tmp18_;
	GtkPopoverMenu* _tmp19_;
	GtkPopoverMenu* _tmp20_;
#line 472 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ == NULL) {
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = TRUE;
#line 2193 "PreviewPage.c"
	} else {
		FontManagerPreviewPageMode _tmp2_;
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_mode;
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp2_ != FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 2200 "PreviewPage.c"
	}
#line 473 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp0_) {
#line 474 "../src/font-manager/web/google/PreviewPage.vala"
		return;
#line 2206 "PreviewPage.c"
	}
#line 475 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.x = (gint) x;
#line 476 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.y = (gint) y;
#line 477 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.width = 2;
#line 478 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.height = 2;
#line 479 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->_waterfall_settings;
#line 479 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = font_manager_waterfall_settings_get_context_menu (_tmp3_);
#line 479 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = _tmp4_;
#line 479 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = gtk_widget_get_parent ((GtkWidget*) _tmp5_);
#line 479 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp6_ != NULL) {
#line 2226 "PreviewPage.c"
		FontManagerWaterfallSettings* _tmp7_;
		GtkPopoverMenu* _tmp8_;
		GtkPopoverMenu* _tmp9_;
#line 480 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp7_ = self->priv->_waterfall_settings;
#line 480 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = font_manager_waterfall_settings_get_context_menu (_tmp7_);
#line 480 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp9_ = _tmp8_;
#line 480 "../src/font-manager/web/google/PreviewPage.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp9_);
#line 2238 "PreviewPage.c"
	}
#line 481 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = self->priv->_waterfall_settings;
#line 481 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = font_manager_waterfall_settings_get_context_menu (_tmp10_);
#line 481 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp12_ = _tmp11_;
#line 481 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = self->priv->webview;
#line 481 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp12_, (GtkWidget*) _tmp13_);
#line 482 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = self->priv->_waterfall_settings;
#line 482 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = font_manager_waterfall_settings_get_context_menu (_tmp14_);
#line 482 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = _tmp15_;
#line 482 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = self->priv->clicked_area;
#line 482 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_popover_set_pointing_to ((GtkPopover*) _tmp16_, &_tmp17_);
#line 483 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = self->priv->_waterfall_settings;
#line 483 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = font_manager_waterfall_settings_get_context_menu (_tmp18_);
#line 483 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = _tmp19_;
#line 483 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_popover_popup ((GtkPopover*) _tmp20_);
#line 484 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 2270 "PreviewPage.c"
}

gint
font_manager_google_fonts_preview_page_get_predefined_size (FontManagerGoogleFontsPreviewPage* self)
{
	gint result;
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_predefined_size;
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2283 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_predefined_size (FontManagerGoogleFontsPreviewPage* self,
                                                            gint value)
{
	gint old_value;
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_predefined_size (self);
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_predefined_size = value;
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY]);
#line 2301 "PreviewPage.c"
	}
}

gboolean
font_manager_google_fonts_preview_page_get_show_line_size (FontManagerGoogleFontsPreviewPage* self)
{
	gboolean result;
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_show_line_size;
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2315 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_show_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                           gboolean value)
{
	gboolean old_value;
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_show_line_size (self);
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_show_line_size = value;
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY]);
#line 2333 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_preview_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_preview_size;
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2347 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_size (FontManagerGoogleFontsPreviewPage* self,
                                                         gdouble value)
{
	gdouble old_value;
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_preview_size (self);
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_preview_size = value;
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY]);
#line 2365 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_min_waterfall_size;
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2379 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_min_waterfall_size (self);
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_min_waterfall_size = value;
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY]);
#line 2397 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_max_waterfall_size;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2411 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_max_waterfall_size (self);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_max_waterfall_size = value;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY]);
#line 2429 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_waterfall_size_ratio;
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2443 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self,
                                                                 gdouble value)
{
	gdouble old_value;
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_waterfall_size_ratio (self);
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_waterfall_size_ratio = value;
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY]);
#line 2461 "PreviewPage.c"
	}
}

GObject*
font_manager_google_fonts_preview_page_get_selected_item (FontManagerGoogleFontsPreviewPage* self)
{
	GObject* result;
	GObject* _tmp0_;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_selected_item;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2478 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_selected_item (FontManagerGoogleFontsPreviewPage* self,
                                                          GObject* value)
{
	GObject* old_value;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_selected_item (self);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 2492 "PreviewPage.c"
		GObject* _tmp0_;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->_selected_item);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_selected_item = _tmp0_;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY]);
#line 2502 "PreviewPage.c"
	}
}

GtkJustification
font_manager_google_fonts_preview_page_get_justification (FontManagerGoogleFontsPreviewPage* self)
{
	GtkJustification result;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_justification;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2516 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_justification (FontManagerGoogleFontsPreviewPage* self,
                                                          GtkJustification value)
{
	GtkJustification old_value;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_justification (self);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_justification = value;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY]);
#line 2534 "PreviewPage.c"
	}
}

FontManagerPreviewPageMode
font_manager_google_fonts_preview_page_get_preview_mode (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerPreviewPageMode result;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_preview_mode;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2548 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_mode (FontManagerGoogleFontsPreviewPage* self,
                                                         FontManagerPreviewPageMode value)
{
	FontManagerPreviewPageMode old_value;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_preview_mode (self);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_preview_mode = value;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY]);
#line 2566 "PreviewPage.c"
	}
}

FontManagerWaterfallSettings*
font_manager_google_fonts_preview_page_get_waterfall_settings (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerWaterfallSettings* result;
	FontManagerWaterfallSettings* _tmp0_;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2583 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_waterfall_settings (FontManagerGoogleFontsPreviewPage* self,
                                                               FontManagerWaterfallSettings* value)
{
	FontManagerWaterfallSettings* old_value;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_waterfall_settings (self);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 2597 "PreviewPage.c"
		FontManagerWaterfallSettings* _tmp0_;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->_waterfall_settings);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_waterfall_settings = _tmp0_;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY]);
#line 2607 "PreviewPage.c"
	}
}

const gchar*
font_manager_google_fonts_preview_page_get_preview_text (FontManagerGoogleFontsPreviewPage* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_preview_text;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ != NULL) {
#line 2623 "PreviewPage.c"
		const gchar* _tmp2_;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_text;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp2_;
#line 2629 "PreviewPage.c"
	} else {
		const gchar* _tmp3_;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp3_ = self->priv->default_pangram;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp3_;
#line 2636 "PreviewPage.c"
	}
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 154 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2642 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                         const gchar* value)
{
	gchar* _tmp0_;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup (value);
#line 157 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_preview_text);
#line 157 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_text = _tmp0_;
#line 158 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_notify ((GObject*) self, "preview-text");
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY]);
#line 2662 "PreviewPage.c"
}

const gchar*
font_manager_google_fonts_preview_page_get_active_preview_text (FontManagerGoogleFontsPreviewPage* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 163 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_active_preview_text;
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ != NULL) {
#line 2677 "PreviewPage.c"
		const gchar* _tmp2_;
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_active_preview_text;
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp2_;
#line 2683 "PreviewPage.c"
	} else {
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = DEFAULT_ACTIVE_TEXT;
#line 2687 "PreviewPage.c"
	}
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 164 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2693 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_active_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                                const gchar* value)
{
	gchar* _tmp0_;
#line 166 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup (value);
#line 167 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_active_preview_text);
#line 167 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_active_preview_text = _tmp0_;
#line 168 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_notify ((GObject*) self, "active-preview-text");
#line 166 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY]);
#line 2713 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_class_init (FontManagerGoogleFontsPreviewPageClass * klass,
                                                   gpointer klass_data)
{
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_parent_class = g_type_class_peek_parent (klass);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsPreviewPage_private_offset);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_preview_page_get_property;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_preview_page_set_property;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_preview_page_finalize;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY] = g_param_spec_int ("predefined-size", "predefined-size", "predefined-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY] = g_param_spec_boolean ("show-line-size", "show-line-size", "show-line-size", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY] = g_param_spec_double ("preview-size", "preview-size", "preview-size", -G_MAXDOUBLE, G_MAXDOUBLE, 12.5, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("min-waterfall-size", "min-waterfall-size", "min-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MIN_FONT_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("max-waterfall-size", "max-waterfall-size", "max-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MAX_FONT_SIZE * 2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY] = g_param_spec_double ("waterfall-size-ratio", "waterfall-size-ratio", "waterfall-size-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY] = g_param_spec_object ("selected-item", "selected-item", "selected-item", G_TYPE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY] = g_param_spec_enum ("justification", "justification", "justification", gtk_justification_get_type (), GTK_JUSTIFY_CENTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY] = g_param_spec_enum ("preview-mode", "preview-mode", "preview-mode", font_manager_preview_page_mode_get_type (), FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY] = g_param_spec_object ("waterfall-settings", "waterfall-settings", "waterfall-settings", FONT_MANAGER_TYPE_WATERFALL_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY] = g_param_spec_string ("preview-text", "preview-text", "preview-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY] = g_param_spec_string ("active-preview-text", "active-preview-text", "active-preview-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/FontManager/FontManager/web/google/ui/google-fonts-preview-page.ui");
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, controls));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, menu_button));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sample_button", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, sample_button));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_colors", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, preview_colors));
#line 205 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_install_property_action (GTK_WIDGET_CLASS (klass), "predefined-size", "predefined-size");
#line 206 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_install_property_action (GTK_WIDGET_CLASS (klass), "show-line-size", "show-line-size");
#line 2768 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_instance_init (FontManagerGoogleFontsPreviewPage * self,
                                                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv = font_manager_google_fonts_preview_page_get_instance_private (self);
#line 141 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_show_line_size = TRUE;
#line 142 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_size = 12.5;
#line 143 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_min_waterfall_size = FONT_MANAGER_MIN_FONT_SIZE;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_max_waterfall_size = FONT_MANAGER_MAX_FONT_SIZE * 2;
#line 145 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_waterfall_size_ratio = 1.1;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_selected_item = NULL;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_justification = GTK_JUSTIFY_CENTER;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_mode = FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 172 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_text = NULL;
#line 173 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->waterfall_body = NULL;
#line 174 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_active_preview_text = NULL;
#line 175 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup ("The quick brown fox jumps over the lazy dog.");
#line 175 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->default_pangram = _tmp0_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_strdup ("preview-text");
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = g_strdup ("preview-size");
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = g_strdup ("preview-mode");
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = g_strdup ("justification");
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = g_new0 (gchar*, 4 + 1);
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[0] = _tmp1_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[1] = _tmp2_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[2] = _tmp3_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[3] = _tmp4_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload = _tmp5_;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload_length1 = 4;
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_requires_reload_size_ = self->priv->requires_reload_length1;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup ("min-waterfall-size");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = g_strdup ("max-waterfall-size");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = g_strdup ("waterfall-size-ratio");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup ("preview-text");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = g_strdup ("show-line-size");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = g_new0 (gchar*, 5 + 1);
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[0] = _tmp6_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[1] = _tmp7_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[2] = _tmp8_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[3] = _tmp9_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[4] = _tmp10_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall = _tmp11_;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall_length1 = 5;
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_affects_waterfall_size_ = self->priv->affects_waterfall_length1;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2869 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_finalize (GObject * obj)
{
	FontManagerGoogleFontsPreviewPage * self;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->_selected_item);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->_waterfall_settings);
#line 172 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_preview_text);
#line 173 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->waterfall_body);
#line 174 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_active_preview_text);
#line 175 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->default_pangram);
#line 182 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->font);
#line 183 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale);
#line 184 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->entry);
#line 185 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_controls);
#line 186 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->samples);
#line 188 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->webview);
#line 189 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->controls_revealer);
#line 190 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale_revealer);
#line 191 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_stack);
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->textview);
#line 194 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload = (_vala_array_free (self->priv->requires_reload, self->priv->requires_reload_length1, (GDestroyNotify) g_free), NULL);
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall = (_vala_array_free (self->priv->affects_waterfall, self->priv->affects_waterfall_length1, (GDestroyNotify) g_free), NULL);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_preview_page_parent_class)->finalize (obj);
#line 2916 "PreviewPage.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsPreviewPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_preview_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsPreviewPage), 0, (GInstanceInitFunc) font_manager_google_fonts_preview_page_instance_init, NULL };
	GType font_manager_google_fonts_preview_page_type_id;
	font_manager_google_fonts_preview_page_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerGoogleFontsPreviewPage", &g_define_type_info, 0);
	FontManagerGoogleFontsPreviewPage_private_offset = g_type_add_instance_private (font_manager_google_fonts_preview_page_type_id, sizeof (FontManagerGoogleFontsPreviewPagePrivate));
	return font_manager_google_fonts_preview_page_type_id;
}

GType
font_manager_google_fonts_preview_page_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_page_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_page_type_id__once)) {
		GType font_manager_google_fonts_preview_page_type_id;
		font_manager_google_fonts_preview_page_type_id = font_manager_google_fonts_preview_page_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_page_type_id__once, font_manager_google_fonts_preview_page_type_id);
	}
	return font_manager_google_fonts_preview_page_type_id__once;
}

static void
_vala_font_manager_google_fonts_preview_page_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	switch (property_id) {
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_int (value, font_manager_google_fonts_preview_page_get_predefined_size (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_boolean (value, font_manager_google_fonts_preview_page_get_show_line_size (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_preview_size (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_min_waterfall_size (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_max_waterfall_size (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_waterfall_size_ratio (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_page_get_selected_item (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_enum (value, font_manager_google_fonts_preview_page_get_justification (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_enum (value, font_manager_google_fonts_preview_page_get_preview_mode (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_page_get_waterfall_settings (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_string (value, font_manager_google_fonts_preview_page_get_preview_text (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_string (value, font_manager_google_fonts_preview_page_get_active_preview_text (self));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3023 "PreviewPage.c"
		default:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3029 "PreviewPage.c"
	}
}

static void
_vala_font_manager_google_fonts_preview_page_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	switch (property_id) {
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_predefined_size (self, g_value_get_int (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_show_line_size (self, g_value_get_boolean (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_size (self, g_value_get_double (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_min_waterfall_size (self, g_value_get_double (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_max_waterfall_size (self, g_value_get_double (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_waterfall_size_ratio (self, g_value_get_double (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_selected_item (self, g_value_get_object (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_justification (self, g_value_get_enum (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_mode (self, g_value_get_enum (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_waterfall_settings (self, g_value_get_object (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_text (self, g_value_get_string (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_ACTIVE_PREVIEW_TEXT_PROPERTY:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_active_preview_text (self, g_value_get_string (value));
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3115 "PreviewPage.c"
		default:
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3121 "PreviewPage.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 60 "../src/font-manager/FontModel.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 3132 "PreviewPage.c"
		gssize i;
#line 60 "../src/font-manager/FontModel.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 60 "../src/font-manager/FontModel.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 60 "../src/font-manager/FontModel.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3140 "PreviewPage.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 60 "../src/font-manager/FontModel.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 60 "../src/font-manager/FontModel.vala"
	g_free (array);
#line 3155 "PreviewPage.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 60 "../src/font-manager/FontModel.vala"
	if (mem && byte_size != 0) {
#line 60 "../src/font-manager/FontModel.vala"
		new_mem = g_malloc (byte_size);
#line 60 "../src/font-manager/FontModel.vala"
		memcpy (new_mem, mem, byte_size);
#line 3169 "PreviewPage.c"
	} else {
#line 60 "../src/font-manager/FontModel.vala"
		new_mem = NULL;
#line 3173 "PreviewPage.c"
	}
#line 60 "../src/font-manager/FontModel.vala"
	return new_mem;
#line 3177 "PreviewPage.c"
}

