/* WebFont.c generated by valac 0.56.18, the Vala compiler
 * generated from WebFont.vala, do not modify */

/* WebFont.vala
 *
 * Copyright (C) 2020-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include "font-manager.h"
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <glib/gstdio.h>

#define FONT_MANAGER_GOOGLE_FONTS_FONT_FACE "\n" \
"    @font-face {\n" \
"        font-family: '%s';\n" \
"        font-style: %s;\n" \
"        font-weight: %i;\n" \
"        src: local('%s'), local('%s'), url(%s) format('truetype');\n" \
"    }\n" \
"    "
#define FONT_MANAGER_GOOGLE_FONTS_GET "GET"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE
} FontManagerGoogleFontsFileStatus;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FILE_STATUS (font_manager_google_fonts_file_status_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;
typedef struct _FontManagerGoogleFontsFamilyPrivate FontManagerGoogleFontsFamilyPrivate;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_INCONSISTENT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block40Data Block40Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block41Data Block41Data;
typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN = 100,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT = 200,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT = 300,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR = 400,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM = 500,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD = 600,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD = 700,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD = 800,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK = 900
} FontManagerGoogleFontsWeight;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_WEIGHT (font_manager_google_fonts_weight_get_type ())
typedef struct _Block42Data Block42Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block43Data Block43Data;
typedef struct _Block44Data Block44Data;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_CHANGED_SIGNAL,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_SIGNALS
};
static guint font_manager_google_fonts_family_signals[FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_SIGNALS] = {0};
typedef struct _FontManagerGoogleFontsFontPrivate FontManagerGoogleFontsFontPrivate;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FONT_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_INCONSISTENT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FONT_CHANGED_SIGNAL,
	FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_SIGNALS
};
static guint font_manager_google_fonts_font_signals[FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerGoogleFontsFamily {
	GObject parent_instance;
	FontManagerGoogleFontsFamilyPrivate * priv;
};

struct _FontManagerGoogleFontsFamilyClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFamilyPrivate {
	guint _position;
	gchar* _family;
	gchar* _category;
	GPtrArray* _variants;
	FontManagerStringSet* _subsets;
	gint _version;
};

struct _Block40Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	JsonObject* filelist;
};

struct _Block41Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	FontManagerGoogleFontsFont* _result_;
};

struct _Block42Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	GString* builder;
};

struct _Block43Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	gboolean value;
};

struct _Block44Data {
	int _ref_count_;
	Block43Data * _data43_;
	FontManagerGoogleFontsFont* entry;
};

struct _FontManagerGoogleFontsFont {
	GObject parent_instance;
	FontManagerGoogleFontsFontPrivate * priv;
};

struct _FontManagerGoogleFontsFontClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFontPrivate {
	guint _position;
	gchar* _family;
	gchar* _url;
	gint _weight;
	gboolean _italic;
	gint _version;
	FontManagerStringSet* _subsets;
};

static gint FontManagerGoogleFontsFamily_private_offset;
static gpointer font_manager_google_fonts_family_parent_class = NULL;
static gint FontManagerGoogleFontsFont_private_offset;
static gpointer font_manager_google_fonts_font_parent_class = NULL;

VALA_EXTERN GType font_manager_google_fonts_file_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_new (JsonObject* source);
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_construct (GType object_type,
                                                                          JsonObject* source);
static Block40Data* block40_data_ref (Block40Data* _data40_);
static void block40_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                                  const gchar* value);
VALA_EXTERN void font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                                    const gchar* value);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                                    GPtrArray* value);
VALA_EXTERN void font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                                   FontManagerStringSet* value);
static void __lambda169_ (Block40Data* _data40_,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_new (const gchar* family,
                                                                const gchar* variant,
                                                                const gchar* url,
                                                                FontManagerStringSet* subsets);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_construct (GType object_type,
                                                                      const gchar* family,
                                                                      const gchar* variant,
                                                                      const gchar* url,
                                                                      FontManagerStringSet* subsets);
VALA_EXTERN GPtrArray* font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self);
static void __lambda170_ (FontManagerGoogleFontsFamily* self);
static gboolean __lambda171_ (FontManagerGoogleFontsFamily* self);
static gboolean ___lambda171__gsource_func (gpointer self);
static void ___lambda170__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void ___lambda169__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static void __lambda172_ (FontManagerGoogleFontsFamily* self,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
static void ___lambda172__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self);
static void font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                                   gint value);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self);
static Block41Data* block41_data_ref (Block41Data* _data41_);
static void block41_data_unref (void * _userdata_);
static void __lambda173_ (Block41Data* _data41_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gboolean font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN GType font_manager_google_fonts_weight_get_type (void) G_GNUC_CONST ;
static void ___lambda173__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN gchar* font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self);
static Block42Data* block42_data_ref (Block42Data* _data42_);
static void block42_data_unref (void * _userdata_);
static void __lambda174_ (Block42Data* _data42_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
static void ___lambda174__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gboolean font_manager_google_fonts_font_get_active (FontManagerGoogleFontsFont* self);
VALA_EXTERN guint font_manager_google_fonts_family_get_position (FontManagerGoogleFontsFamily* self);
VALA_EXTERN void font_manager_google_fonts_family_set_position (FontManagerGoogleFontsFamily* self,
                                                    guint value);
VALA_EXTERN gboolean font_manager_google_fonts_family_get_inconsistent (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gboolean font_manager_google_fonts_family_get_active (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self);
VALA_EXTERN void font_manager_google_fonts_family_set_active (FontManagerGoogleFontsFamily* self,
                                                  gboolean value);
static Block43Data* block43_data_ref (Block43Data* _data43_);
static void block43_data_unref (void * _userdata_);
static Block44Data* block44_data_ref (Block44Data* _data44_);
static void block44_data_unref (void * _userdata_);
static gboolean _font_manager_google_fonts_family_active_____lambda175_ (Block44Data* _data44_);
VALA_EXTERN void font_manager_google_fonts_font_set_active (FontManagerGoogleFontsFont* self,
                                                gboolean value);
static gboolean __font_manager_google_fonts_family_active_____lambda175__gsource_func (gpointer self);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self);
static void font_manager_google_fonts_family_finalize (GObject * obj);
static GType font_manager_google_fonts_family_get_type_once (void);
static void _vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_translatable_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN void font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                                gint value);
static void font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                                 gint value);
static FontManagerGoogleFontsFileStatus font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self);
static void font_manager_google_fonts_font_set_installation_status (FontManagerGoogleFontsFont* self,
                                                             gboolean install);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self);
static GFile* font_manager_google_fonts_font_get_outdated_file (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_get_font_directory (void);
static void font_manager_google_fonts_font_remove_outdated_files (FontManagerGoogleFontsFont* self);
VALA_EXTERN gboolean font_manager_remove_directory_tree_if_empty (GFile* dir);
static void font_manager_google_fonts_font_on_download_complete (FontManagerGoogleFontsFont* self,
                                                          GObject* source,
                                                          GTask* task);
static void font_manager_google_fonts_font_download_file (GTask* task,
                                                   GObject* source,
                                                   void* data,
                                                   GCancellable* cancellable);
static void _font_manager_google_fonts_font_on_download_complete_gasync_ready_callback (GObject* source_object,
                                                                                 GTask* task,
                                                                                 gpointer self);
static void _font_manager_google_fonts_font_download_file_gtask_thread_func (GTask* task,
                                                                      GObject* source_object,
                                                                      void* task_data,
                                                                      GCancellable* cancellable);
VALA_EXTERN guint font_manager_google_fonts_font_get_position (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_position (FontManagerGoogleFontsFont* self,
                                                  guint value);
VALA_EXTERN gboolean font_manager_google_fonts_font_get_inconsistent (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                                const gchar* value);
VALA_EXTERN void font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                             const gchar* value);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                                 FontManagerStringSet* value);
static void font_manager_google_fonts_font_finalize (GObject * obj);
static GType font_manager_google_fonts_font_get_type_once (void);
static void _vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_file_status_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED", "not-installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED", "installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE", "requires-update"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_file_status_type_id;
	font_manager_google_fonts_file_status_type_id = g_enum_register_static ("FontManagerGoogleFontsFileStatus", values);
	return font_manager_google_fonts_file_status_type_id;
}

GType
font_manager_google_fonts_file_status_get_type (void)
{
	static volatile gsize font_manager_google_fonts_file_status_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_file_status_type_id__once)) {
		GType font_manager_google_fonts_file_status_type_id;
		font_manager_google_fonts_file_status_type_id = font_manager_google_fonts_file_status_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_file_status_type_id__once, font_manager_google_fonts_file_status_type_id);
	}
	return font_manager_google_fonts_file_status_type_id__once;
}

static inline gpointer
font_manager_google_fonts_family_get_instance_private (FontManagerGoogleFontsFamily* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFamily_private_offset);
}

static Block40Data*
block40_data_ref (Block40Data* _data40_)
{
#line 80 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data40_->_ref_count_);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	return _data40_;
#line 431 "WebFont.c"
}

static void
block40_data_unref (void * _userdata_)
{
	Block40Data* _data40_;
	_data40_ = (Block40Data*) _userdata_;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data40_->_ref_count_)) {
#line 441 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 80 "../src/font-manager/web/google/WebFont.vala"
		self = _data40_->self;
#line 80 "../src/font-manager/web/google/WebFont.vala"
		_json_object_unref0 (_data40_->filelist);
#line 80 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 80 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block40Data, _data40_);
#line 451 "WebFont.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 83 "../src/font-manager/web/google/WebFont.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 460 "WebFont.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 85 "../src/font-manager/web/google/WebFont.vala"
	return self ? json_object_ref (self) : NULL;
#line 468 "WebFont.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/font-manager/web/google/WebFont.vala"
	return self ? g_object_ref (self) : NULL;
#line 476 "WebFont.c"
}

static gboolean
__lambda171_ (FontManagerGoogleFontsFamily* self)
{
	gboolean result;
#line 92 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify ((GObject*) self, "active");
#line 93 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify ((GObject*) self, "inconsistent");
#line 94 "../src/font-manager/web/google/WebFont.vala"
	result = G_SOURCE_REMOVE;
#line 94 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 491 "WebFont.c"
}

static gboolean
___lambda171__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda171_ ((FontManagerGoogleFontsFamily*) self);
#line 91 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 501 "WebFont.c"
}

static void
__lambda170_ (FontManagerGoogleFontsFamily* self)
{
#line 91 "../src/font-manager/web/google/WebFont.vala"
	g_idle_add_full (G_PRIORITY_LOW, ___lambda171__gsource_func, g_object_ref (self), g_object_unref);
#line 509 "WebFont.c"
}

static void
___lambda170__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 90 "../src/font-manager/web/google/WebFont.vala"
	__lambda170_ ((FontManagerGoogleFontsFamily*) self);
#line 519 "WebFont.c"
}

static void
__lambda169_ (Block40Data* _data40_,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerGoogleFontsFamily* self;
	gchar* entry = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	FontManagerGoogleFontsFont* variant = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerGoogleFontsFont* _tmp5_;
	GPtrArray* _tmp6_;
	FontManagerGoogleFontsFont* _tmp7_;
#line 86 "../src/font-manager/web/google/WebFont.vala"
	self = _data40_->self;
#line 86 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (array != NULL);
#line 86 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (node != NULL);
#line 87 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = json_node_get_string (node);
#line 87 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 87 "../src/font-manager/web/google/WebFont.vala"
	entry = _tmp1_;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_family;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = json_object_get_string_member (_data40_->filelist, entry);
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_subsets;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = font_manager_google_fonts_font_new (_tmp2_, entry, _tmp3_, _tmp4_);
#line 88 "../src/font-manager/web/google/WebFont.vala"
	variant = _tmp5_;
#line 89 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_variants;
#line 89 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _g_object_ref0 (variant);
#line 89 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_insert (_tmp6_, (gint) index, _tmp7_);
#line 90 "../src/font-manager/web/google/WebFont.vala"
	g_signal_connect_object ((GObject*) variant, "notify::active", (GCallback) ___lambda170__g_object_notify, self, 0);
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (variant);
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (entry);
#line 573 "WebFont.c"
}

static void
___lambda169__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
#line 86 "../src/font-manager/web/google/WebFont.vala"
	__lambda169_ (self, array, index_, element_node);
#line 584 "WebFont.c"
}

static void
__lambda172_ (FontManagerGoogleFontsFamily* self,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerStringSet* _tmp0_;
	const gchar* _tmp1_;
#line 98 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (array != NULL);
#line 98 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (node != NULL);
#line 99 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 99 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = json_node_get_string (node);
#line 99 "../src/font-manager/web/google/WebFont.vala"
	font_manager_string_set_add (_tmp0_, _tmp1_);
#line 605 "WebFont.c"
}

static void
___lambda172__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
#line 98 "../src/font-manager/web/google/WebFont.vala"
	__lambda172_ ((FontManagerGoogleFontsFamily*) self, array, index_, element_node);
#line 616 "WebFont.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 638 "WebFont.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 642 "WebFont.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 648 "WebFont.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 652 "WebFont.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 656 "WebFont.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 664 "WebFont.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 692 "WebFont.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 701 "WebFont.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 715 "WebFont.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 724 "WebFont.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 738 "WebFont.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 747 "WebFont.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 756 "WebFont.c"
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_construct (GType object_type,
                                            JsonObject* source)
{
	FontManagerGoogleFontsFamily * self = NULL;
	Block40Data* _data40_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerStringSet* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	JsonArray* _tmp8_;
	JsonArray* _tmp9_;
	gchar** _version = NULL;
	GPtrArray* _tmp10_;
	gconstpointer _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _version_length1;
	gint __version_size_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	_data40_ = g_slice_new0 (Block40Data);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	_data40_->_ref_count_ = 1;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	self = (FontManagerGoogleFontsFamily*) g_object_new (object_type, NULL);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	_data40_->self = g_object_ref (self);
#line 81 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = json_object_get_string_member (source, "family");
#line 81 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_family (self, _tmp0_);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = json_object_get_string_member (source, "category");
#line 82 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_category (self, _tmp1_);
#line 83 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 83 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 83 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_variants (self, _tmp3_);
#line 83 "../src/font-manager/web/google/WebFont.vala"
	_g_ptr_array_unref0 (_tmp3_);
#line 84 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = font_manager_string_set_new ();
#line 84 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = _tmp4_;
#line 84 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_subsets (self, _tmp5_);
#line 84 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (_tmp5_);
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = json_object_get_object_member (source, "files");
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _json_object_ref0 (_tmp6_);
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_data40_->filelist = _tmp7_;
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = json_object_get_array_member (source, "variants");
#line 86 "../src/font-manager/web/google/WebFont.vala"
	json_array_foreach_element (_tmp8_, ___lambda169__json_array_foreach, _data40_);
#line 98 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = json_object_get_array_member (source, "subsets");
#line 98 "../src/font-manager/web/google/WebFont.vala"
	json_array_foreach_element (_tmp9_, ___lambda172__json_array_foreach, self);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = self->priv->_variants;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = g_ptr_array_index (_tmp10_, (guint) 0);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = font_manager_google_fonts_font_get_url ((FontManagerGoogleFontsFont*) _tmp11_);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "/", 0);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_version = _tmp15_;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_version_length1 = _vala_array_length (_tmp14_);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	__version_size_ = _version_length1;
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = _version[_version_length1 - 2];
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = string_replace (_tmp16_, "v", "");
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp18_ = _tmp17_;
#line 102 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_version (self, atoi (_tmp18_));
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp18_);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	block40_data_unref (_data40_);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	_data40_ = NULL;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	return self;
#line 869 "WebFont.c"
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_new (JsonObject* source)
{
#line 80 "../src/font-manager/web/google/WebFont.vala"
	return font_manager_google_fonts_family_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, source);
#line 877 "WebFont.c"
}

static Block41Data*
block41_data_ref (Block41Data* _data41_)
{
#line 105 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data41_->_ref_count_);
#line 105 "../src/font-manager/web/google/WebFont.vala"
	return _data41_;
#line 887 "WebFont.c"
}

static void
block41_data_unref (void * _userdata_)
{
	Block41Data* _data41_;
	_data41_ = (Block41Data*) _userdata_;
#line 105 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data41_->_ref_count_)) {
#line 897 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 105 "../src/font-manager/web/google/WebFont.vala"
		self = _data41_->self;
#line 105 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (_data41_->_result_);
#line 105 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 105 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block41Data, _data41_);
#line 907 "WebFont.c"
	}
}

static void
__lambda173_ (Block41Data* _data41_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 107 "../src/font-manager/web/google/WebFont.vala"
	self = _data41_->self;
#line 107 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (variant != NULL);
#line 108 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_get_italic (variant);
#line 108 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 109 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 932 "WebFont.c"
	}
#line 110 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = font_manager_google_fonts_font_get_weight (variant);
#line 110 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 110 "../src/font-manager/web/google/WebFont.vala"
	if (((FontManagerGoogleFontsWeight) _tmp3_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR) {
#line 940 "WebFont.c"
		FontManagerGoogleFontsFont* _tmp4_;
#line 111 "../src/font-manager/web/google/WebFont.vala"
		_tmp4_ = _g_object_ref0 (variant);
#line 111 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (_data41_->_result_);
#line 111 "../src/font-manager/web/google/WebFont.vala"
		_data41_->_result_ = _tmp4_;
#line 948 "WebFont.c"
	}
}

static void
___lambda173__gfunc (gconstpointer data,
                     gpointer self)
{
#line 107 "../src/font-manager/web/google/WebFont.vala"
	__lambda173_ (self, (FontManagerGoogleFontsFont*) data);
#line 958 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self)
{
	Block41Data* _data41_;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FontManagerGoogleFontsFont* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	FontManagerGoogleFontsFont* result;
#line 105 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/font-manager/web/google/WebFont.vala"
	_data41_ = g_slice_new0 (Block41Data);
#line 105 "../src/font-manager/web/google/WebFont.vala"
	_data41_->_ref_count_ = 1;
#line 105 "../src/font-manager/web/google/WebFont.vala"
	_data41_->self = g_object_ref (self);
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) 0);
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) _tmp1_);
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_data41_->_result_ = _tmp2_;
#line 107 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = self->priv->_variants;
#line 107 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_foreach (_tmp3_, ___lambda173__gfunc, _data41_);
#line 113 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = _g_object_ref0 (_data41_->_result_);
#line 113 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp4_;
#line 113 "../src/font-manager/web/google/WebFont.vala"
	block41_data_unref (_data41_);
#line 113 "../src/font-manager/web/google/WebFont.vala"
	_data41_ = NULL;
#line 113 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1001 "WebFont.c"
}

static Block42Data*
block42_data_ref (Block42Data* _data42_)
{
#line 116 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data42_->_ref_count_);
#line 116 "../src/font-manager/web/google/WebFont.vala"
	return _data42_;
#line 1011 "WebFont.c"
}

static void
block42_data_unref (void * _userdata_)
{
	Block42Data* _data42_;
	_data42_ = (Block42Data*) _userdata_;
#line 116 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data42_->_ref_count_)) {
#line 1021 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 116 "../src/font-manager/web/google/WebFont.vala"
		self = _data42_->self;
#line 116 "../src/font-manager/web/google/WebFont.vala"
		_g_string_free0 (_data42_->builder);
#line 116 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 116 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block42Data, _data42_);
#line 1031 "WebFont.c"
	}
}

static void
__lambda174_ (Block42Data* _data42_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	self = _data42_->self;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (variant != NULL);
#line 118 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_to_font_face_rule (variant);
#line 118 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	g_string_append (_data42_->builder, _tmp1_);
#line 118 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp1_);
#line 1054 "WebFont.c"
}

static void
___lambda174__gfunc (gconstpointer data,
                     gpointer self)
{
#line 118 "../src/font-manager/web/google/WebFont.vala"
	__lambda174_ (self, (FontManagerGoogleFontsFont*) data);
#line 1063 "WebFont.c"
}

gchar*
font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self)
{
	Block42Data* _data42_;
	GString* _tmp0_;
	GPtrArray* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 116 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/font-manager/web/google/WebFont.vala"
	_data42_ = g_slice_new0 (Block42Data);
#line 116 "../src/font-manager/web/google/WebFont.vala"
	_data42_->_ref_count_ = 1;
#line 116 "../src/font-manager/web/google/WebFont.vala"
	_data42_->self = g_object_ref (self);
#line 117 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = g_string_new ("");
#line 117 "../src/font-manager/web/google/WebFont.vala"
	_data42_->builder = _tmp0_;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_variants;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_foreach (_tmp1_, ___lambda174__gfunc, _data42_);
#line 119 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = _data42_->builder->str;
#line 119 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 119 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp3_;
#line 119 "../src/font-manager/web/google/WebFont.vala"
	block42_data_unref (_data42_);
#line 119 "../src/font-manager/web/google/WebFont.vala"
	_data42_ = NULL;
#line 119 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1103 "WebFont.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5954 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5955 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5955 "glib-2.0.vapi"
	return result;
#line 1116 "WebFont.c"
}

FontManagerGoogleFontsFileStatus
font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self)
{
	FontManagerGoogleFontsFileStatus result;
#line 122 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1125 "WebFont.c"
	{
		gint i = 0;
#line 123 "../src/font-manager/web/google/WebFont.vala"
		i = 0;
#line 1130 "WebFont.c"
		{
			gboolean _tmp0_ = FALSE;
#line 123 "../src/font-manager/web/google/WebFont.vala"
			_tmp0_ = TRUE;
#line 123 "../src/font-manager/web/google/WebFont.vala"
			while (TRUE) {
#line 1137 "WebFont.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 123 "../src/font-manager/web/google/WebFont.vala"
				if (!_tmp0_) {
#line 1147 "WebFont.c"
					gint _tmp1_;
#line 123 "../src/font-manager/web/google/WebFont.vala"
					_tmp1_ = i;
#line 123 "../src/font-manager/web/google/WebFont.vala"
					i = _tmp1_ + 1;
#line 1153 "WebFont.c"
				}
#line 123 "../src/font-manager/web/google/WebFont.vala"
				_tmp0_ = FALSE;
#line 123 "../src/font-manager/web/google/WebFont.vala"
				_tmp2_ = self->priv->_variants;
#line 123 "../src/font-manager/web/google/WebFont.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 123 "../src/font-manager/web/google/WebFont.vala"
				_tmp4_ = _tmp3_;
#line 123 "../src/font-manager/web/google/WebFont.vala"
				if (!(i < _tmp4_)) {
#line 123 "../src/font-manager/web/google/WebFont.vala"
					break;
#line 1167 "WebFont.c"
				}
#line 124 "../src/font-manager/web/google/WebFont.vala"
				_tmp5_ = self->priv->_variants;
#line 124 "../src/font-manager/web/google/WebFont.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 124 "../src/font-manager/web/google/WebFont.vala"
				_tmp7_ = font_manager_google_fonts_font_get_active ((FontManagerGoogleFontsFont*) _tmp6_);
#line 124 "../src/font-manager/web/google/WebFont.vala"
				_tmp8_ = _tmp7_;
#line 124 "../src/font-manager/web/google/WebFont.vala"
				if (_tmp8_) {
#line 125 "../src/font-manager/web/google/WebFont.vala"
					result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
#line 125 "../src/font-manager/web/google/WebFont.vala"
					return result;
#line 1183 "WebFont.c"
				}
			}
		}
	}
#line 127 "../src/font-manager/web/google/WebFont.vala"
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 127 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1192 "WebFont.c"
}

guint
font_manager_google_fonts_family_get_position (FontManagerGoogleFontsFamily* self)
{
	guint result;
#line 44 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 44 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_position;
#line 44 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1205 "WebFont.c"
}

void
font_manager_google_fonts_family_set_position (FontManagerGoogleFontsFamily* self,
                                               guint value)
{
	guint old_value;
#line 44 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_position (self);
#line 44 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 44 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_position = value;
#line 44 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY]);
#line 1223 "WebFont.c"
	}
}

gboolean
font_manager_google_fonts_family_get_inconsistent (FontManagerGoogleFontsFamily* self)
{
	gboolean result;
	gboolean possibly_sensitive = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint installed = 0;
	GPtrArray* _tmp2_;
	gboolean _tmp8_ = FALSE;
#line 47 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_family_get_active (self);
#line 48 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/font-manager/web/google/WebFont.vala"
	possibly_sensitive = _tmp1_;
#line 49 "../src/font-manager/web/google/WebFont.vala"
	if (!possibly_sensitive) {
#line 50 "../src/font-manager/web/google/WebFont.vala"
		result = FALSE;
#line 50 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 1251 "WebFont.c"
	}
#line 51 "../src/font-manager/web/google/WebFont.vala"
	installed = 0;
#line 52 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_variants;
#line 1257 "WebFont.c"
	{
		GPtrArray* entry_collection = NULL;
		guint entry_index = 0U;
#line 52 "../src/font-manager/web/google/WebFont.vala"
		entry_collection = _tmp2_;
#line 52 "../src/font-manager/web/google/WebFont.vala"
		for (entry_index = 0; entry_index < entry_collection->len; entry_index = entry_index + 1) {
#line 1265 "WebFont.c"
			FontManagerGoogleFontsFont* _tmp3_;
			FontManagerGoogleFontsFont* entry = NULL;
#line 52 "../src/font-manager/web/google/WebFont.vala"
			_tmp3_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) g_ptr_array_index (entry_collection, entry_index));
#line 52 "../src/font-manager/web/google/WebFont.vala"
			entry = _tmp3_;
#line 1272 "WebFont.c"
			{
				FontManagerGoogleFontsFont* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
#line 53 "../src/font-manager/web/google/WebFont.vala"
				_tmp4_ = entry;
#line 53 "../src/font-manager/web/google/WebFont.vala"
				_tmp5_ = font_manager_google_fonts_font_get_active (_tmp4_);
#line 53 "../src/font-manager/web/google/WebFont.vala"
				_tmp6_ = _tmp5_;
#line 53 "../src/font-manager/web/google/WebFont.vala"
				if (_tmp6_) {
#line 1285 "WebFont.c"
					gint _tmp7_;
#line 54 "../src/font-manager/web/google/WebFont.vala"
					_tmp7_ = installed;
#line 54 "../src/font-manager/web/google/WebFont.vala"
					installed = _tmp7_ + 1;
#line 1291 "WebFont.c"
				}
#line 52 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (entry);
#line 1295 "WebFont.c"
			}
		}
	}
#line 55 "../src/font-manager/web/google/WebFont.vala"
	if (possibly_sensitive) {
#line 1301 "WebFont.c"
		gint _tmp9_;
		gint _tmp10_;
#line 55 "../src/font-manager/web/google/WebFont.vala"
		_tmp9_ = font_manager_google_fonts_family_get_count (self);
#line 55 "../src/font-manager/web/google/WebFont.vala"
		_tmp10_ = _tmp9_;
#line 55 "../src/font-manager/web/google/WebFont.vala"
		_tmp8_ = installed < _tmp10_;
#line 1310 "WebFont.c"
	} else {
#line 55 "../src/font-manager/web/google/WebFont.vala"
		_tmp8_ = FALSE;
#line 1314 "WebFont.c"
	}
#line 55 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp8_;
#line 55 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1320 "WebFont.c"
}

gboolean
font_manager_google_fonts_family_get_active (FontManagerGoogleFontsFamily* self)
{
	gboolean result;
#line 60 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/font-manager/web/google/WebFont.vala"
	result = font_manager_google_fonts_family_get_installation_status (self) != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 61 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1333 "WebFont.c"
}

static Block43Data*
block43_data_ref (Block43Data* _data43_)
{
#line 63 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data43_->_ref_count_);
#line 63 "../src/font-manager/web/google/WebFont.vala"
	return _data43_;
#line 1343 "WebFont.c"
}

static void
block43_data_unref (void * _userdata_)
{
	Block43Data* _data43_;
	_data43_ = (Block43Data*) _userdata_;
#line 63 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data43_->_ref_count_)) {
#line 1353 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 63 "../src/font-manager/web/google/WebFont.vala"
		self = _data43_->self;
#line 63 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 63 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block43Data, _data43_);
#line 1361 "WebFont.c"
	}
}

static Block44Data*
block44_data_ref (Block44Data* _data44_)
{
#line 64 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data44_->_ref_count_);
#line 64 "../src/font-manager/web/google/WebFont.vala"
	return _data44_;
#line 1372 "WebFont.c"
}

static void
block44_data_unref (void * _userdata_)
{
	Block44Data* _data44_;
	_data44_ = (Block44Data*) _userdata_;
#line 64 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data44_->_ref_count_)) {
#line 1382 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 64 "../src/font-manager/web/google/WebFont.vala"
		self = _data44_->_data43_->self;
#line 64 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (_data44_->entry);
#line 64 "../src/font-manager/web/google/WebFont.vala"
		block43_data_unref (_data44_->_data43_);
#line 64 "../src/font-manager/web/google/WebFont.vala"
		_data44_->_data43_ = NULL;
#line 64 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block44Data, _data44_);
#line 1394 "WebFont.c"
	}
}

static gboolean
_font_manager_google_fonts_family_active_____lambda175_ (Block44Data* _data44_)
{
	Block43Data* _data43_;
	FontManagerGoogleFontsFamily* self;
	FontManagerGoogleFontsFont* _tmp0_;
	gboolean result;
#line 65 "../src/font-manager/web/google/WebFont.vala"
	_data43_ = _data44_->_data43_;
#line 65 "../src/font-manager/web/google/WebFont.vala"
	self = _data43_->self;
#line 66 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = _data44_->entry;
#line 66 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_active (_tmp0_, _data43_->value);
#line 67 "../src/font-manager/web/google/WebFont.vala"
	result = G_SOURCE_REMOVE;
#line 67 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1417 "WebFont.c"
}

static gboolean
__font_manager_google_fonts_family_active_____lambda175__gsource_func (gpointer self)
{
	gboolean result;
	result = _font_manager_google_fonts_family_active_____lambda175_ (self);
#line 65 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1427 "WebFont.c"
}

void
font_manager_google_fonts_family_set_active (FontManagerGoogleFontsFamily* self,
                                             gboolean value)
{
	Block43Data* _data43_;
	GPtrArray* _tmp0_;
#line 63 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/font-manager/web/google/WebFont.vala"
	_data43_ = g_slice_new0 (Block43Data);
#line 63 "../src/font-manager/web/google/WebFont.vala"
	_data43_->_ref_count_ = 1;
#line 63 "../src/font-manager/web/google/WebFont.vala"
	_data43_->self = g_object_ref (self);
#line 63 "../src/font-manager/web/google/WebFont.vala"
	_data43_->value = value;
#line 64 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 1448 "WebFont.c"
	{
		GPtrArray* entry_collection = NULL;
		guint entry_index = 0U;
#line 64 "../src/font-manager/web/google/WebFont.vala"
		entry_collection = _tmp0_;
#line 64 "../src/font-manager/web/google/WebFont.vala"
		for (entry_index = 0; entry_index < entry_collection->len; entry_index = entry_index + 1) {
#line 1456 "WebFont.c"
			FontManagerGoogleFontsFont* _tmp1_;
			FontManagerGoogleFontsFont* entry = NULL;
#line 64 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) g_ptr_array_index (entry_collection, entry_index));
#line 64 "../src/font-manager/web/google/WebFont.vala"
			entry = _tmp1_;
#line 1463 "WebFont.c"
			{
				Block44Data* _data44_;
#line 64 "../src/font-manager/web/google/WebFont.vala"
				_data44_ = g_slice_new0 (Block44Data);
#line 64 "../src/font-manager/web/google/WebFont.vala"
				_data44_->_ref_count_ = 1;
#line 64 "../src/font-manager/web/google/WebFont.vala"
				_data44_->_data43_ = block43_data_ref (_data43_);
#line 64 "../src/font-manager/web/google/WebFont.vala"
				_data44_->entry = entry;
#line 65 "../src/font-manager/web/google/WebFont.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __font_manager_google_fonts_family_active_____lambda175__gsource_func, block44_data_ref (_data44_), block44_data_unref);
#line 64 "../src/font-manager/web/google/WebFont.vala"
				block44_data_unref (_data44_);
#line 64 "../src/font-manager/web/google/WebFont.vala"
				_data44_ = NULL;
#line 1480 "WebFont.c"
			}
		}
	}
#line 69 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify ((GObject*) self, "active");
#line 63 "../src/font-manager/web/google/WebFont.vala"
	block43_data_unref (_data43_);
#line 63 "../src/font-manager/web/google/WebFont.vala"
	_data43_ = NULL;
#line 63 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY]);
#line 1492 "WebFont.c"
}

const gchar*
font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_family;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1508 "WebFont.c"
}

void
font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_family (self);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1522 "WebFont.c"
		gchar* _tmp0_;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 73 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_family);
#line 73 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_family = _tmp0_;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY]);
#line 1532 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 74 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_category;
#line 74 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 74 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1549 "WebFont.c"
}

void
font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 74 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_category (self);
#line 74 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1563 "WebFont.c"
		gchar* _tmp0_;
#line 74 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_category);
#line 74 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_category = _tmp0_;
#line 74 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY]);
#line 1573 "WebFont.c"
	}
}

GPtrArray*
font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self)
{
	GPtrArray* result;
	GPtrArray* _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1590 "WebFont.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 75 "../src/font-manager/web/google/WebFont.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 1598 "WebFont.c"
}

void
font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                               GPtrArray* value)
{
	GPtrArray* old_value;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_variants (self);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 1612 "WebFont.c"
		GPtrArray* _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_ptr_array_ref0 (value);
#line 75 "../src/font-manager/web/google/WebFont.vala"
		_g_ptr_array_unref0 (self->priv->_variants);
#line 75 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_variants = _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY]);
#line 1622 "WebFont.c"
	}
}

FontManagerStringSet*
font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1639 "WebFont.c"
}

void
font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                              FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_subsets (self);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 1653 "WebFont.c"
		FontManagerStringSet* _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 76 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self->priv->_subsets);
#line 76 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_subsets = _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY]);
#line 1663 "WebFont.c"
	}
}

gint
font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self)
{
	gint result;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = _tmp1_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp2_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1686 "WebFont.c"
}

gint
font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self)
{
	gint result;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_version;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1699 "WebFont.c"
}

static void
font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                              gint value)
{
	gint old_value;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_version (self);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 78 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_version = value;
#line 78 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY]);
#line 1717 "WebFont.c"
	}
}

static void
font_manager_google_fonts_family_class_init (FontManagerGoogleFontsFamilyClass * klass,
                                             gpointer klass_data)
{
#line 40 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFamily_private_offset);
#line 40 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_family_get_property;
#line 40 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_family_set_property;
#line 40 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_family_finalize;
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY] = g_param_spec_uint ("position", "position", "position", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_INCONSISTENT_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_INCONSISTENT_PROPERTY] = g_param_spec_boolean ("inconsistent", "inconsistent", "inconsistent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY] = g_param_spec_boxed ("variants", "variants", "variants", G_TYPE_PTR_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY] = g_param_spec_int ("count", "count", "count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_signals[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1755 "WebFont.c"
}

static void
font_manager_google_fonts_family_instance_init (FontManagerGoogleFontsFamily * self,
                                                gpointer klass)
{
#line 40 "../src/font-manager/web/google/WebFont.vala"
	self->priv = font_manager_google_fonts_family_get_instance_private (self);
#line 44 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_position = (guint) 0;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_version = 1;
#line 1768 "WebFont.c"
}

static void
font_manager_google_fonts_family_finalize (GObject * obj)
{
	FontManagerGoogleFontsFamily * self;
#line 40 "../src/font-manager/web/google/WebFont.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_family);
#line 74 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_category);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	_g_ptr_array_unref0 (self->priv->_variants);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (self->priv->_subsets);
#line 40 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_family_parent_class)->finalize (obj);
#line 1787 "WebFont.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_family_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFamilyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_family_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFamily), 0, (GInstanceInitFunc) font_manager_google_fonts_family_instance_init, NULL };
	GType font_manager_google_fonts_family_type_id;
	font_manager_google_fonts_family_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFamily", &g_define_type_info, 0);
	FontManagerGoogleFontsFamily_private_offset = g_type_add_instance_private (font_manager_google_fonts_family_type_id, sizeof (FontManagerGoogleFontsFamilyPrivate));
	return font_manager_google_fonts_family_type_id;
}

GType
font_manager_google_fonts_family_get_type (void)
{
	static volatile gsize font_manager_google_fonts_family_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_family_type_id__once)) {
		GType font_manager_google_fonts_family_type_id;
		font_manager_google_fonts_family_type_id = font_manager_google_fonts_family_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_family_type_id__once, font_manager_google_fonts_family_type_id);
	}
	return font_manager_google_fonts_family_type_id__once;
}

static void
_vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 40 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_uint (value, font_manager_google_fonts_family_get_position (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_INCONSISTENT_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_family_get_inconsistent (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_family_get_active (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_family_get_family (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_family_get_category (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boxed (value, font_manager_google_fonts_family_get_variants (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_object (value, font_manager_google_fonts_family_get_subsets (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_family_get_count (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_family_get_version (self));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1876 "WebFont.c"
		default:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1882 "WebFont.c"
	}
}

static void
_vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 40 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_POSITION_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_position (self, g_value_get_uint (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_ACTIVE_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_active (self, g_value_get_boolean (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_family (self, g_value_get_string (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_category (self, g_value_get_string (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_variants (self, g_value_get_boxed (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_subsets (self, g_value_get_object (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 40 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_version (self, g_value_get_int (value));
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1938 "WebFont.c"
		default:
#line 40 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1944 "WebFont.c"
	}
}

gchar*
font_manager_google_fonts_weight_to_string (FontManagerGoogleFontsWeight self)
{
	gchar* result;
#line 145 "../src/font-manager/web/google/WebFont.vala"
	switch (self) {
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN:
#line 1956 "WebFont.c"
		{
			gchar* _tmp0_;
#line 147 "../src/font-manager/web/google/WebFont.vala"
			_tmp0_ = g_strdup ("Thin");
#line 147 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp0_;
#line 147 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 1965 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT:
#line 1969 "WebFont.c"
		{
			gchar* _tmp1_;
#line 149 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = g_strdup ("ExtraLight");
#line 149 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp1_;
#line 149 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 1978 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT:
#line 1982 "WebFont.c"
		{
			gchar* _tmp2_;
#line 151 "../src/font-manager/web/google/WebFont.vala"
			_tmp2_ = g_strdup ("Light");
#line 151 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp2_;
#line 151 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 1991 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR:
#line 1995 "WebFont.c"
		{
			gchar* _tmp3_;
#line 153 "../src/font-manager/web/google/WebFont.vala"
			_tmp3_ = g_strdup ("Regular");
#line 153 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp3_;
#line 153 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2004 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM:
#line 2008 "WebFont.c"
		{
			gchar* _tmp4_;
#line 155 "../src/font-manager/web/google/WebFont.vala"
			_tmp4_ = g_strdup ("Medium");
#line 155 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp4_;
#line 155 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2017 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD:
#line 2021 "WebFont.c"
		{
			gchar* _tmp5_;
#line 157 "../src/font-manager/web/google/WebFont.vala"
			_tmp5_ = g_strdup ("SemiBold");
#line 157 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp5_;
#line 157 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2030 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD:
#line 2034 "WebFont.c"
		{
			gchar* _tmp6_;
#line 159 "../src/font-manager/web/google/WebFont.vala"
			_tmp6_ = g_strdup ("Bold");
#line 159 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp6_;
#line 159 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2043 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD:
#line 2047 "WebFont.c"
		{
			gchar* _tmp7_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
			_tmp7_ = g_strdup ("ExtraBold");
#line 161 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp7_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2056 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK:
#line 2060 "WebFont.c"
		{
			gchar* _tmp8_;
#line 163 "../src/font-manager/web/google/WebFont.vala"
			_tmp8_ = g_strdup ("Black");
#line 163 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp8_;
#line 163 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2069 "WebFont.c"
		}
		default:
		{
#line 165 "../src/font-manager/web/google/WebFont.vala"
			g_assert_not_reached ();
#line 2075 "WebFont.c"
		}
	}
}

gchar*
font_manager_google_fonts_weight_to_translatable_string (FontManagerGoogleFontsWeight self)
{
	gchar* result;
#line 170 "../src/font-manager/web/google/WebFont.vala"
	switch (self) {
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN:
#line 2088 "WebFont.c"
		{
			gchar* _tmp0_;
#line 172 "../src/font-manager/web/google/WebFont.vala"
			_tmp0_ = g_strdup (_ ("Thin"));
#line 172 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp0_;
#line 172 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2097 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT:
#line 2101 "WebFont.c"
		{
			gchar* _tmp1_;
#line 174 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = g_strdup (_ ("ExtraLight"));
#line 174 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp1_;
#line 174 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2110 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT:
#line 2114 "WebFont.c"
		{
			gchar* _tmp2_;
#line 176 "../src/font-manager/web/google/WebFont.vala"
			_tmp2_ = g_strdup (_ ("Light"));
#line 176 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp2_;
#line 176 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2123 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR:
#line 2127 "WebFont.c"
		{
			gchar* _tmp3_;
#line 178 "../src/font-manager/web/google/WebFont.vala"
			_tmp3_ = g_strdup (_ ("Regular"));
#line 178 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp3_;
#line 178 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2136 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM:
#line 2140 "WebFont.c"
		{
			gchar* _tmp4_;
#line 180 "../src/font-manager/web/google/WebFont.vala"
			_tmp4_ = g_strdup (_ ("Medium"));
#line 180 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp4_;
#line 180 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2149 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD:
#line 2153 "WebFont.c"
		{
			gchar* _tmp5_;
#line 182 "../src/font-manager/web/google/WebFont.vala"
			_tmp5_ = g_strdup (_ ("SemiBold"));
#line 182 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp5_;
#line 182 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2162 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD:
#line 2166 "WebFont.c"
		{
			gchar* _tmp6_;
#line 184 "../src/font-manager/web/google/WebFont.vala"
			_tmp6_ = g_strdup (_ ("Bold"));
#line 184 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp6_;
#line 184 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2175 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD:
#line 2179 "WebFont.c"
		{
			gchar* _tmp7_;
#line 186 "../src/font-manager/web/google/WebFont.vala"
			_tmp7_ = g_strdup (_ ("ExtraBold"));
#line 186 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp7_;
#line 186 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2188 "WebFont.c"
		}
#line 170 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK:
#line 2192 "WebFont.c"
		{
			gchar* _tmp8_;
#line 188 "../src/font-manager/web/google/WebFont.vala"
			_tmp8_ = g_strdup (_ ("Black"));
#line 188 "../src/font-manager/web/google/WebFont.vala"
			result = _tmp8_;
#line 188 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2201 "WebFont.c"
		}
		default:
		{
#line 190 "../src/font-manager/web/google/WebFont.vala"
			g_assert_not_reached ();
#line 2207 "WebFont.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_weight_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN", "thin"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT", "extra-light"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT", "light"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR", "regular"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM", "medium"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD", "semi-bold"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD", "bold"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD", "extra-bold"}, {FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK, "FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK", "black"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_weight_type_id;
	font_manager_google_fonts_weight_type_id = g_enum_register_static ("FontManagerGoogleFontsWeight", values);
	return font_manager_google_fonts_weight_type_id;
}

GType
font_manager_google_fonts_weight_get_type (void)
{
	static volatile gsize font_manager_google_fonts_weight_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_weight_type_id__once)) {
		GType font_manager_google_fonts_weight_type_id;
		font_manager_google_fonts_weight_type_id = font_manager_google_fonts_weight_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_weight_type_id__once, font_manager_google_fonts_weight_type_id);
	}
	return font_manager_google_fonts_weight_type_id__once;
}

static inline gpointer
font_manager_google_fonts_font_get_instance_private (FontManagerGoogleFontsFont* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFont_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2255 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_construct (GType object_type,
                                          const gchar* family,
                                          const gchar* variant,
                                          const gchar* url,
                                          FontManagerStringSet* subsets)
{
	FontManagerGoogleFontsFont * self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _version = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _version_length1;
	gint __version_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 220 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (family != NULL, NULL);
#line 220 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (variant != NULL, NULL);
#line 220 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 220 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (subsets != NULL, NULL);
#line 221 "../src/font-manager/web/google/WebFont.vala"
	self = (FontManagerGoogleFontsFont*) g_object_new (object_type, "family", family, "url", url, "subsets", subsets, NULL);
#line 222 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_italic (self, string_contains (variant, "italic"));
#line 223 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (variant, "regular") == 0) {
#line 223 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = TRUE;
#line 2295 "WebFont.c"
	} else {
#line 223 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strcmp0 (variant, "italic") == 0;
#line 2299 "WebFont.c"
	}
#line 223 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp0_) {
#line 224 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, (gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
#line 2305 "WebFont.c"
	} else {
		gchar* _tmp1_ = NULL;
		gboolean _tmp2_;
#line 226 "../src/font-manager/web/google/WebFont.vala"
		_tmp2_ = self->priv->_italic;
#line 226 "../src/font-manager/web/google/WebFont.vala"
		if (_tmp2_) {
#line 2313 "WebFont.c"
			gchar* _tmp3_;
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_tmp3_ = string_replace (variant, "italic", "");
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (_tmp1_);
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = _tmp3_;
#line 2321 "WebFont.c"
		} else {
			gchar* _tmp4_;
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_tmp4_ = g_strdup (variant);
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (_tmp1_);
#line 226 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = _tmp4_;
#line 2330 "WebFont.c"
		}
#line 226 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, atoi (_tmp1_));
#line 223 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (_tmp1_);
#line 2336 "WebFont.c"
	}
#line 227 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_ = g_strsplit (url, "/", 0);
#line 227 "../src/font-manager/web/google/WebFont.vala"
	_version = _tmp6_;
#line 227 "../src/font-manager/web/google/WebFont.vala"
	_version_length1 = _vala_array_length (_tmp5_);
#line 227 "../src/font-manager/web/google/WebFont.vala"
	__version_size_ = _version_length1;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _version;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp7__length1 = _version_length1;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _version;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp8__length1 = _version_length1;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = _tmp7_[_tmp8__length1 - 2];
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = string_replace (_tmp9_, "v", "");
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 228 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_version (self, atoi (_tmp11_));
#line 228 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 229 "../src/font-manager/web/google/WebFont.vala"
	if (font_manager_google_fonts_font_get_installation_status (self) == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE) {
#line 230 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_installation_status (self, TRUE);
#line 2368 "WebFont.c"
	}
#line 220 "../src/font-manager/web/google/WebFont.vala"
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
#line 220 "../src/font-manager/web/google/WebFont.vala"
	return self;
#line 2374 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_new (const gchar* family,
                                    const gchar* variant,
                                    const gchar* url,
                                    FontManagerStringSet* subsets)
{
#line 220 "../src/font-manager/web/google/WebFont.vala"
	return font_manager_google_fonts_font_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, family, variant, url, subsets);
#line 2385 "WebFont.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2406 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 233 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 234 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 234 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _ ("Italic");
#line 2435 "WebFont.c"
	} else {
#line 234 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "";
#line 2439 "WebFont.c"
	}
#line 234 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 234 "../src/font-manager/web/google/WebFont.vala"
	ital = _tmp2_;
#line 235 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_italic;
#line 235 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp4_) {
#line 2449 "WebFont.c"
		gint _tmp5_;
#line 235 "../src/font-manager/web/google/WebFont.vala"
		_tmp5_ = self->priv->_weight;
#line 235 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = _tmp5_ == ((gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
#line 2455 "WebFont.c"
	} else {
#line 235 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = FALSE;
#line 2459 "WebFont.c"
	}
#line 235 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp3_) {
#line 236 "../src/font-manager/web/google/WebFont.vala"
		result = ital;
#line 236 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2467 "WebFont.c"
	}
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_weight;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = font_manager_google_fonts_weight_to_translatable_string ((FontManagerGoogleFontsWeight) _tmp6_);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _tmp7_;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = ital;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp8_);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp13_;
#line 237 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ital);
#line 237 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2495 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 240 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 241 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 241 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "Italic";
#line 2524 "WebFont.c"
	} else {
#line 241 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "";
#line 2528 "WebFont.c"
	}
#line 241 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 241 "../src/font-manager/web/google/WebFont.vala"
	ital = _tmp2_;
#line 242 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_italic;
#line 242 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp4_) {
#line 2538 "WebFont.c"
		gint _tmp5_;
#line 242 "../src/font-manager/web/google/WebFont.vala"
		_tmp5_ = self->priv->_weight;
#line 242 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = ((FontManagerGoogleFontsWeight) _tmp5_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR;
#line 2544 "WebFont.c"
	} else {
#line 242 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = FALSE;
#line 2548 "WebFont.c"
	}
#line 242 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp3_) {
#line 243 "../src/font-manager/web/google/WebFont.vala"
		result = ital;
#line 243 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2556 "WebFont.c"
	}
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_weight;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = font_manager_google_fonts_weight_to_string ((FontManagerGoogleFontsWeight) _tmp6_);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _tmp7_;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = ital;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp8_);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp13_;
#line 244 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ital);
#line 244 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2584 "WebFont.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 2597 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self)
{
	gchar* description = NULL;
	gchar* _tmp0_;
	gchar* local = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _local = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_ = NULL;
	gboolean _tmp15_;
	gchar* style = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gint _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 247 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_to_description (self);
#line 248 "../src/font-manager/web/google/WebFont.vala"
	description = _tmp0_;
#line 249 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_family;
#line 249 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 249 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = description;
#line 249 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 249 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = g_strconcat (_tmp2_, " ", _tmp4_, NULL);
#line 249 "../src/font-manager/web/google/WebFont.vala"
	local = _tmp5_;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_family;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = string_replace (_tmp6_, " ", "");
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _tmp7_;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = description;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = string_replace (_tmp9_, " ", "");
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = g_strdup_printf ("%s-%s", _tmp8_, _tmp11_);
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp8_);
#line 250 "../src/font-manager/web/google/WebFont.vala"
	_local = _tmp13_;
#line 251 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = self->priv->_italic;
#line 251 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp15_) {
#line 251 "../src/font-manager/web/google/WebFont.vala"
		_tmp14_ = "italic";
#line 2677 "WebFont.c"
	} else {
#line 251 "../src/font-manager/web/google/WebFont.vala"
		_tmp14_ = "normal";
#line 2681 "WebFont.c"
	}
#line 251 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = g_strdup (_tmp14_);
#line 251 "../src/font-manager/web/google/WebFont.vala"
	style = _tmp16_;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = self->priv->_family;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp18_ = self->priv->_weight;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp19_ = local;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp20_ = _local;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp21_ = self->priv->_url;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_tmp22_ = g_strdup_printf (FONT_MANAGER_GOOGLE_FONTS_FONT_FACE, _tmp17_, style, _tmp18_, _tmp19_, _tmp20_, _tmp21_);
#line 252 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp22_;
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (style);
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_local);
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (local);
#line 252 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (description);
#line 252 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2711 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self)
{
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* style = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* family = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 255 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_url;
#line 256 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = font_manager_get_file_extension (_tmp0_);
#line 256 "../src/font-manager/web/google/WebFont.vala"
	ext = _tmp1_;
#line 257 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = font_manager_google_fonts_font_to_description (self);
#line 257 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 257 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = string_replace (_tmp3_, " ", "_");
#line 257 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = _tmp4_;
#line 257 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp3_);
#line 257 "../src/font-manager/web/google/WebFont.vala"
	style = _tmp5_;
#line 258 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_family;
#line 258 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = string_replace (_tmp6_, " ", "_");
#line 258 "../src/font-manager/web/google/WebFont.vala"
	family = _tmp7_;
#line 259 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = self->priv->_version;
#line 259 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = g_strdup_printf ("%s_%s.%i.%s", family, style, _tmp8_, ext);
#line 259 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp9_;
#line 259 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (family);
#line 259 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (style);
#line 259 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ext);
#line 259 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2771 "WebFont.c"
}

static GFile*
font_manager_google_fonts_font_get_outdated_file (FontManagerGoogleFontsFont* self)
{
	GFile* font_dir = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gchar* ext = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* style = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* family = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* filename = NULL;
	gint _tmp15_;
	gchar* _tmp16_;
	GFile* outdated = NULL;
	GFile* _tmp17_;
	GFile* result;
#line 262 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_get_font_directory ();
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_family;
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = g_build_filename (_tmp1_, _tmp2_, NULL);
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = _tmp3_;
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_;
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp4_);
#line 263 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp1_);
#line 263 "../src/font-manager/web/google/WebFont.vala"
	font_dir = _tmp6_;
#line 264 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = self->priv->_url;
#line 264 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = font_manager_get_file_extension (_tmp7_);
#line 264 "../src/font-manager/web/google/WebFont.vala"
	ext = _tmp8_;
#line 265 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = font_manager_google_fonts_font_to_description (self);
#line 265 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = _tmp9_;
#line 265 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = string_replace (_tmp10_, " ", "_");
#line 265 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = _tmp11_;
#line 265 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp10_);
#line 265 "../src/font-manager/web/google/WebFont.vala"
	style = _tmp12_;
#line 266 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = self->priv->_family;
#line 266 "../src/font-manager/web/google/WebFont.vala"
	_tmp14_ = string_replace (_tmp13_, " ", "_");
#line 266 "../src/font-manager/web/google/WebFont.vala"
	family = _tmp14_;
#line 267 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = self->priv->_version;
#line 267 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = g_strdup_printf ("%s_%s.%i.%s", family, style, _tmp15_ - 1, ext);
#line 267 "../src/font-manager/web/google/WebFont.vala"
	filename = _tmp16_;
#line 268 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = g_file_get_child (font_dir, filename);
#line 268 "../src/font-manager/web/google/WebFont.vala"
	outdated = _tmp17_;
#line 269 "../src/font-manager/web/google/WebFont.vala"
	result = outdated;
#line 269 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (filename);
#line 269 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (family);
#line 269 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (style);
#line 269 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ext);
#line 269 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font_dir);
#line 269 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2872 "WebFont.c"
}

static FontManagerGoogleFontsFileStatus
font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	gchar* filepath = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* font = NULL;
	const gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* font_dir = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	FontManagerGoogleFontsFileStatus result;
#line 272 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 273 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_get_font_directory ();
#line 273 "../src/font-manager/web/google/WebFont.vala"
	dir = _tmp0_;
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = dir;
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_family;
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = font_manager_google_fonts_font_get_filename (self);
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = _tmp3_;
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = g_build_filename (_tmp1_, _tmp2_, _tmp4_, NULL);
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_;
#line 274 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp4_);
#line 274 "../src/font-manager/web/google/WebFont.vala"
	filepath = _tmp6_;
#line 275 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = filepath;
#line 275 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = g_file_new_for_path (_tmp7_);
#line 275 "../src/font-manager/web/google/WebFont.vala"
	font = _tmp8_;
#line 276 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = font;
#line 276 "../src/font-manager/web/google/WebFont.vala"
	if (g_file_query_exists (_tmp9_, NULL)) {
#line 277 "../src/font-manager/web/google/WebFont.vala"
		result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
#line 277 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (font);
#line 277 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (filepath);
#line 277 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (dir);
#line 277 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2942 "WebFont.c"
	}
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = dir;
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = self->priv->_family;
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = g_build_filename (_tmp10_, _tmp11_, NULL);
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp14_ = g_file_new_for_path (_tmp13_);
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = _tmp14_;
#line 278 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp13_);
#line 278 "../src/font-manager/web/google/WebFont.vala"
	font_dir = _tmp15_;
#line 279 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = font_dir;
#line 279 "../src/font-manager/web/google/WebFont.vala"
	if (g_file_query_exists (_tmp16_, NULL)) {
#line 2964 "WebFont.c"
		GFile* outdated = NULL;
		GFile* _tmp17_;
		GFile* _tmp18_;
#line 280 "../src/font-manager/web/google/WebFont.vala"
		_tmp17_ = font_manager_google_fonts_font_get_outdated_file (self);
#line 280 "../src/font-manager/web/google/WebFont.vala"
		outdated = _tmp17_;
#line 281 "../src/font-manager/web/google/WebFont.vala"
		_tmp18_ = outdated;
#line 281 "../src/font-manager/web/google/WebFont.vala"
		if (g_file_query_exists (_tmp18_, NULL)) {
#line 282 "../src/font-manager/web/google/WebFont.vala"
			result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE;
#line 282 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (outdated);
#line 282 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font_dir);
#line 282 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font);
#line 282 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (filepath);
#line 282 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (dir);
#line 282 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2990 "WebFont.c"
		}
#line 279 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (outdated);
#line 2994 "WebFont.c"
	}
#line 284 "../src/font-manager/web/google/WebFont.vala"
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 284 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font_dir);
#line 284 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font);
#line 284 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (filepath);
#line 284 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (dir);
#line 284 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3008 "WebFont.c"
}

static void
font_manager_google_fonts_font_remove_outdated_files (FontManagerGoogleFontsFont* self)
{
	GFile* outdated_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 287 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_get_outdated_file (self);
#line 288 "../src/font-manager/web/google/WebFont.vala"
	outdated_file = _tmp0_;
#line 289 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = outdated_file;
#line 289 "../src/font-manager/web/google/WebFont.vala"
	if (!g_file_query_exists (_tmp1_, NULL)) {
#line 290 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (outdated_file);
#line 290 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 3032 "WebFont.c"
	}
	{
		GFile* _tmp2_;
		gchar* font_dir = NULL;
		gchar* _tmp3_;
		gchar* target_dir = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		GFile* outdated_dir = NULL;
		const gchar* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 292 "../src/font-manager/web/google/WebFont.vala"
		_tmp2_ = outdated_file;
#line 292 "../src/font-manager/web/google/WebFont.vala"
		g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 292 "../src/font-manager/web/google/WebFont.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3052 "WebFont.c"
			goto __catch0_g_error;
		}
#line 293 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = font_manager_google_fonts_get_font_directory ();
#line 293 "../src/font-manager/web/google/WebFont.vala"
		font_dir = _tmp3_;
#line 294 "../src/font-manager/web/google/WebFont.vala"
		_tmp4_ = font_dir;
#line 294 "../src/font-manager/web/google/WebFont.vala"
		_tmp5_ = self->priv->_family;
#line 294 "../src/font-manager/web/google/WebFont.vala"
		_tmp6_ = g_build_filename (_tmp4_, _tmp5_, NULL);
#line 294 "../src/font-manager/web/google/WebFont.vala"
		target_dir = _tmp6_;
#line 295 "../src/font-manager/web/google/WebFont.vala"
		_tmp7_ = target_dir;
#line 295 "../src/font-manager/web/google/WebFont.vala"
		_tmp8_ = g_file_new_for_path (_tmp7_);
#line 295 "../src/font-manager/web/google/WebFont.vala"
		outdated_dir = _tmp8_;
#line 296 "../src/font-manager/web/google/WebFont.vala"
		_tmp9_ = outdated_dir;
#line 296 "../src/font-manager/web/google/WebFont.vala"
		font_manager_remove_directory_tree_if_empty (_tmp9_);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (outdated_dir);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (target_dir);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (font_dir);
#line 3083 "WebFont.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* path = NULL;
		GFile* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
#line 291 "../src/font-manager/web/google/WebFont.vala"
		g_clear_error (&_inner_error0_);
#line 298 "../src/font-manager/web/google/WebFont.vala"
		_tmp10_ = outdated_file;
#line 298 "../src/font-manager/web/google/WebFont.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 298 "../src/font-manager/web/google/WebFont.vala"
		path = _tmp11_;
#line 299 "../src/font-manager/web/google/WebFont.vala"
		_tmp12_ = path;
#line 299 "../src/font-manager/web/google/WebFont.vala"
		g_warning ("WebFont.vala:299: Failed to remove outdated font file : %s", _tmp12_);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (path);
#line 3106 "WebFont.c"
	}
	__finally0:
#line 291 "../src/font-manager/web/google/WebFont.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (outdated_file);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		g_clear_error (&_inner_error0_);
#line 291 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 3119 "WebFont.c"
	}
#line 301 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (outdated_file);
#line 301 "../src/font-manager/web/google/WebFont.vala"
	return;
#line 3125 "WebFont.c"
}

static void
font_manager_google_fonts_font_on_download_complete (FontManagerGoogleFontsFont* self,
                                                     GObject* source,
                                                     GTask* task)
{
	GError* _inner_error0_ = NULL;
#line 304 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (task != NULL);
#line 3138 "WebFont.c"
	{
		gboolean _tmp0_ = FALSE;
#line 306 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_task_propagate_boolean (task, &_inner_error0_);
#line 306 "../src/font-manager/web/google/WebFont.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3145 "WebFont.c"
			goto __catch0_g_error;
		}
#line 306 "../src/font-manager/web/google/WebFont.vala"
		if (_tmp0_) {
#line 307 "../src/font-manager/web/google/WebFont.vala"
			font_manager_google_fonts_font_remove_outdated_files (self);
#line 3152 "WebFont.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 305 "../src/font-manager/web/google/WebFont.vala"
		e = _inner_error0_;
#line 305 "../src/font-manager/web/google/WebFont.vala"
		_inner_error0_ = NULL;
#line 309 "../src/font-manager/web/google/WebFont.vala"
		_tmp1_ = e;
#line 309 "../src/font-manager/web/google/WebFont.vala"
		_tmp2_ = _tmp1_->message;
#line 309 "../src/font-manager/web/google/WebFont.vala"
		g_warning ("WebFont.vala:309: %s", _tmp2_);
#line 305 "../src/font-manager/web/google/WebFont.vala"
		_g_error_free0 (e);
#line 3173 "WebFont.c"
	}
	__finally0:
#line 305 "../src/font-manager/web/google/WebFont.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "../src/font-manager/web/google/WebFont.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 305 "../src/font-manager/web/google/WebFont.vala"
		g_clear_error (&_inner_error0_);
#line 305 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 3184 "WebFont.c"
	}
#line 311 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify ((GObject*) self, "active");
#line 312 "../src/font-manager/web/google/WebFont.vala"
	return;
#line 3190 "WebFont.c"
}

static void
font_manager_google_fonts_font_download_file (GTask* task,
                                              GObject* source,
                                              void* data,
                                              GCancellable* cancellable)
{
	FontManagerGoogleFontsFont* font = NULL;
	FontManagerGoogleFontsFont* _tmp0_;
	SoupSession* session = NULL;
	SoupSession* _tmp1_;
	gchar* font_dir = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* filename = NULL;
	FontManagerGoogleFontsFont* _tmp10_;
	gchar* _tmp11_;
	gchar* filepath = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	SoupMessage* message = NULL;
	FontManagerGoogleFontsFont* _tmp15_;
	const gchar* _tmp16_;
	SoupMessage* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 315 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (task != NULL);
#line 315 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (source != NULL);
#line 316 "../src/font-manager/web/google/WebFont.vala"
	_vala_assert (FONT_MANAGER_GOOGLE_FONTS_IS_FONT (source), "source is Font");
#line 317 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont));
#line 317 "../src/font-manager/web/google/WebFont.vala"
	font = _tmp0_;
#line 318 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = soup_session_new ();
#line 318 "../src/font-manager/web/google/WebFont.vala"
	session = _tmp1_;
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = font_manager_google_fonts_get_font_directory ();
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = font;
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = _tmp4_->priv->_family;
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = g_build_filename (_tmp3_, _tmp5_, NULL);
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _tmp6_;
#line 319 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp3_);
#line 319 "../src/font-manager/web/google/WebFont.vala"
	font_dir = _tmp7_;
#line 320 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = font_dir;
#line 320 "../src/font-manager/web/google/WebFont.vala"
	if (g_mkdir_with_parents (_tmp8_, 0755) != 0) {
#line 3257 "WebFont.c"
		const gchar* _tmp9_;
#line 321 "../src/font-manager/web/google/WebFont.vala"
		_tmp9_ = font_dir;
#line 321 "../src/font-manager/web/google/WebFont.vala"
		g_warning ("WebFont.vala:321: Failed to create directory : %s", _tmp9_);
#line 322 "../src/font-manager/web/google/WebFont.vala"
		g_task_return_boolean (task, FALSE);
#line 323 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (font_dir);
#line 323 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (session);
#line 323 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (font);
#line 323 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 3273 "WebFont.c"
	}
#line 325 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = font;
#line 325 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = font_manager_google_fonts_font_get_filename (_tmp10_);
#line 325 "../src/font-manager/web/google/WebFont.vala"
	filename = _tmp11_;
#line 326 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = font_dir;
#line 326 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = filename;
#line 326 "../src/font-manager/web/google/WebFont.vala"
	_tmp14_ = g_build_filename (_tmp12_, _tmp13_, NULL);
#line 326 "../src/font-manager/web/google/WebFont.vala"
	filepath = _tmp14_;
#line 327 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = font;
#line 327 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = _tmp15_->priv->_url;
#line 327 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = soup_message_new (FONT_MANAGER_GOOGLE_FONTS_GET, _tmp16_);
#line 327 "../src/font-manager/web/google/WebFont.vala"
	message = _tmp17_;
#line 3297 "WebFont.c"
	{
		GBytes* bytes = NULL;
		SoupSession* _tmp18_;
		SoupMessage* _tmp19_;
		GBytes* _tmp20_;
		GBytes* _tmp21_;
		GBytes* _tmp22_;
		GFile* font_file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFileOutputStream* stream = NULL;
		GFile* _tmp27_;
		GFileOutputStream* _tmp28_;
#line 329 "../src/font-manager/web/google/WebFont.vala"
		_tmp18_ = session;
#line 329 "../src/font-manager/web/google/WebFont.vala"
		_tmp19_ = message;
#line 329 "../src/font-manager/web/google/WebFont.vala"
		_tmp20_ = soup_session_send_and_read (_tmp18_, _tmp19_, NULL, &_inner_error0_);
#line 329 "../src/font-manager/web/google/WebFont.vala"
		bytes = _tmp20_;
#line 329 "../src/font-manager/web/google/WebFont.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3322 "WebFont.c"
			goto __catch0_g_error;
		}
#line 330 "../src/font-manager/web/google/WebFont.vala"
		_tmp21_ = bytes;
#line 330 "../src/font-manager/web/google/WebFont.vala"
		if (_tmp21_ == NULL) {
#line 331 "../src/font-manager/web/google/WebFont.vala"
			g_task_return_boolean (task, FALSE);
#line 3331 "WebFont.c"
		}
#line 332 "../src/font-manager/web/google/WebFont.vala"
		_tmp22_ = bytes;
#line 332 "../src/font-manager/web/google/WebFont.vala"
		g_return_if_fail (_tmp22_ != NULL);
#line 333 "../src/font-manager/web/google/WebFont.vala"
		_tmp23_ = filepath;
#line 333 "../src/font-manager/web/google/WebFont.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 333 "../src/font-manager/web/google/WebFont.vala"
		font_file = _tmp24_;
#line 335 "../src/font-manager/web/google/WebFont.vala"
		_tmp25_ = font_file;
#line 335 "../src/font-manager/web/google/WebFont.vala"
		if (g_file_query_exists (_tmp25_, NULL)) {
#line 3347 "WebFont.c"
			GFile* _tmp26_;
#line 336 "../src/font-manager/web/google/WebFont.vala"
			_tmp26_ = font_file;
#line 336 "../src/font-manager/web/google/WebFont.vala"
			g_file_delete (_tmp26_, NULL, &_inner_error0_);
#line 336 "../src/font-manager/web/google/WebFont.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (font_file);
#line 336 "../src/font-manager/web/google/WebFont.vala"
				_g_bytes_unref0 (bytes);
#line 3359 "WebFont.c"
				goto __catch0_g_error;
			}
		}
#line 337 "../src/font-manager/web/google/WebFont.vala"
		_tmp27_ = font_file;
#line 337 "../src/font-manager/web/google/WebFont.vala"
		_tmp28_ = g_file_create (_tmp27_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 337 "../src/font-manager/web/google/WebFont.vala"
		stream = _tmp28_;
#line 337 "../src/font-manager/web/google/WebFont.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 337 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font_file);
#line 337 "../src/font-manager/web/google/WebFont.vala"
			_g_bytes_unref0 (bytes);
#line 3375 "WebFont.c"
			goto __catch0_g_error;
		}
		{
			GFileOutputStream* _tmp29_;
			GBytes* _tmp30_;
			GFileOutputStream* _tmp31_;
#line 339 "../src/font-manager/web/google/WebFont.vala"
			_tmp29_ = stream;
#line 339 "../src/font-manager/web/google/WebFont.vala"
			_tmp30_ = bytes;
#line 339 "../src/font-manager/web/google/WebFont.vala"
			g_output_stream_write_bytes ((GOutputStream*) _tmp29_, _tmp30_, NULL, &_inner_error0_);
#line 339 "../src/font-manager/web/google/WebFont.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3390 "WebFont.c"
				goto __catch1_g_error;
			}
#line 340 "../src/font-manager/web/google/WebFont.vala"
			_tmp31_ = stream;
#line 340 "../src/font-manager/web/google/WebFont.vala"
			g_output_stream_close ((GOutputStream*) _tmp31_, NULL, &_inner_error0_);
#line 340 "../src/font-manager/web/google/WebFont.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3399 "WebFont.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp32_;
			GError* _tmp33_;
			const gchar* _tmp34_;
#line 338 "../src/font-manager/web/google/WebFont.vala"
			e = _inner_error0_;
#line 338 "../src/font-manager/web/google/WebFont.vala"
			_inner_error0_ = NULL;
#line 342 "../src/font-manager/web/google/WebFont.vala"
			g_task_return_boolean (task, FALSE);
#line 343 "../src/font-manager/web/google/WebFont.vala"
			_tmp32_ = filepath;
#line 343 "../src/font-manager/web/google/WebFont.vala"
			_tmp33_ = e;
#line 343 "../src/font-manager/web/google/WebFont.vala"
			_tmp34_ = _tmp33_->message;
#line 343 "../src/font-manager/web/google/WebFont.vala"
			g_warning ("WebFont.vala:343: Failed to write data to file : %s : %s", _tmp32_, _tmp34_);
#line 338 "../src/font-manager/web/google/WebFont.vala"
			_g_error_free0 (e);
#line 3426 "WebFont.c"
		}
		__finally1:
#line 338 "../src/font-manager/web/google/WebFont.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (stream);
#line 338 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font_file);
#line 338 "../src/font-manager/web/google/WebFont.vala"
			_g_bytes_unref0 (bytes);
#line 3437 "WebFont.c"
			goto __catch0_g_error;
		}
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (stream);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (font_file);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_bytes_unref0 (bytes);
#line 3446 "WebFont.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp35_;
		SoupMessage* _tmp36_;
		guint _tmp37_;
		guint _tmp38_;
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 328 "../src/font-manager/web/google/WebFont.vala"
		e = _inner_error0_;
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_inner_error0_ = NULL;
#line 346 "../src/font-manager/web/google/WebFont.vala"
		g_task_return_boolean (task, FALSE);
#line 347 "../src/font-manager/web/google/WebFont.vala"
		_tmp35_ = filename;
#line 347 "../src/font-manager/web/google/WebFont.vala"
		_tmp36_ = message;
#line 347 "../src/font-manager/web/google/WebFont.vala"
		g_object_get (_tmp36_, "status-code", &_tmp37_, NULL);
#line 347 "../src/font-manager/web/google/WebFont.vala"
		_tmp38_ = _tmp37_;
#line 347 "../src/font-manager/web/google/WebFont.vala"
		_tmp39_ = e;
#line 347 "../src/font-manager/web/google/WebFont.vala"
		_tmp40_ = _tmp39_->message;
#line 347 "../src/font-manager/web/google/WebFont.vala"
		g_warning ("WebFont.vala:347: Failed to read data for : %s :: %i :: %s", _tmp35_, (gint) _tmp38_, _tmp40_);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_error_free0 (e);
#line 3480 "WebFont.c"
	}
	__finally0:
#line 328 "../src/font-manager/web/google/WebFont.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (message);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (filepath);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (filename);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (font_dir);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (session);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (font);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		g_clear_error (&_inner_error0_);
#line 328 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 3503 "WebFont.c"
	}
#line 352 "../src/font-manager/web/google/WebFont.vala"
	g_task_return_boolean (task, TRUE);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (message);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (filepath);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (filename);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (font_dir);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (session);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font);
#line 353 "../src/font-manager/web/google/WebFont.vala"
	return;
#line 3521 "WebFont.c"
}

static void
_font_manager_google_fonts_font_on_download_complete_gasync_ready_callback (GObject* source_object,
                                                                            GTask* task,
                                                                            gpointer self)
{
#line 358 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_on_download_complete ((FontManagerGoogleFontsFont*) self, source_object, task);
#line 358 "../src/font-manager/web/google/WebFont.vala"
	g_object_unref (self);
#line 3533 "WebFont.c"
}

static void
_font_manager_google_fonts_font_download_file_gtask_thread_func (GTask* task,
                                                                 GObject* source_object,
                                                                 void* task_data,
                                                                 GCancellable* cancellable)
{
#line 359 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_download_file (task, source_object, task_data, cancellable);
#line 3544 "WebFont.c"
}

static void
font_manager_google_fonts_font_set_installation_status (FontManagerGoogleFontsFont* self,
                                                        gboolean install)
{
	GError* _inner_error0_ = NULL;
#line 356 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/font-manager/web/google/WebFont.vala"
	if (install) {
#line 3556 "WebFont.c"
		GTask* task = NULL;
		GTask* _tmp0_;
		GTask* _tmp1_;
#line 358 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_task_new ((GObject*) self, NULL, _font_manager_google_fonts_font_on_download_complete_gasync_ready_callback, g_object_ref (self));
#line 358 "../src/font-manager/web/google/WebFont.vala"
		task = _tmp0_;
#line 359 "../src/font-manager/web/google/WebFont.vala"
		_tmp1_ = task;
#line 359 "../src/font-manager/web/google/WebFont.vala"
		g_task_run_in_thread (_tmp1_, _font_manager_google_fonts_font_download_file_gtask_thread_func);
#line 357 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (task);
#line 3570 "WebFont.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 360 "../src/font-manager/web/google/WebFont.vala"
		_tmp2_ = font_manager_google_fonts_font_get_active (self);
#line 360 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = _tmp2_;
#line 360 "../src/font-manager/web/google/WebFont.vala"
		if (_tmp3_) {
#line 3580 "WebFont.c"
			gchar* font_dir = NULL;
			gchar* _tmp4_;
			gchar* file_name = NULL;
			gchar* _tmp5_;
			gchar* target_dir = NULL;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* target_file = NULL;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			GFile* dir = NULL;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* file = NULL;
			const gchar* _tmp14_;
			GFile* _tmp15_;
#line 361 "../src/font-manager/web/google/WebFont.vala"
			_tmp4_ = font_manager_google_fonts_get_font_directory ();
#line 361 "../src/font-manager/web/google/WebFont.vala"
			font_dir = _tmp4_;
#line 362 "../src/font-manager/web/google/WebFont.vala"
			_tmp5_ = font_manager_google_fonts_font_get_filename (self);
#line 362 "../src/font-manager/web/google/WebFont.vala"
			file_name = _tmp5_;
#line 363 "../src/font-manager/web/google/WebFont.vala"
			_tmp6_ = font_dir;
#line 363 "../src/font-manager/web/google/WebFont.vala"
			_tmp7_ = self->priv->_family;
#line 363 "../src/font-manager/web/google/WebFont.vala"
			_tmp8_ = g_build_filename (_tmp6_, _tmp7_, NULL);
#line 363 "../src/font-manager/web/google/WebFont.vala"
			target_dir = _tmp8_;
#line 364 "../src/font-manager/web/google/WebFont.vala"
			_tmp9_ = target_dir;
#line 364 "../src/font-manager/web/google/WebFont.vala"
			_tmp10_ = file_name;
#line 364 "../src/font-manager/web/google/WebFont.vala"
			_tmp11_ = g_build_filename (_tmp9_, _tmp10_, NULL);
#line 364 "../src/font-manager/web/google/WebFont.vala"
			target_file = _tmp11_;
#line 365 "../src/font-manager/web/google/WebFont.vala"
			_tmp12_ = target_dir;
#line 365 "../src/font-manager/web/google/WebFont.vala"
			_tmp13_ = g_file_new_for_path (_tmp12_);
#line 365 "../src/font-manager/web/google/WebFont.vala"
			dir = _tmp13_;
#line 366 "../src/font-manager/web/google/WebFont.vala"
			_tmp14_ = target_file;
#line 366 "../src/font-manager/web/google/WebFont.vala"
			_tmp15_ = g_file_new_for_path (_tmp14_);
#line 366 "../src/font-manager/web/google/WebFont.vala"
			file = _tmp15_;
#line 3635 "WebFont.c"
			{
				gboolean _tmp16_ = FALSE;
				GFile* _tmp17_;
#line 368 "../src/font-manager/web/google/WebFont.vala"
				_tmp17_ = file;
#line 368 "../src/font-manager/web/google/WebFont.vala"
				_tmp16_ = g_file_delete (_tmp17_, NULL, &_inner_error0_);
#line 368 "../src/font-manager/web/google/WebFont.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3645 "WebFont.c"
					goto __catch0_g_error;
				}
#line 368 "../src/font-manager/web/google/WebFont.vala"
				if (_tmp16_) {
#line 3650 "WebFont.c"
					GFile* _tmp18_;
#line 369 "../src/font-manager/web/google/WebFont.vala"
					_tmp18_ = dir;
#line 369 "../src/font-manager/web/google/WebFont.vala"
					font_manager_remove_directory_tree_if_empty (_tmp18_);
#line 3656 "WebFont.c"
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp19_;
#line 367 "../src/font-manager/web/google/WebFont.vala"
				e = _inner_error0_;
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_inner_error0_ = NULL;
#line 371 "../src/font-manager/web/google/WebFont.vala"
				_tmp19_ = e;
#line 371 "../src/font-manager/web/google/WebFont.vala"
				if (_tmp19_->code != G_FILE_ERROR_NOENT) {
#line 3672 "WebFont.c"
					GError* _tmp20_;
					const gchar* _tmp21_;
#line 372 "../src/font-manager/web/google/WebFont.vala"
					_tmp20_ = e;
#line 372 "../src/font-manager/web/google/WebFont.vala"
					_tmp21_ = _tmp20_->message;
#line 372 "../src/font-manager/web/google/WebFont.vala"
					g_warning ("WebFont.vala:372: %s", _tmp21_);
#line 3681 "WebFont.c"
				}
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_error_free0 (e);
#line 3685 "WebFont.c"
			}
			__finally0:
#line 367 "../src/font-manager/web/google/WebFont.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (file);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (dir);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (target_file);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (target_dir);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (file_name);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (font_dir);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				g_clear_error (&_inner_error0_);
#line 367 "../src/font-manager/web/google/WebFont.vala"
				return;
#line 3708 "WebFont.c"
			}
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (file);
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (dir);
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (target_file);
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (target_dir);
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (file_name);
#line 360 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (font_dir);
#line 3722 "WebFont.c"
		}
	}
#line 375 "../src/font-manager/web/google/WebFont.vala"
	return;
#line 3727 "WebFont.c"
}

guint
font_manager_google_fonts_font_get_position (FontManagerGoogleFontsFont* self)
{
	guint result;
#line 200 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 200 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_position;
#line 200 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3740 "WebFont.c"
}

void
font_manager_google_fonts_font_set_position (FontManagerGoogleFontsFont* self,
                                             guint value)
{
	guint old_value;
#line 200 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_position (self);
#line 200 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 200 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_position = value;
#line 200 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY]);
#line 3758 "WebFont.c"
	}
}

gboolean
font_manager_google_fonts_font_get_inconsistent (FontManagerGoogleFontsFont* self)
{
	gboolean result;
#line 201 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 201 "../src/font-manager/web/google/WebFont.vala"
	result = FALSE;
#line 201 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3772 "WebFont.c"
}

gboolean
font_manager_google_fonts_font_get_active (FontManagerGoogleFontsFont* self)
{
	gboolean result;
#line 204 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../src/font-manager/web/google/WebFont.vala"
	result = font_manager_google_fonts_font_get_installation_status (self) != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 205 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3785 "WebFont.c"
}

void
font_manager_google_fonts_font_set_active (FontManagerGoogleFontsFont* self,
                                           gboolean value)
{
#line 207 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_installation_status (self, value);
#line 207 "../src/font-manager/web/google/WebFont.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY]);
#line 3798 "WebFont.c"
}

const gchar*
font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 212 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_family;
#line 212 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 212 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3814 "WebFont.c"
}

void
font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 212 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_family (self);
#line 212 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3828 "WebFont.c"
		gchar* _tmp0_;
#line 212 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 212 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_family);
#line 212 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_family = _tmp0_;
#line 212 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY]);
#line 3838 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 213 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_url;
#line 213 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 213 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3855 "WebFont.c"
}

void
font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 213 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_url (self);
#line 213 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3869 "WebFont.c"
		gchar* _tmp0_;
#line 213 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 213 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_url);
#line 213 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_url = _tmp0_;
#line 213 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY]);
#line 3879 "WebFont.c"
	}
}

gint
font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self)
{
	gint result;
#line 214 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_weight;
#line 214 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3893 "WebFont.c"
}

void
font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                           gint value)
{
	gint old_value;
#line 214 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_weight (self);
#line 214 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 214 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_weight = value;
#line 214 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY]);
#line 3911 "WebFont.c"
	}
}

gboolean
font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self)
{
	gboolean result;
#line 215 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_italic;
#line 215 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3925 "WebFont.c"
}

void
font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                           gboolean value)
{
	gboolean old_value;
#line 215 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_italic (self);
#line 215 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 215 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_italic = value;
#line 215 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY]);
#line 3943 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 216 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 216 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 216 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "italic";
#line 3961 "WebFont.c"
	} else {
#line 216 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "normal";
#line 3965 "WebFont.c"
	}
#line 216 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 216 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3971 "WebFont.c"
}

gint
font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self)
{
	gint result;
#line 217 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 217 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_version;
#line 217 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 3984 "WebFont.c"
}

static void
font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                            gint value)
{
	gint old_value;
#line 217 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_version (self);
#line 217 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 217 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_version = value;
#line 217 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY]);
#line 4002 "WebFont.c"
	}
}

FontManagerStringSet*
font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
#line 218 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 218 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 218 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 4019 "WebFont.c"
}

void
font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                            FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
#line 218 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_subsets (self);
#line 218 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 4033 "WebFont.c"
		FontManagerStringSet* _tmp0_;
#line 218 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 218 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self->priv->_subsets);
#line 218 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_subsets = _tmp0_;
#line 218 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY]);
#line 4043 "WebFont.c"
	}
}

static void
font_manager_google_fonts_font_class_init (FontManagerGoogleFontsFontClass * klass,
                                           gpointer klass_data)
{
#line 196 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_parent_class = g_type_class_peek_parent (klass);
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFont_private_offset);
#line 196 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_font_get_property;
#line 196 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_font_set_property;
#line 196 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_font_finalize;
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY] = g_param_spec_uint ("position", "position", "position", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_INCONSISTENT_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_INCONSISTENT_PROPERTY] = g_param_spec_boolean ("inconsistent", "inconsistent", "inconsistent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY] = g_param_spec_int ("weight", "weight", "weight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY] = g_param_spec_boolean ("italic", "italic", "italic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY] = g_param_spec_string ("style", "style", "style", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 196 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_signals[FONT_MANAGER_GOOGLE_FONTS_FONT_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4083 "WebFont.c"
}

static void
font_manager_google_fonts_font_instance_init (FontManagerGoogleFontsFont * self,
                                              gpointer klass)
{
#line 196 "../src/font-manager/web/google/WebFont.vala"
	self->priv = font_manager_google_fonts_font_get_instance_private (self);
#line 200 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_position = (guint) 0;
#line 217 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_version = 1;
#line 4096 "WebFont.c"
}

static void
font_manager_google_fonts_font_finalize (GObject * obj)
{
	FontManagerGoogleFontsFont * self;
#line 196 "../src/font-manager/web/google/WebFont.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 212 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_family);
#line 213 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_url);
#line 218 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (self->priv->_subsets);
#line 196 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_font_parent_class)->finalize (obj);
#line 4113 "WebFont.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_font_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFontClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_font_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFont), 0, (GInstanceInitFunc) font_manager_google_fonts_font_instance_init, NULL };
	GType font_manager_google_fonts_font_type_id;
	font_manager_google_fonts_font_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFont", &g_define_type_info, 0);
	FontManagerGoogleFontsFont_private_offset = g_type_add_instance_private (font_manager_google_fonts_font_type_id, sizeof (FontManagerGoogleFontsFontPrivate));
	return font_manager_google_fonts_font_type_id;
}

GType
font_manager_google_fonts_font_get_type (void)
{
	static volatile gsize font_manager_google_fonts_font_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_font_type_id__once)) {
		GType font_manager_google_fonts_font_type_id;
		font_manager_google_fonts_font_type_id = font_manager_google_fonts_font_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_font_type_id__once, font_manager_google_fonts_font_type_id);
	}
	return font_manager_google_fonts_font_type_id__once;
}

static void
_vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 196 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_uint (value, font_manager_google_fonts_font_get_position (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_INCONSISTENT_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_font_get_inconsistent (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_font_get_active (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_family (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_url (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_font_get_weight (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_font_get_italic (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_style (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_font_get_version (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_object (value, font_manager_google_fonts_font_get_subsets (self));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 4208 "WebFont.c"
		default:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 4214 "WebFont.c"
	}
}

static void
_vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 196 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_POSITION_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_position (self, g_value_get_uint (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ACTIVE_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_active (self, g_value_get_boolean (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_family (self, g_value_get_string (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_url (self, g_value_get_string (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, g_value_get_int (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_italic (self, g_value_get_boolean (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_version (self, g_value_get_int (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 196 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_subsets (self, g_value_get_object (value));
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 4276 "WebFont.c"
		default:
#line 196 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 196 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 4282 "WebFont.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 60 "../src/font-manager/FontModel.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 4293 "WebFont.c"
		gssize i;
#line 60 "../src/font-manager/FontModel.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 60 "../src/font-manager/FontModel.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 60 "../src/font-manager/FontModel.vala"
				destroy_func (((gpointer*) array)[i]);
#line 4301 "WebFont.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 60 "../src/font-manager/FontModel.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 60 "../src/font-manager/FontModel.vala"
	g_free (array);
#line 4316 "WebFont.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 60 "../src/font-manager/FontModel.vala"
	if (array) {
#line 60 "../src/font-manager/FontModel.vala"
		while (((gpointer*) array)[length]) {
#line 60 "../src/font-manager/FontModel.vala"
			length++;
#line 4330 "WebFont.c"
		}
	}
#line 60 "../src/font-manager/FontModel.vala"
	return length;
#line 4335 "WebFont.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 60 "../src/font-manager/FontModel.vala"
	if (mem && byte_size != 0) {
#line 60 "../src/font-manager/FontModel.vala"
		new_mem = g_malloc (byte_size);
#line 60 "../src/font-manager/FontModel.vala"
		memcpy (new_mem, mem, byte_size);
#line 4349 "WebFont.c"
	} else {
#line 60 "../src/font-manager/FontModel.vala"
		new_mem = NULL;
#line 4353 "WebFont.c"
	}
#line 60 "../src/font-manager/FontModel.vala"
	return new_mem;
#line 4357 "WebFont.c"
}

